package de.elisabetheckstaedt.dipl.GUI;

import javax.swing.JPanel;
import javax.swing.JDialog;
import javax.swing.JTextField;

import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import javax.swing.JButton;

import de.elisabetheckstaedt.dipl.common.Konfiguration;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.awt.Dimension;
import java.awt.Insets;
import java.text.NumberFormat;
import java.text.ParseException;

/**
 * enthlt Abbrechen, Zurck, Weiter, Fertig Button<p>
 * lauscht auf deren Actions, enthlt Schliessen-Methode
 * @author Elisabeth Eckstdt
 *
 */
public abstract class Assistent extends JDialog implements ActionListener {

	private static final long serialVersionUID = 1L;

	private JPanel jContentPane = null;

	private JPanel jPanelNavigation = null;

	protected JPanel jPanelInhalt = null;

	private JButton jButtonAbbrechen = null;

	private JButton jButtonZurueck = null;

	protected JButton jButtonWeiter = null;

	Konfiguration konfiguration = null;

	/**
	 * definiert windowListener, welcher Schliessen() ruft bei Kreuz
	 * @param konfiguration
	 */
	public Assistent(Konfiguration konfiguration) {
		super(konfiguration.hauptfenster);
		this.konfiguration = konfiguration;
		WindowListener WindowListener = new WindowAdapter()
		{
			public void windowClosing(WindowEvent we)
			{
				Schliessen();
			}
		};
		this.addWindowListener(WindowListener);
	}
	
	/**
	 * Abbrechen -> Schliessen(); weiter -> weiter()
	 * @param ae
	 */
	public void actionPerformed(ActionEvent ae)
	{
		Object Quelle = ae.getSource();

		if (Quelle == jButtonAbbrechen)
		{
			Schliessen();
		}
		else if (Quelle == jButtonZurueck)
		{
		}
		else if (Quelle == jButtonWeiter)
		{
			this.setVisible(false);
			weiter();
		}
	}
	/**
	 * = JPanelInhalt + JPAnelNavigation
	 * @return
	 */
	protected JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new GridBagLayout());
			
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
//			gridBagConstraints.gridwidth = 0;
//			gridBagConstraints.ipady = 0;
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 0;
			gridBagConstraints.fill = GridBagConstraints.BOTH;
			jContentPane.add(getJPanelInhalt(), gridBagConstraints);
			
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
//			gridBagConstraints1.gridheight = -1;
//			gridBagConstraints1.ipadx = 0;
			gridBagConstraints1.gridx = 0;
			gridBagConstraints1.gridy = 1;
			gridBagConstraints1.fill = GridBagConstraints.BOTH;
			jContentPane.add(getJPanelNavigation(), gridBagConstraints1);
		}
		return jContentPane;
	}

	protected abstract JPanel getJPanelInhalt();

	/**
	 * This method initializes jPanelNavigation	
	 * 	Abbrechen, zurck, weiter
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelNavigation() {
		if (jPanelNavigation == null) {
			jPanelNavigation = new JPanel();
			jPanelNavigation.setLayout(new GridBagLayout());

			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.insets = new Insets(10, 10, 0, 10);
			gridBagConstraints2.gridx = 0;
			gridBagConstraints2.gridy = 0;
			gridBagConstraints2.fill = GridBagConstraints.BOTH;
			jPanelNavigation.add(getJButtonAbbrechen(), gridBagConstraints2);

			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.insets = new Insets(10, 0, 0, 0);
			gridBagConstraints5.gridx = 1;
			gridBagConstraints5.gridy = 0;
			gridBagConstraints5.fill = GridBagConstraints.BOTH;
			jPanelNavigation.add(getJButtonZurueck(), gridBagConstraints5);
			
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.insets = new Insets(10, 10, 0, 10);
			gridBagConstraints4.gridx = 2;
			gridBagConstraints4.gridy = 0;
			gridBagConstraints4.fill = GridBagConstraints.BOTH;
			jPanelNavigation.add(getJButtonWeiter(), gridBagConstraints4);
			
		}
		return jPanelNavigation;
	}

	/**
	 * This method initializes jButtonAbbrechen	
	 * 	mit Action LIstener
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonAbbrechen() {
		if (jButtonAbbrechen == null) {
			jButtonAbbrechen = new JButton();
			jButtonAbbrechen.setText("Abbrechen");
			jButtonAbbrechen.setPreferredSize(new Dimension(100, 26));
			jButtonAbbrechen.addActionListener(this);
		}
		return jButtonAbbrechen;
	}

	/**
	 * This method initializes jButtonZurueck	
	 * 	mit Action Listener
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonZurueck() {
		if (jButtonZurueck == null) {
			jButtonZurueck = new JButton();
			jButtonZurueck.setText("< Zurck");
			jButtonZurueck.setPreferredSize(new Dimension(100, 26));
			jButtonZurueck.setEnabled(false);
			jButtonZurueck.addActionListener(this);
		}
		return jButtonZurueck;
	}

	/**
	 * This method initializes jButtonWeiter	
	 * 	mit Action Listener
	 * @return javax.swing.JButton	
	 */
	protected JButton getJButtonWeiter() {
		if (jButtonWeiter == null) {
			jButtonWeiter = new JButton();
			jButtonWeiter.setText("Weiter >");
			jButtonWeiter.setPreferredSize(new Dimension(100, 26));
			jButtonWeiter.addActionListener(this);
		}
		return jButtonWeiter;
	}

	/**
	 * set invisible
	 */
	void Schliessen()
	{
		this.setVisible(false);
	}
	/**
	 * was soll bei Klick auf Weiterbutton passieren
	 */
	protected abstract void weiter();
	
	/**
	 * @param textfeld
	 * @return Textfeldinhalt als double
	 * Dezimaltrennzeichen KOmma
	 */
	protected double einlesen(JTextField textfeld)
	{
		double wert = 0;
		NumberFormat nf = NumberFormat.getInstance();
		try {
			wert = nf.parse(textfeld.getText()).doubleValue();
		} catch (ParseException e) {
			e.printStackTrace();
		}
		return wert;
	}

}
