package de.elisabetheckstaedt.dipl.GUI;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

import de.elisabetheckstaedt.dipl.common.Konfiguration;

/**
 * Auswahl der Anzahl der Subnetze fr eine KZ
 * @author Elisabeth Eckstdt
 *
 */
public class F_3_SN_Zahl extends Assistent implements ActionListener{

	private static final long serialVersionUID = 1L;
//	public F_4_SN_Zuordnung f_TN_Zuordnung;
	int gesamtzahl;

	private JRadioButton jRadioButtonEins = null;

	private JRadioButton jRadioButtonN = null;

	private JRadioButton jRadioButtonZahl = null;

	private JTextField jTextFieldAnzahl = null;

	private JLabel jLabelAnweisung = null;

	protected JLabel jLabelBeschreibung = null;

	int kznummer = 0;

/**
 * @param konfiguration
 * @param kznummer
 * @param gesamtzahl
 */
public F_3_SN_Zahl(Konfiguration konfiguration, int kznummer, int gesamtzahl) {
	
		super(konfiguration);
		this.gesamtzahl = gesamtzahl;
		this.kznummer = kznummer;
		initialize();
		this.setVisible(true);
	}

	/**
 * This method initializes this
 * 
 * @return void
 */
private void initialize() {
	this.setTitle("DC/DEsign - II - Zahl der Subnetze fr Teilsystem " + kznummer);
	this.setSize(new Dimension(400, 200));
	this.setContentPane(getJContentPane());
}

	public void actionPerformed(ActionEvent ae)
	{
		super.actionPerformed(ae);
		Object Quelle = ae.getSource();
		if (Quelle == jTextFieldAnzahl)
		{
			jRadioButtonZahl.setSelected(true);
		}
	}
	public void weiter() {
		int Anzahl = 0;
		if (jRadioButtonEins.isSelected())
			Anzahl = 1;
		else if (jRadioButtonN.isSelected())
			Anzahl = gesamtzahl;
		else
			Anzahl = Integer.valueOf(jTextFieldAnzahl.getText()).intValue();
		konfiguration.tn_zuordnen(Anzahl, kznummer);
	}
	
	protected JPanel getJPanelInhalt() {
			if (jPanelInhalt == null) {
				jPanelInhalt = new JPanel();
				jPanelInhalt.setLayout(new GridBagLayout());
	
				jLabelBeschreibung = new JLabel();
				jLabelBeschreibung.setText("Bitte whlen sie, wieviele Subnetze zum Teilsystem " + kznummer + " erstellt " +
						"werden sollen.");
				GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
				gridBagConstraints4.gridx = 0;
				gridBagConstraints4.gridwidth = 2;
				gridBagConstraints4.gridy = 0;
				gridBagConstraints4.fill = GridBagConstraints.BOTH;
				gridBagConstraints4.anchor = GridBagConstraints.WEST;
				jPanelInhalt.add(jLabelBeschreibung, gridBagConstraints4);
				
				GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
				gridBagConstraints5.gridx = 0;
				gridBagConstraints5.gridwidth = 2;
				gridBagConstraints5.gridy = 1;
				gridBagConstraints5.anchor = GridBagConstraints.WEST;
				jPanelInhalt.add(getJRadioButtonEins(), gridBagConstraints5);
				
				GridBagConstraints gridBagConstraints = new GridBagConstraints();
				gridBagConstraints.gridx = 0;
				gridBagConstraints.gridwidth = 2;
				gridBagConstraints.gridy = 2;
				gridBagConstraints.anchor = GridBagConstraints.WEST;
				jPanelInhalt.add(getJRadioButtonN(), gridBagConstraints);
				
				GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
				gridBagConstraints1.gridx = 0;
				gridBagConstraints1.gridwidth = 2;
				gridBagConstraints1.gridy = 3;
				gridBagConstraints1.anchor = GridBagConstraints.WEST;
				jPanelInhalt.add(getJRadioButtonZahl(), gridBagConstraints1);
				
				ButtonGroup group = new ButtonGroup();
				group.add(jRadioButtonEins);
				group.add(jRadioButtonN);
				group.add(jRadioButtonZahl);
				
				jLabelAnweisung = new JLabel();
				jLabelAnweisung.setText("Ganzzahl zwischen 1 und " + gesamtzahl + " eingeben");
				GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
				gridBagConstraints3.gridx = 0;
				gridBagConstraints3.gridy = 4;
				gridBagConstraints3.anchor = GridBagConstraints.WEST;
				gridBagConstraints3.insets = new Insets(0, 40, 0, 0);
				jPanelInhalt.add(jLabelAnweisung, gridBagConstraints3);
	
				GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
	//			gridBagConstraints2.fill = GridBagConstraints.BOTH;
				gridBagConstraints2.gridx = 0;
				gridBagConstraints2.gridwidth = 1;
				gridBagConstraints2.gridy = 5;
				gridBagConstraints2.anchor = GridBagConstraints.WEST;
				gridBagConstraints2.insets = new Insets(0, 40, 0, 0);
				jPanelInhalt.add(getJTextFieldAnzahl(), gridBagConstraints2);
			}
			return jPanelInhalt;
		}

	private JRadioButton getJRadioButtonEins() {
		if (jRadioButtonEins == null) {
			jRadioButtonEins = new JRadioButton();
			jRadioButtonEins.setText("1");
			jRadioButtonEins.setSelected(true);
		}
		return jRadioButtonEins;
	}

	/**
	 * This method initializes jRadioButtonN	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonN() {
		if (jRadioButtonN == null) {
			jRadioButtonN = new JRadioButton();
			jRadioButtonN.setText((new Integer(gesamtzahl)).toString());
		}
		return jRadioButtonN;
	}

	/**
	 * This method initializes jRadioButtonZahl	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonZahl() {
		if (jRadioButtonZahl == null) {
			jRadioButtonZahl = new JRadioButton();
			jRadioButtonZahl.setText("beliebige Zahl");
		}
		return jRadioButtonZahl;
	}


	/**
	 * This method initializes jTextFieldAnzahl	
	 * 	
	 * @return javax.swing.JTextField	
	 */

	private JTextField getJTextFieldAnzahl() {
		if (jTextFieldAnzahl == null) {
			jTextFieldAnzahl = new JTextField(3);
			int vorschlag = gesamtzahl / 2;
			jTextFieldAnzahl.setText((new Integer(vorschlag)).toString());
		}
		return jTextFieldAnzahl;
	}

}
