package de.elisabetheckstaedt.dipl.GUI;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

import de.elisabetheckstaedt.dipl.common.Konfiguration;
import de.elisabetheckstaedt.dipl.real.Verbraucher;

/**
 * Fenster zur Zuordnung der einzelnen Verbraucher auf die vorgegebenen Subnetze
 * @author Elisabeth Eckstdt
 *
 */
public class F_4_SN_Zuordnung extends Assistent{
	
	private static final long serialVersionUID = 1L;

	public JTextField[] jTextFieldKZ = null;
	JLabel[] labelVer = null;
	JRadioButton[][] radios = null;

	public Verbraucher[][] verbraucher_kzs = null;
	Verbraucher[] verbraucher = null;
	public String[] namen_kzs = null;
	String kzname;
	int kznummer = 0;
	String typ = "";
	
	public F_4_SN_Zuordnung(Konfiguration konfiguration, int neue, int kznummer, Verbraucher[] verbraucher, String kzname) {
		super(konfiguration);
		this.kznummer = kznummer;
		this.verbraucher = verbraucher;
		this.kzname = kzname;
		jTextFieldKZ = new JTextField[neue];
		labelVer = new JLabel[verbraucher.length];
		radios = new JRadioButton[verbraucher.length][neue];
		typ = "Subnetz";
		verbraucher_kzs = new Verbraucher[neue][];
		namen_kzs = new String[neue];
		initialize();
	}
	
	private void initialize() {
		this.setTitle("DC/DEsign - II - Zuordnung zu Subnetzen des Teilsystems " + kznummer);
		int breite = namen_kzs.length * 15 + 80;
		if (breite < 400)
		{
			breite = 400;
		}
		this.setSize(breite, verbraucher.length * 20 + 140);
		this.setContentPane(getJContentPane());
	}
	

	/**
	 * This method initializes jPanelInhalt	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	protected JPanel getJPanelInhalt() {
		if (jPanelInhalt == null) {
			jPanelInhalt = new JPanel();
			jPanelInhalt.setLayout(new GridBagLayout());
			GridBagConstraints[] gbc_jTextFieldKZ = new GridBagConstraints[jTextFieldKZ.length];
			GridBagConstraints[] gbc_labelVer = new GridBagConstraints[labelVer.length];
			GridBagConstraints[][] gbc_radio = new GridBagConstraints[labelVer.length][jTextFieldKZ.length];
			for (int j=0; j<jTextFieldKZ.length; j++)
			{
				jTextFieldKZ[j] = new JTextField(15);
				jTextFieldKZ[j].setText(kzname + " SN " + j);
				gbc_jTextFieldKZ[j] = new GridBagConstraints();
				gbc_jTextFieldKZ[j].gridx = j+1;
				gbc_jTextFieldKZ[j].gridy = 0;
				gbc_jTextFieldKZ[j].fill = GridBagConstraints.BOTH;
				jPanelInhalt.add(jTextFieldKZ[j],gbc_jTextFieldKZ[j]);
			}
			for (int i=0; i<labelVer.length; i++)
			{
				labelVer[i] = new JLabel();
				labelVer[i].setText(verbraucher[i].getName());
				gbc_labelVer[i] = new GridBagConstraints();
				gbc_labelVer[i].gridx = 0;
				gbc_labelVer[i].gridy = i+1;
				gbc_labelVer[i].fill = GridBagConstraints.BOTH;
				jPanelInhalt.add(labelVer[i],gbc_labelVer[i]);
			}
			ButtonGroup[] gruppen = new ButtonGroup[labelVer.length];
			for (int i=0; i<labelVer.length; i++)
			{
				gruppen[i] = new ButtonGroup();
				for (int j=0; j<jTextFieldKZ.length; j++)
				{
					radios[i][j] = new JRadioButton("          ");
					gbc_radio[i][j] = new GridBagConstraints();
					gbc_radio[i][j].gridx = j+1;
					gbc_radio[i][j].gridy = i+1;
					gruppen[i].add(radios[i][j]);
					jPanelInhalt.add(radios[i][j],gbc_radio[i][j]);
					if (jTextFieldKZ.length == labelVer.length) //so viele KZ wie Verbraucher
					{
						if (i == j)
						{
							radios[i][j].setSelected(true);
						}
					}
					else
						if (j == 0)
						{
							radios[i][j].setSelected(true);
						}
				}
				
			}
		}
		return jPanelInhalt;
	}

	protected void weiter() {
		for (int j=0; j<jTextFieldKZ.length; j++)
		{
			int h = 0;
			for (int i=0; i<labelVer.length; i++)
			{
				if(radios[i][j].isSelected())
				{
					h++;
				}
			}
			Verbraucher[] verbraucherj = new Verbraucher[h];
			h = 0;
			for (int i=0; i<labelVer.length; i++)
			{
				if(radios[i][j].isSelected())
				{
					verbraucherj[h] = (Verbraucher) verbraucher[i];
					h++;
				}
			}
			
			verbraucher_kzs[j] = verbraucherj;
			namen_kzs[j] = jTextFieldKZ[j].getText();
		}
		konfiguration.km_anzahl(kznummer, verbraucher_kzs);
	}
//	protected JPanel getJPanelInhalt() {
//		if (jPanelInhalt == null) {
//			jPanelInhalt = new JPanel();
//			jPanelInhalt.setLayout(new GridBagLayout());
//
//			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
//			gridBagConstraints7.gridx = 0;
//			gridBagConstraints7.gridy = 0;
//			jPanelInhalt.add(getJPanelVerteilung(), gridBagConstraints7);
//			
//			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
//			gridBagConstraints12.gridx = 0;
//			gridBagConstraints12.gridy = verbraucher.length + 1;
//			jPanelInhalt.add(getJButtonWeiter(), gridBagConstraints12);
////			
////			GridBagConstraints gridBagConstraints13 = new GridBagConstraints();
////			gridBagConstraints13.gridx = 1;
////			gridBagConstraints13.gridy = verbraucher.length + 1;
////			jPanelInhalt.add(getJButtonAbbrechen(), gridBagConstraints13);
////			
////			GridBagConstraints gridBagConstraints14 = new GridBagConstraints();
////			gridBagConstraints14.gridx = 2;
////			gridBagConstraints14.gridy = verbraucher.length + 1;
////			jPanelInhalt.add(getJButtonUebernehmen(),gridBagConstraints14);
//		}
//		return jPanelInhalt;
//	}

}
