package de.elisabetheckstaedt.dipl.GUI;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Arrays;

import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.SwingConstants;

import de.elisabetheckstaedt.dipl.common.Helper;
import de.elisabetheckstaedt.dipl.common.Konfiguration;

/**
 * Fenster zur Festlegung der Anzahl der Kltemaschinen fr eine KZ und ggf. Aufteilung der Nennleistungen
 * @author Elisabeth Eckstdt
 *
 */
public class F_5_KM_Zahl extends Assistent implements ActionListener{
	
	private static final long serialVersionUID = 1L;

	private JRadioButton jRadioButtonEine = null;

	private JRadioButton jRadioButtonZwei = null;

	private JLabel jLabelAnleitung = null;

	private JRadioButton jRadioButtonSpitzenlastanteil = null;

	private JRadioButton jRadioButtonLaufzeitanteil = null;

	private JRadioButton jRadioButtonEnergieanteil = null;

	private JTextField jTextFieldSpitzenlastanteil = null;

	private JTextField jTextFieldLaufzeitanteil = null;

	private JTextField jTextFieldEnergieanteil = null;

	private JLabel jLabelProzent = null;
	int kznummer = 0;
	public int anzahl = 0;
	double[] geordneter_lastgang;
	double[] kaelteleistung;
	public double[] maschinenleistungen;

	public JTextField jTextFieldNennleistung0 = null;

	private JLabel jLabelNennleistung = null;

	private JLabel jLabelNennleistung1 = null;

	private JLabel jLabelVollberiebsstunden = null;

	private JTextField jTextFieldVollbetriebsstunden0 = null;

	private JTextField jTextFieldVollbetriebsstunden1 = null;

	private JTextField jTextFieldNennleistung1 = null;

	/**
	 * @param owner
	 */
	public F_5_KM_Zahl(Konfiguration konfiguration, int kznummer, double[] kaelteleistung) {
		super(konfiguration);
		this.kaelteleistung = kaelteleistung;
		this.kznummer = kznummer;
		Arrays.sort(kaelteleistung); //aufsteigend
		geordneter_lastgang = Helper.reverse(kaelteleistung);
		initialize();
		this.setVisible(true);
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setTitle("DC/DEsign - II - Zahl und Leistungsaufteilung der Kltemaschinen fr Teilsystem " + kznummer);
		this.setSize(500,250);
		this.setContentPane(getJContentPane());
	}

	protected void weiter()
	{
		double spitzenlast = geordneter_lastgang[0];
		String[] name = new String[2];  //TODO bisher maximal 2 KM im Auswahlfenster (auch nchste Zeile)
		maschinenleistungen = new double[2];
		maschinenleistungen[0] = einlesen(jTextFieldNennleistung0);
		double[][] LA;
		if (jRadioButtonZwei.isSelected())
		{
			LA = new double[2][8760];
			anzahl = 2;
			name[0] = "Grundlastmaschine Teilsystem " + kznummer;
			maschinenleistungen[1] = spitzenlast - maschinenleistungen[0];
			name[1] = "Spitzenlastmaschine Teilsystem " + kznummer;
			double[] LAGlM = new double[8760];
			double[] LASlM = new double[8760];
			for (int i=0; i<8760; i++) //TODO Speicherentladung hat auch einen Leistungsanteil
			{
				if (kaelteleistung[i]<maschinenleistungen[0])
				{
					LASlM[i] = 0;
					LAGlM[i] = 1;
				}
				else
				{
					LAGlM[i] = maschinenleistungen[0]/kaelteleistung[i];
					LASlM[i] = 1 - LAGlM[i];
					if (LASlM[i] * kaelteleistung[i] > maschinenleistungen[1])
					{
						LASlM[i] =  maschinenleistungen[1]/kaelteleistung[i];
					}
				}
			}
			LA[0] = LAGlM;
			LA[1] = LASlM;
		}
		else
		{
			maschinenleistungen = new double[1];
			maschinenleistungen[0] = spitzenlast;
			LA = new double[1][8760];
			double[] LAKM = new double[8760];
			Arrays.fill(LAKM, 1);
			LA[0] = LAKM;
			anzahl = 1;
			name[0] = "Kltemaschine Teilsystem " + kznummer;
		}
		konfiguration.km_anzahl_fertig(kznummer, anzahl, LA, maschinenleistungen);
		for (int i=0; i<anzahl; i++)
		{
			konfiguration.f_km_spez[kznummer][0] = new F_6_KM_Spez(name[i],maschinenleistungen[i],konfiguration, kznummer, i);
			konfiguration.f_km_spez[kznummer][0].setVisible(true);
		}
	}

	public void actionPerformed(ActionEvent ae)
	{
		super.actionPerformed(ae);
		Object Quelle = ae.getSource();
		double spitzenlast = geordneter_lastgang[0];
		if (Quelle == jRadioButtonEine)
		{
			jTextFieldNennleistung0.setText(Helper.Zahlformat(spitzenlast, 0));
			aktualisieren();
			jRadioButtonEnergieanteil.setEnabled(false);
			jRadioButtonLaufzeitanteil.setEnabled(false);
			jRadioButtonSpitzenlastanteil.setEnabled(false);
			jTextFieldEnergieanteil.setEnabled(false);
			jTextFieldLaufzeitanteil.setEnabled(false);
			jTextFieldSpitzenlastanteil.setEnabled(false);
		}
		else if (Quelle == jRadioButtonZwei)
		{
			jRadioButtonEnergieanteil.setEnabled(true);
			jRadioButtonLaufzeitanteil.setEnabled(true);
			jRadioButtonSpitzenlastanteil.setEnabled(true);
			if (jRadioButtonEnergieanteil.isSelected())
			{
				jTextFieldEnergieanteil.setEnabled(true);
			}
			else if (jRadioButtonLaufzeitanteil.isSelected())
			{
				jTextFieldLaufzeitanteil.setEnabled(true);
				int laufzeit = new Double((100 - Double.valueOf(jTextFieldLaufzeitanteil.getText()).doubleValue()) /100 * 8760).intValue();
				jTextFieldNennleistung0.setText(Helper.Zahlformat(geordneter_lastgang[laufzeit],0));
			}
			else if (jRadioButtonSpitzenlastanteil.isSelected())
			{
				jTextFieldSpitzenlastanteil.setEnabled(true);
				jTextFieldNennleistung0.setText(Helper.Zahlformat(
					spitzenlast * einlesen(jTextFieldSpitzenlastanteil) / 100
					,0));
			}
			aktualisieren();
		}
		else if (Quelle == jRadioButtonSpitzenlastanteil)
		{
			jTextFieldSpitzenlastanteil.setEnabled(true);
			jTextFieldLaufzeitanteil.setEnabled(false);
			jTextFieldEnergieanteil.setEnabled(false);
			jTextFieldNennleistung0.setText(Helper.Zahlformat(
					spitzenlast * einlesen(jTextFieldSpitzenlastanteil) / 100
					,0));
			aktualisieren();
		}
		else if (Quelle == jRadioButtonLaufzeitanteil)
		{
			jTextFieldSpitzenlastanteil.setEnabled(false);
			jTextFieldLaufzeitanteil.setEnabled(true);
			jTextFieldEnergieanteil.setEnabled(false);
			int laufzeit = new Double((100 - Double.valueOf(jTextFieldLaufzeitanteil.getText()).doubleValue()) /100 * 8760).intValue();
			jTextFieldNennleistung0.setText(Helper.Zahlformat(geordneter_lastgang[laufzeit],0));
			aktualisieren();
		}
		else if (Quelle == jRadioButtonEnergieanteil)
		{
			jTextFieldSpitzenlastanteil.setEnabled(false);
			jTextFieldLaufzeitanteil.setEnabled(false);
			jTextFieldEnergieanteil.setEnabled(true);
			jTextFieldNennleistung0.setText(Helper.Zahlformat(Energieanteil(), 0));
			aktualisieren();
		}
		else if (Quelle == jTextFieldSpitzenlastanteil)
		{
			jTextFieldNennleistung0.setText(Helper.Zahlformat(
					spitzenlast * einlesen(jTextFieldSpitzenlastanteil) / 100
							,0));
			aktualisieren();
		}
		else if (Quelle == jTextFieldLaufzeitanteil)
		{
			int laufzeit = new Double((100 - Double.valueOf(jTextFieldLaufzeitanteil.getText()).doubleValue()) /100 * 8760).intValue();
			jTextFieldNennleistung0.setText(Helper.Zahlformat(geordneter_lastgang[laufzeit],0));
			aktualisieren();
		}
		else if (Quelle == jTextFieldEnergieanteil)
		{
			jTextFieldNennleistung0.setText(Helper.Zahlformat(Energieanteil(), 0));
			aktualisieren();
		}
		else if (Quelle == jTextFieldNennleistung0)
		{
			aktualisieren();
		}
	}

	private void aktualisieren()
	{
		double spitzenlast = geordneter_lastgang[0];
		double[] geordneter_lastgang_aufsteigend = Helper.reverse(geordneter_lastgang); 
		double[] kaelteenergie_cumsum = new double[8760];
		kaelteenergie_cumsum[0] = geordneter_lastgang_aufsteigend[0];
		double summe0 = 0; //aufsummiert Grundlastmaschinen
		double summe1 = 0; //SLM
		double grundnennlast = einlesen(jTextFieldNennleistung0);
		for (int i=1; i<8760; i++)
		{
			kaelteenergie_cumsum[i] = kaelteenergie_cumsum[i-1] + geordneter_lastgang_aufsteigend[i];
			if (geordneter_lastgang_aufsteigend[i] < grundnennlast)
			{
				summe0 = summe0 + geordneter_lastgang_aufsteigend[i];
			}
			else
			{
				summe0 = summe0 + grundnennlast;
				summe1 = summe1 + (geordneter_lastgang_aufsteigend[i] - grundnennlast);
			}
		}
		double vollbetriebsstunden0 = summe0 / grundnennlast;
		double vollbetriebsstunden1 = summe1 /(spitzenlast - grundnennlast);
		jTextFieldNennleistung1.setText(Helper.Zahlformat(spitzenlast-grundnennlast, 0));
		jTextFieldVollbetriebsstunden0.setText(Helper.Zahlformat(vollbetriebsstunden0, 0));
		jTextFieldVollbetriebsstunden1.setText(Helper.Zahlformat(vollbetriebsstunden1, 0));
	}

	/**
	 * @return Nennleistung der Grundlastmaschine
	 */
	private double Energieanteil()
	{
		double grundnennleistung = 0;
		double[] geordneter_lastgang_aufsteigend = Helper.reverse(geordneter_lastgang); 
		double[] kaelteenergie_cumsum = new double[8760];
		kaelteenergie_cumsum[0] = geordneter_lastgang_aufsteigend[0];
		for (int i=1; i<8760; i++)
		{
			kaelteenergie_cumsum[i] = kaelteenergie_cumsum[i-1] + geordneter_lastgang_aufsteigend[i];
		}
		double jahressumme = kaelteenergie_cumsum[8759];
		double Anteil = einlesen(jTextFieldEnergieanteil) / 100;
		double energieanteil = jahressumme * Anteil;
		int i = 0;
		double EM = 0;
		while (EM < energieanteil)
		{
			grundnennleistung = geordneter_lastgang_aufsteigend[i];
			EM = kaelteenergie_cumsum[i] + (8760 - i) * grundnennleistung;
			i++;
		}
		return grundnennleistung;
	}

	/**
	 * This method initializes jPanelInhalt
	 * 
	 * @return javax.swing.JPanel
	 */
	protected JPanel getJPanelInhalt() {
		if (jPanelInhalt == null) {
			
			jPanelInhalt = new JPanel();
			jPanelInhalt.setLayout(new GridBagLayout());
			
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.gridx = 0;
			gridBagConstraints3.gridy = 0;
			gridBagConstraints3.gridwidth = 4;
			gridBagConstraints3.fill = GridBagConstraints.BOTH;
			jLabelAnleitung = new JLabel();
			jLabelAnleitung.setText("Wieviele Kltemaschinen mchten sie fr das " + kznummer + ". Teilsystem anlegen?");
			jPanelInhalt.add(jLabelAnleitung, gridBagConstraints3);
			
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 1;
//			gridBagConstraints.gridwidth = 1;
			gridBagConstraints.anchor = GridBagConstraints.WEST;
			jPanelInhalt.add(getJRadioButtonEine(), gridBagConstraints);
			
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 0;
			gridBagConstraints2.gridy = 2;
//			gridBagConstraints2.gridwidth = 1;
			gridBagConstraints2.anchor = GridBagConstraints.WEST;
			jPanelInhalt.add(getJRadioButtonZwei(), gridBagConstraints2);

			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.insets = new Insets(0, 50, 0, 0);
			gridBagConstraints11.gridx = 0;
			gridBagConstraints11.gridy = 3;
			gridBagConstraints11.anchor = GridBagConstraints.WEST;
			jPanelInhalt.add(getJRadioButtonSpitzenlastanteil(), gridBagConstraints11);
			
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.gridx = 1;
			gridBagConstraints4.gridy = 3;
			gridBagConstraints4.fill = GridBagConstraints.BOTH;
			gridBagConstraints4.weightx = 1.0;
			jPanelInhalt.add(getJTextFieldSpitzenlastanteil(), gridBagConstraints4);
			
			GridBagConstraints gridBagConstraints71 = new GridBagConstraints();
			gridBagConstraints71.gridx = 3;
			gridBagConstraints71.gridy = 3;
			jLabelProzent = new JLabel();
			jLabelProzent.setText("[%]");
			jPanelInhalt.add(jLabelProzent, gridBagConstraints71);

			GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
			gridBagConstraints21.insets = new Insets(0, 50, 0, 0);
			gridBagConstraints21.gridx = 0;
			gridBagConstraints21.gridy = 4;
			gridBagConstraints21.anchor = GridBagConstraints.WEST;
			jPanelInhalt.add(getJRadioButtonLaufzeitanteil(), gridBagConstraints21);
			
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.gridx = 1;
			gridBagConstraints5.gridy = 4;
//			gridBagConstraints5.weightx = 1.0;
			gridBagConstraints5.fill = GridBagConstraints.BOTH;
			jPanelInhalt.add(getJTextFieldLaufzeitanteil(), gridBagConstraints5);
			
			GridBagConstraints gridBagConstraints72 = new GridBagConstraints();
			gridBagConstraints72.gridx = 4;
			gridBagConstraints72.gridy = 4;
			jPanelInhalt.add(jLabelProzent, gridBagConstraints72);
			
			GridBagConstraints gridBagConstraints31 = new GridBagConstraints();
			gridBagConstraints31.insets = new Insets(0, 50, 0, 0);
			gridBagConstraints31.gridx = 0;
			gridBagConstraints31.gridy = 5;
			gridBagConstraints31.anchor = GridBagConstraints.WEST;
			jPanelInhalt.add(getJRadioButtonEnergieanteil(), gridBagConstraints31);
			
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.gridx = 1;
			gridBagConstraints6.gridy = 5;
//			gridBagConstraints6.weightx = 1.0;
			gridBagConstraints6.fill = GridBagConstraints.BOTH;
			jPanelInhalt.add(getJTextFieldEnergieanteil(), gridBagConstraints6);

			GridBagConstraints gridBagConstraints73 = new GridBagConstraints();
			gridBagConstraints73.gridx = 2;
			gridBagConstraints73.gridy = 5;
			gridBagConstraints73.anchor = GridBagConstraints.WEST;
			jPanelInhalt.add(jLabelProzent, gridBagConstraints73);
			
			GridBagConstraints gridBagConstraints22 = new GridBagConstraints();
			gridBagConstraints22.insets = new Insets(0,0 , 0, 5);
			gridBagConstraints22.gridx = 0;
			gridBagConstraints22.gridy = 7;
			gridBagConstraints22.anchor = GridBagConstraints.WEST;
			jLabelNennleistung = new JLabel();
			jLabelNennleistung.setText("Nennleistung Maschine 0 (Grundlast)  [kW]");
			jPanelInhalt.add(jLabelNennleistung, gridBagConstraints22);
			
			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			gridBagConstraints12.gridx = 1;
			gridBagConstraints12.gridy = 7;
//			gridBagConstraints12.weightx = 1.0;
			gridBagConstraints12.fill = GridBagConstraints.BOTH;
			jPanelInhalt.add(getJTextFieldNennleistung0(), gridBagConstraints12);
			
			GridBagConstraints gridBagConstraints23 = new GridBagConstraints();
			gridBagConstraints23.gridx = 2;
			gridBagConstraints23.gridy = 7;
			jLabelVollberiebsstunden = new JLabel();
			jLabelVollberiebsstunden.setText("Vollbetriebsstunden");
			jPanelInhalt.add(jLabelVollberiebsstunden, gridBagConstraints23);
			
			GridBagConstraints gridBagConstraints32 = new GridBagConstraints();
			gridBagConstraints32.gridx = 3;
			gridBagConstraints32.gridy = 7;
//			gridBagConstraints32.weightx = 1.0;
			gridBagConstraints32.fill = GridBagConstraints.BOTH;
			jPanelInhalt.add(getJTextFieldVollbetriebsstunden0(), gridBagConstraints32);
			
			GridBagConstraints gridBagConstraints13 = new GridBagConstraints();
			gridBagConstraints13.insets = new Insets(0,0 , 0, 5);
			gridBagConstraints13.gridx = 0;
			gridBagConstraints13.gridy = 8;
			gridBagConstraints13.anchor = GridBagConstraints.WEST;
			jLabelNennleistung1 = new JLabel();
			jLabelNennleistung1.setText("Nennleistung Maschine 1 (Spitzenlast) [kW]");
			jPanelInhalt.add(jLabelNennleistung1, gridBagConstraints13);

			GridBagConstraints gridBagConstraints51 = new GridBagConstraints();
			gridBagConstraints51.gridx = 1;
			gridBagConstraints51.gridy = 8;
//			gridBagConstraints51.weightx = 1.0;
			gridBagConstraints51.fill = GridBagConstraints.BOTH;
			jPanelInhalt.add(getJTextFieldNennleistung1(), gridBagConstraints51);
			
			GridBagConstraints gridBagConstraints41 = new GridBagConstraints();
			gridBagConstraints41.gridx = 3;
			gridBagConstraints41.gridy = 8;
//			gridBagConstraints41.weightx = 1.0;
			gridBagConstraints41.fill = GridBagConstraints.BOTH;
			jPanelInhalt.add(getJTextFieldVollbetriebsstunden1(), gridBagConstraints41);
			
			ButtonGroup buttonGroupAnzahl = new ButtonGroup();
			buttonGroupAnzahl.add(getJRadioButtonEine());
			buttonGroupAnzahl.add(getJRadioButtonZwei());
			
			ButtonGroup buttonGroupKriterium = new ButtonGroup();
			buttonGroupKriterium.add(getJRadioButtonSpitzenlastanteil());
			buttonGroupKriterium.add(getJRadioButtonLaufzeitanteil());
			buttonGroupKriterium.add(getJRadioButtonEnergieanteil());
		}
		return jPanelInhalt;
	}

	/**
	 * This method initializes jRadioButtonEine	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonEine() {
		if (jRadioButtonEine == null) {
			jRadioButtonEine = new JRadioButton();
			jRadioButtonEine.setText("Eine");
			jRadioButtonEine.setHorizontalTextPosition(SwingConstants.RIGHT);
			jRadioButtonEine.setHorizontalAlignment(SwingConstants.LEFT);
			jRadioButtonEine.addActionListener(this);
		}
		return jRadioButtonEine;
	}

	/**
	 * This method initializes jRadioButtonZwei	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonZwei() {
		if (jRadioButtonZwei == null) {
			jRadioButtonZwei = new JRadioButton();
			jRadioButtonZwei.setText("Grund- und Spitzenlastmaschine");
			jRadioButtonZwei.setSelected(true);
			jRadioButtonZwei.addActionListener(this);
		}
		return jRadioButtonZwei;
	}

	/**
	 * This method initializes jRadioButtonSpitzenlastanteil	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonSpitzenlastanteil() {
		if (jRadioButtonSpitzenlastanteil == null) {
			jRadioButtonSpitzenlastanteil = new JRadioButton();
			jRadioButtonSpitzenlastanteil.setText("Spitzenlastanteil");
			jRadioButtonSpitzenlastanteil.addActionListener(this);
		}
		return jRadioButtonSpitzenlastanteil;
	}

	/**
	 * This method initializes jRadioButtonLaufzeitanteil	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonLaufzeitanteil() {
		if (jRadioButtonLaufzeitanteil == null) {
			jRadioButtonLaufzeitanteil = new JRadioButton();
			jRadioButtonLaufzeitanteil.setText("Laufzeitanteil");
			jRadioButtonLaufzeitanteil.setSelected(true);
			jRadioButtonLaufzeitanteil.addActionListener(this);
		}
		return jRadioButtonLaufzeitanteil;
	}

	/**
	 * This method initializes jRadioButtonEnergieanteil	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonEnergieanteil() {
		if (jRadioButtonEnergieanteil == null) {
			jRadioButtonEnergieanteil = new JRadioButton();
			jRadioButtonEnergieanteil.setText("Energieanteil");
			jRadioButtonEnergieanteil.addActionListener(this);
			
		}
		return jRadioButtonEnergieanteil;
	}

	/**
	 * This method initializes jTextFieldSpitzenlastanteil	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldSpitzenlastanteil() {
		if (jTextFieldSpitzenlastanteil == null) {
			jTextFieldSpitzenlastanteil = new JTextField(3);
			jTextFieldSpitzenlastanteil.setText("75");
			jTextFieldSpitzenlastanteil.setEnabled(false);
			jTextFieldSpitzenlastanteil.addActionListener(this);
		}
		return jTextFieldSpitzenlastanteil;
	}

	/**
	 * This method initializes jTextFieldLaufzeitanteil	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldLaufzeitanteil() { //je kleiner dieser Wert desto kleiner ist die GLM
		if (jTextFieldLaufzeitanteil == null) {
			jTextFieldLaufzeitanteil = new JTextField(3);
			jTextFieldLaufzeitanteil.setText("80");
			jTextFieldLaufzeitanteil.addActionListener(this);
		}
		return jTextFieldLaufzeitanteil;
	}

	/**
	 * This method initializes jTextFieldEnergieanteil	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldEnergieanteil() {
		if (jTextFieldEnergieanteil == null) {
			jTextFieldEnergieanteil = new JTextField(3);
			jTextFieldEnergieanteil.setText("70");
			jTextFieldEnergieanteil.setEnabled(false);
			jTextFieldEnergieanteil.addActionListener(this);
		}
		return jTextFieldEnergieanteil;
	}

	/**
	 * This method initializes jTextFieldNennleistung0	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldNennleistung0() {
		if (jTextFieldNennleistung0 == null) {
			jTextFieldNennleistung0 = new JTextField(10);
			jTextFieldNennleistung0.addActionListener(this);
			int laufzeit = new Double((100 - Double.valueOf(jTextFieldLaufzeitanteil.getText()).doubleValue()) /100 * 8760).intValue();
			jTextFieldNennleistung0.setText(Helper.Zahlformat(geordneter_lastgang[laufzeit],0));
		}
		return jTextFieldNennleistung0;
	}
	
	/**
	 * This method initializes jTextFieldVollbetriebsstunden0	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldVollbetriebsstunden0() {
		if (jTextFieldVollbetriebsstunden0 == null) {
			jTextFieldVollbetriebsstunden0 = new JTextField(10);
//			jTextFieldVollbetriebsstunden0.setEditable(false);
		}
		return jTextFieldVollbetriebsstunden0;
	}

	/**
	 * This method initializes jTextFieldVollbetriebsstunden1	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldVollbetriebsstunden1() {
		if (jTextFieldVollbetriebsstunden1 == null) {
			jTextFieldVollbetriebsstunden1 = new JTextField(10);
//			jTextFieldVollbetriebsstunden1.setEditable(false);
		}
		return jTextFieldVollbetriebsstunden1;
	}

	/**
	 * This method initializes jTextFieldNennleistung1	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldNennleistung1() {
		if (jTextFieldNennleistung1 == null) {
			jTextFieldNennleistung1 = new JTextField(10);
//			jTextFieldNennleistung1.setEditable(false);
			int laufzeit = new Double((100 - Double.valueOf(jTextFieldLaufzeitanteil.getText()).doubleValue()) /100 * 8760).intValue();
			jTextFieldNennleistung1.setText(Helper.Zahlformat(geordneter_lastgang[0] - geordneter_lastgang[laufzeit],0));
		}
		return jTextFieldNennleistung1;
	}
}