package de.elisabetheckstaedt.dipl.GUI;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

import de.elisabetheckstaedt.dipl.common.Konfiguration;
import de.elisabetheckstaedt.dipl.real.AbKM;
import de.elisabetheckstaedt.dipl.real.Kaeltemaschine;
import de.elisabetheckstaedt.dipl.real.Kompaktanlage;
import de.elisabetheckstaedt.dipl.real.Rueckkuehler;
import de.elisabetheckstaedt.dipl.real.Schraubenverdichter;
import de.elisabetheckstaedt.dipl.real.Turboverdichter;

/**
 * Fenster zur Festlegung der Art der Kltemaschine und Oberklasse des Rckkhlers (Luft/Wasser)
 * @author Elisabeth Eckstdt
 *
 */
public class F_6_KM_Spez extends Assistent {

	private static final long serialVersionUID = 1L;

	private JRadioButton jRadioButtonAKM = null;

	private JRadioButton jRadioButtonTurboW = null;

	private JRadioButton jRadioButtonSchraubeW = null;

	private JLabel jLabelAKM = null;

	private JLabel jLabelKKM = null;

	private JLabel jLabelWassergek = null;

	private JLabel jLabelLuftgekuehlt = null;

	private JLabel jLabelTurbo = null;

	private JLabel jLabelSchraube = null;

	private JRadioButton jRadioButtonSchraubeL = null;

	private JLabel jLabelKolben = null;
	
	private JRadioButton jRadioButtonKolbenA = null;

	private JRadioButton jRadioButtonKolbenB = null;

	private JRadioButton jRadioButtonKolben1 = null;

	private JRadioButton jRadioButtonKolben2 = null;

	private JRadioButton jRadioButtonKolben3 = null;

	private JRadioButton jRadioButtonKolben4 = null;

	private JLabel jLabeleinstufig = null;

	private JLabel jLabelAnweisung = null;

	private JLabel jLabelScrollverdichter = null;

	private JRadioButton jRadioButtonScroll1 = null;

	private JRadioButton jRadioButtonScroll2 = null;

	private JRadioButton jRadioButtonScroll4 = null;

	private JRadioButton jRadioButtonScrollA = null;

	private JRadioButton jRadioButtonScrollB = null;

	String kmname = null;
	double nennleistung = 0;

	int kznummer = 0;
	int kmnummer = 0;
	public F_7_WRK_Spez f_7_WRK_Spez = null;
//	double[][] leistungsanteile = null;

	/**
	 * @param owner
	 */
	public F_6_KM_Spez(String name, double nennleistung, Konfiguration konfiguration, int kznummer, int kmnummer) {
		super(konfiguration);
		kmname = name;
		this.nennleistung = nennleistung;
		this.kznummer = kznummer;
		this.kmnummer = kmnummer;
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setTitle("DC/DEsign - II - Spezifikation fr " + kmname);
		this.setSize(400, 350);
		this.setContentPane(getJContentPane());
	}

	protected void weiter()
	{
		if (!(jRadioButtonSchraubeL.isSelected() || jRadioButtonKolbenA.isSelected() || jRadioButtonKolbenB.isSelected()|| jRadioButtonScrollA.isSelected()|| jRadioButtonScrollB.isSelected()))
		{
			f_7_WRK_Spez = new F_7_WRK_Spez(konfiguration, this, kmname, nennleistung);
			f_7_WRK_Spez.setVisible(true);
		}
		else
			km_erzeugen(null);
		
	}

	void km_erzeugen(Rueckkuehler rk)
	{
		Kaeltemaschine km = null;
		if (jRadioButtonSchraubeL.isSelected() || jRadioButtonKolbenA.isSelected() || jRadioButtonKolbenB.isSelected()|| jRadioButtonScrollA.isSelected()|| jRadioButtonScrollB.isSelected())
		{
			if (jRadioButtonSchraubeL.isSelected())
			{
				km = new Kompaktanlage(kmname, "Schraube", "C");
			}
			else if (jRadioButtonKolbenA.isSelected())
			{
				km = new Kompaktanlage(kmname, "Kolben", "A");
			}
			else if (jRadioButtonKolbenB.isSelected())
			{
				km = new Kompaktanlage(kmname, "Kolben", "B");
			}
			else if (jRadioButtonScrollA.isSelected())
			{
				km = new Kompaktanlage(kmname, "Scroll", "A");
			}
			else if (jRadioButtonScrollB.isSelected())
			{
				km = new Kompaktanlage(kmname, "Scroll", "B");
			}
		}
		else if (jRadioButtonAKM.isSelected())
		{
			km = new AbKM(kmname, rk, "7");
		}
		else if (jRadioButtonTurboW.isSelected())
		{
			km = new Turboverdichter(kmname, rk, "6");
		}
		else if(jRadioButtonSchraubeW.isSelected())
		{
			km = new Schraubenverdichter(kmname, rk, "5");
		}
		konfiguration.kms[kznummer][kmnummer] = km;
		this.setVisible(false);
		konfiguration.kms_anlegen();
	}

	/**
	 * This method initializes jPanelInhalt
	 * 
	 * @return javax.swing.JPanel
	 */
	protected JPanel getJPanelInhalt() {
		if (jPanelInhalt == null) {
			
			
			GridBagConstraints gridBagConstraints51 = new GridBagConstraints();
			gridBagConstraints51.gridx = 3;
			gridBagConstraints51.gridy = 8;
			GridBagConstraints gridBagConstraints41 = new GridBagConstraints();
			gridBagConstraints41.gridx = 3;
			gridBagConstraints41.gridy = 7;
			GridBagConstraints gridBagConstraints31 = new GridBagConstraints();
			gridBagConstraints31.gridx = 2;
			gridBagConstraints31.gridy = 9;
			GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
			gridBagConstraints21.gridx = 2;
			gridBagConstraints21.gridy = 8;
			GridBagConstraints gridBagConstraints110 = new GridBagConstraints();
			gridBagConstraints110.gridx = 2;
			gridBagConstraints110.gridy = 7;
			GridBagConstraints gridBagConstraints22 = new GridBagConstraints();
			gridBagConstraints22.gridx = 1;
			gridBagConstraints22.gridy = 7;
			gridBagConstraints22.anchor = GridBagConstraints.WEST;
			jLabelScrollverdichter = new JLabel();
			jLabelScrollverdichter.setText("Scrollverdichter");
			GridBagConstraints gridBagConstraints19 = new GridBagConstraints();
			gridBagConstraints19.gridx = 0;
			gridBagConstraints19.gridwidth = 5;
			gridBagConstraints19.fill = GridBagConstraints.BOTH;
			gridBagConstraints19.gridy = 16;
			
			GridBagConstraints gridBagConstraints18 = new GridBagConstraints();
			gridBagConstraints18.gridx = 0;
			gridBagConstraints18.gridwidth = 4;
			gridBagConstraints18.gridy = 0;
			
			gridBagConstraints18.anchor = GridBagConstraints.WEST;
			jLabelAnweisung = new JLabel();
			jLabelAnweisung.setText("<html><body>Spezifikation fr " + kmname + " whlen " +
					"<br>(Nennleistung KM: " + nennleistung + " kW)</body></html>");
			GridBagConstraints gridBagConstraints17 = new GridBagConstraints();
			gridBagConstraints17.insets = new Insets(0, 5, 0, 0);
			gridBagConstraints17.gridx = 1;
			gridBagConstraints17.gridy = 2;
			gridBagConstraints17.anchor = GridBagConstraints.WEST;
			jLabeleinstufig = new JLabel();
			jLabeleinstufig.setText("LiBr einstufig");
			
			GridBagConstraints gridBagConstraints16 = new GridBagConstraints();
			gridBagConstraints16.gridx = 2;
			gridBagConstraints16.gridy = 6;
			GridBagConstraints gridBagConstraints15 = new GridBagConstraints();
			gridBagConstraints15.gridx = 2;
			gridBagConstraints15.gridy = 5;
			GridBagConstraints gridBagConstraints14 = new GridBagConstraints();
			gridBagConstraints14.gridx = 2;
			gridBagConstraints14.gridy = 4;
			GridBagConstraints gridBagConstraints13 = new GridBagConstraints();
			gridBagConstraints13.gridx = 2;
			gridBagConstraints13.gridy = 3;
			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			gridBagConstraints12.gridx = 3;
			gridBagConstraints12.gridy = 4;
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.gridx = 3;
			gridBagConstraints11.gridy = 3;
			GridBagConstraints gridBagConstraints10 = new GridBagConstraints();
			gridBagConstraints10.insets = new Insets(0, 5, 0, 0);
			gridBagConstraints10.gridx = 1;
			gridBagConstraints10.gridheight = 1;
			gridBagConstraints10.gridy = 3;
			gridBagConstraints10.anchor = GridBagConstraints.WEST;
			jLabelKolben = new JLabel();
			jLabelKolben.setText("Kolbenverdichter");
			GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
			gridBagConstraints9.gridx = 3;
			gridBagConstraints9.gridy = 10;
			GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
			gridBagConstraints8.gridx = 1;
			gridBagConstraints8.gridy = 10;
			gridBagConstraints8.anchor = GridBagConstraints.WEST;
			jLabelSchraube = new JLabel();
			jLabelSchraube.setText("Schraubenverdichter");
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.gridx = 1;
			gridBagConstraints7.gridy = 11;
			gridBagConstraints7.anchor = GridBagConstraints.WEST;
			jLabelTurbo = new JLabel();
			jLabelTurbo.setText("Turboverdichter");
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.insets = new Insets(0, 5, 0, 0);
			gridBagConstraints6.gridx = 3;
			gridBagConstraints6.gridy = 1;
			jLabelLuftgekuehlt = new JLabel();
			jLabelLuftgekuehlt.setText("Luftgekhlt = Kompaktanlage");
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints5.gridx = 2;
			gridBagConstraints5.gridy = 1;
			gridBagConstraints5.anchor = GridBagConstraints.WEST;
			jLabelWassergek = new JLabel();
			jLabelWassergek.setText("Wassergekhlt");
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 0;
			gridBagConstraints1.gridheight = 1;
			gridBagConstraints1.gridy = 3;
			gridBagConstraints1.anchor = GridBagConstraints.WEST;
			jLabelKKM = new JLabel();
			jLabelKKM.setText("KoKM");
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.gridx = 0;
			gridBagConstraints4.gridy = 2;
			gridBagConstraints4.anchor = GridBagConstraints.WEST;
			jLabelAKM = new JLabel();
			jLabelAKM.setText("AbKM");
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.gridx = 2;
			gridBagConstraints3.gridy = 10;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 2;
			gridBagConstraints2.gridy = 11;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 2;
			gridBagConstraints.gridy = 2;
			jPanelInhalt = new JPanel();
			jPanelInhalt.setLayout(new GridBagLayout());
			jPanelInhalt.add(getJRadioButtonAKM(), gridBagConstraints);
			jPanelInhalt.add(getJRadioButtonTurboW(), gridBagConstraints2);
			jPanelInhalt.add(getJRadioButtonSchraubeW(), gridBagConstraints3);
			jPanelInhalt.add(jLabelAKM, gridBagConstraints4);
			jPanelInhalt.add(jLabelKKM, gridBagConstraints1);
			jPanelInhalt.add(jLabelWassergek, gridBagConstraints5);
			jPanelInhalt.add(jLabelLuftgekuehlt, gridBagConstraints6);
			jPanelInhalt.add(jLabelTurbo, gridBagConstraints7);
			jPanelInhalt.add(jLabelSchraube, gridBagConstraints8);
			jPanelInhalt.add(getJRadioButtonSchraubeL(), gridBagConstraints9);
			jPanelInhalt.add(jLabelKolben, gridBagConstraints10);
			jPanelInhalt.add(getJRadioButtonKolbenA(), gridBagConstraints11);
			jPanelInhalt.add(getJRadioButtonKolbenB(), gridBagConstraints12);
			jPanelInhalt.add(getJRadioButtonKolben1(), gridBagConstraints13);
			jPanelInhalt.add(getJRadioButtonKolben2(), gridBagConstraints14);
			jPanelInhalt.add(getJRadioButtonKolben3(), gridBagConstraints15);
			jPanelInhalt.add(getJRadioButtonKolben4(), gridBagConstraints16);
			jPanelInhalt.add(jLabeleinstufig, gridBagConstraints17);
			jPanelInhalt.add(jLabelAnweisung, gridBagConstraints18);
			jPanelInhalt.add(jLabelScrollverdichter, gridBagConstraints22);
			jPanelInhalt.add(getJRadioButtonScroll1(), gridBagConstraints110);
			jPanelInhalt.add(getJRadioButtonScroll2(), gridBagConstraints21);
			jPanelInhalt.add(getJRadioButtonScroll4(), gridBagConstraints31);
			jPanelInhalt.add(getJRadioButtonScrollA(), gridBagConstraints41);
			jPanelInhalt.add(getJRadioButtonScrollB(), gridBagConstraints51);
			
			ButtonGroup buttongroup = new ButtonGroup();
			buttongroup.add(jRadioButtonAKM);
			buttongroup.add(jRadioButtonSchraubeL);
			buttongroup.add(jRadioButtonSchraubeW);
			buttongroup.add(jRadioButtonTurboW);
			buttongroup.add(jRadioButtonKolben1);
			buttongroup.add(jRadioButtonKolben2);
			buttongroup.add(jRadioButtonKolben3);
			buttongroup.add(jRadioButtonKolben4);
			buttongroup.add(jRadioButtonKolbenA);
			buttongroup.add(jRadioButtonKolbenB);
		}
		return jPanelInhalt;
	}

	/**
	 * This method initializes jRadioButtonAKM	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonAKM() {
		if (jRadioButtonAKM == null) {
			jRadioButtonAKM = new JRadioButton();
			jRadioButtonAKM.setText("7");
		}
		return jRadioButtonAKM;
	}

	/**
	 * This method initializes jRadioButtonTurboW	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonTurboW() {
		if (jRadioButtonTurboW == null) {
			jRadioButtonTurboW = new JRadioButton();
			jRadioButtonTurboW.setText("6");
			jRadioButtonTurboW.setSelected(true);
		}
		return jRadioButtonTurboW;
	}

	/**
	 * This method initializes jRadioButtonSchraubeW	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonSchraubeW() {
		if (jRadioButtonSchraubeW == null) {
			jRadioButtonSchraubeW = new JRadioButton();
			jRadioButtonSchraubeW.setText("5");
		}
		return jRadioButtonSchraubeW;
	}

	/**
	 * This method initializes jRadioButtonSchraubeL	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonSchraubeL() {
		if (jRadioButtonSchraubeL == null) {
			jRadioButtonSchraubeL = new JRadioButton();
			jRadioButtonSchraubeL.setText("C");
		}
		return jRadioButtonSchraubeL;
	}

	/**
	 * This method initializes jRadioButtonKolbenA	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonKolbenA() {
		if (jRadioButtonKolbenA == null) {
			jRadioButtonKolbenA = new JRadioButton();
			jRadioButtonKolbenA.setText("A");
			
		}
		return jRadioButtonKolbenA;
	}

	/**
	 * This method initializes jRadioButtonKolbenB	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonKolbenB() {
		if (jRadioButtonKolbenB == null) {
			jRadioButtonKolbenB = new JRadioButton();
			jRadioButtonKolbenB.setText("B");
			
		}
		return jRadioButtonKolbenB;
	}

	/**
	 * This method initializes jRadioButtonKolben1	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonKolben1() {
		if (jRadioButtonKolben1 == null) {
			jRadioButtonKolben1 = new JRadioButton();
			jRadioButtonKolben1.setText("1");
			jRadioButtonKolben1.setEnabled(false);
			
		}
		return jRadioButtonKolben1;
	}

	/**
	 * This method initializes jRadioButtonKolben2	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonKolben2() {
		if (jRadioButtonKolben2 == null) {
			jRadioButtonKolben2 = new JRadioButton();
			jRadioButtonKolben2.setText("2");
			jRadioButtonKolben2.setEnabled(false);
			
		}
		return jRadioButtonKolben2;
	}

	/**
	 * This method initializes jRadioButtonKolben3	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonKolben3() {
		if (jRadioButtonKolben3 == null) {
			jRadioButtonKolben3 = new JRadioButton();
			jRadioButtonKolben3.setText("3");
			jRadioButtonKolben3.setEnabled(false);
			
		}
		return jRadioButtonKolben3;
	}

	/**
	 * This method initializes jRadioButtonKolben4	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonKolben4() {
		if (jRadioButtonKolben4 == null) {
			jRadioButtonKolben4 = new JRadioButton();
			jRadioButtonKolben4.setText("4");
			jRadioButtonKolben4.setEnabled(false);
			
		}
		return jRadioButtonKolben4;
	}
	
	/**
	 * This method initializes jRadioButtonScroll1	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonScroll1() {
		if (jRadioButtonScroll1 == null) {
			jRadioButtonScroll1 = new JRadioButton();
			jRadioButtonScroll1.setText("1");
			jRadioButtonScroll1.setEnabled(false);
		}
		return jRadioButtonScroll1;
	}

	/**
	 * This method initializes jRadioButtonScroll2	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonScroll2() {
		if (jRadioButtonScroll2 == null) {
			jRadioButtonScroll2 = new JRadioButton();
			jRadioButtonScroll2.setText("2");
			jRadioButtonScroll2.setEnabled(false);
		}
		return jRadioButtonScroll2;
	}

	/**
	 * This method initializes jRadioButtonScroll4	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonScroll4() {
		if (jRadioButtonScroll4 == null) {
			jRadioButtonScroll4 = new JRadioButton();
			jRadioButtonScroll4.setText("4");
			jRadioButtonScroll4.setEnabled(false);
		}
		return jRadioButtonScroll4;
	}

	/**
	 * This method initializes jRadioButtonScrollA	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonScrollA() {
		if (jRadioButtonScrollA == null) {
			jRadioButtonScrollA = new JRadioButton();
			jRadioButtonScrollA.setText("A");
		}
		return jRadioButtonScrollA;
	}

	/**
	 * This method initializes jRadioButtonScrollB	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonScrollB() {
		if (jRadioButtonScrollB == null) {
			jRadioButtonScrollB = new JRadioButton();
			jRadioButtonScrollB.setText("B");
		}
		return jRadioButtonScrollB;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
