package de.elisabetheckstaedt.dipl.GUI;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.SwingConstants;

import de.elisabetheckstaedt.dipl.common.Konfiguration;
import de.elisabetheckstaedt.dipl.real.Rueckkuehler;
import de.elisabetheckstaedt.dipl.real.Trockenrueckkuehler;
import de.elisabetheckstaedt.dipl.real.Verdunstungsrueckkuehler;

/**
 * Fenster zur nheren Spezifikation von Wasserrckkhlern 
 * @author Elisabeth Eckstdt
 *
 */
public class F_7_WRK_Spez extends Assistent {

	private static final long serialVersionUID = 1L;

	private JLabel jLabelVerdunstung = null;

	private JLabel jLabelTrocken = null;

	private JLabel jLabelgeschlossen = null;

	private JLabel jLabeloffen = null;

	private JLabel jLabelaxial = null;

	private JLabel jLabelradial = null;

	private JRadioButton jRadioButtongeschlax = null;

	private JRadioButton jRadioButtongeschlrad = null;

	private JRadioButton jRadioButtonofax = null;

	private JRadioButton jRadioButtonofrad = null;

	private JRadioButton jRadioButtontrocken = null;

	private JLabel jLabelBeschreibung = null;

	private JLabel jLabelAnweisung = null;

	public Rueckkuehler rk = null;  //  @jve:decl-index=0:
	String kmname = null;
	double kmnennleistung = 0;
	
	double ha_trocken = 0.045;
	double ha_geschlax = 0.033;
	double ha_geschlrad = 0.04;
	double ha_ofax = 0.018;
	double ha_ofrad = 0.021;
	F_6_KM_Spez f_km_spez = null;

	/**
	 * @param owner
	 * @param kmname
	 * @param rknennleistung
	 */
	public F_7_WRK_Spez(Konfiguration konfiguration, F_6_KM_Spez owner, String kmname, double kmnennleistung) {
		super(konfiguration);
		f_km_spez = owner;
		this.kmname = kmname;
		this.kmnennleistung = kmnennleistung;
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(400, 200);
		this.setModal(true);
		this.setTitle("DE/DEsign - II - Spezifikation Wasserkhlung fr " + kmname);
		this.setContentPane(getJContentPane());
	}

	/**
	 * This method initializes jPanelInhalt
	 * 
	 * @return javax.swing.JPanel
	 */
	protected JPanel getJPanelInhalt() {
		if (jPanelInhalt == null) {
			jPanelInhalt = new JPanel();
			jPanelInhalt.setLayout(new GridBagLayout());
			
			GridBagConstraints gridBagConstraints20 = new GridBagConstraints();
			gridBagConstraints20.gridx = 0;
			gridBagConstraints20.gridy = 0;
			gridBagConstraints20.gridwidth = 5;
			gridBagConstraints20.anchor = GridBagConstraints.WEST;
			jLabelAnweisung = new JLabel();
			jLabelAnweisung.setText("<html><body>Rckkhler fr " + kmname + " whlen " +
					"<br>(Nennleistung KM: " + kmnennleistung + " kW)</body></html>");
			jPanelInhalt.add(jLabelAnweisung, gridBagConstraints20);
			
			GridBagConstraints gridBagConstraints10 = new GridBagConstraints();
			gridBagConstraints10.gridx = 3;
			gridBagConstraints10.gridy = 3;
			jPanelInhalt.add(getJRadioButtontrocken(), gridBagConstraints10);
			
			GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
			gridBagConstraints9.gridx = 2;
			gridBagConstraints9.gridy = 4;
//			gridBagConstraints9.anchor = GridBagConstraints.WEST;
			jPanelInhalt.add(getJRadioButtonofrad(), gridBagConstraints9);
			
			GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
			gridBagConstraints8.gridx = 2;
			gridBagConstraints8.gridy = 3;
			jPanelInhalt.add(getJRadioButtonofax(), gridBagConstraints8);
			
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.gridx = 1;
			gridBagConstraints7.gridy = 4;
			jPanelInhalt.add(getJRadioButtongeschlrad(), gridBagConstraints7);
			
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.gridx = 1;
			gridBagConstraints6.gridy = 3;
			jPanelInhalt.add(getJRadioButtongeschlax(), gridBagConstraints6);
			
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.gridx = 0;
			gridBagConstraints5.gridy = 4;
			gridBagConstraints5.anchor = GridBagConstraints.EAST;
			jLabelradial = new JLabel();
			jLabelradial.setText("Radialventilator");
			jPanelInhalt.add(jLabelradial, gridBagConstraints5);
			
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.gridx = 0;
			gridBagConstraints4.gridy = 3;
			jLabelaxial = new JLabel();
			jLabelaxial.setText("Axialventilator");
			gridBagConstraints4.anchor = GridBagConstraints.EAST;
//			jLabelaxial.setHorizontalTextPosition(SwingConstants.LEFT);
			jPanelInhalt.add(jLabelaxial, gridBagConstraints4);

			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.insets = new Insets(0, 5, 0, 5);
			gridBagConstraints3.gridx = 2;
			gridBagConstraints3.gridy = 2;
			jLabeloffen = new JLabel();
			jLabeloffen.setText("Offener Kreislauf");
			jPanelInhalt.add(jLabeloffen, gridBagConstraints3);
			
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.insets = new Insets(0, 5, 0, 5);
			gridBagConstraints2.gridx = 1;
			gridBagConstraints2.gridy = 2;
			jLabelgeschlossen = new JLabel();
			jLabelgeschlossen.setText("geschlossener Kreislauf");
			jPanelInhalt.add(jLabelgeschlossen, gridBagConstraints2);
			
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 3;
			gridBagConstraints1.gridy = 1;
			jLabelTrocken = new JLabel();
			jLabelTrocken.setText("Trockenrckkhler");
			jPanelInhalt.add(jLabelTrocken, gridBagConstraints1);
			
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 1;
			gridBagConstraints.gridy = 1;
			gridBagConstraints.gridwidth = 2;
			jLabelVerdunstung = new JLabel();
			jLabelVerdunstung.setText("Verdunstungsrckkhler");
			jPanelInhalt.add(jLabelVerdunstung, gridBagConstraints);
			
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.gridx = 1;
			gridBagConstraints11.gridy = 5;
			gridBagConstraints11.gridwidth = 3;
			jLabelBeschreibung = new JLabel();
			jLabelBeschreibung.setText("Stromverbrauch [kW/kW Rckkhlleistung]");
			jPanelInhalt.add(jLabelBeschreibung, gridBagConstraints11);

			
			ButtonGroup buttongroup = new ButtonGroup();
			buttongroup.add(jRadioButtongeschlax);
			buttongroup.add(jRadioButtongeschlrad);
			buttongroup.add(jRadioButtonofax);
			buttongroup.add(jRadioButtonofrad);
			buttongroup.add(jRadioButtontrocken);
		}
		return jPanelInhalt;
	}

	/**
	 * This method initializes jRadioButtongeschlax	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtongeschlax() {
		if (jRadioButtongeschlax == null) {
			jRadioButtongeschlax = new JRadioButton();
			jRadioButtongeschlax.setText(String.valueOf(ha_geschlax));
		}
		return jRadioButtongeschlax;
	}

	/**
	 * This method initializes jRadioButtongeschlrad	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtongeschlrad() {
		if (jRadioButtongeschlrad == null) {
			jRadioButtongeschlrad = new JRadioButton();
			jRadioButtongeschlrad.setText(String.valueOf(ha_geschlrad));
		}
		return jRadioButtongeschlrad;
	}

	/**
	 * This method initializes jRadioButtonofax	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonofax() {
		if (jRadioButtonofax == null) {
			jRadioButtonofax = new JRadioButton();
			jRadioButtonofax.setText(String.valueOf(ha_ofax));
			jRadioButtonofax.setSelected(true);
		}
		return jRadioButtonofax;
	}

	/**
	 * This method initializes jRadioButtonofrad	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonofrad() {
		if (jRadioButtonofrad == null) {
			jRadioButtonofrad = new JRadioButton();
			jRadioButtonofrad.setText(String.valueOf(ha_ofrad));
			jRadioButtonofrad.setHorizontalAlignment(SwingConstants.LEFT);
		}
		return jRadioButtonofrad;
	}

	/**
	 * This method initializes jRadioButtontrocken	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtontrocken() {
		if (jRadioButtontrocken == null) {
			jRadioButtontrocken = new JRadioButton();
			jRadioButtontrocken.setText(String.valueOf(ha_trocken));
		}
		return jRadioButtontrocken;
	}

	protected void weiter()
	{
//		double hilfsantriebe = 0;
		if (jRadioButtontrocken.isSelected())
		{
			rk = new Trockenrueckkuehler("RK " + kmname);
//			hilfsantriebe = ha_trocken;
		}
		else
		{
			String typ =  null;
			String typ2 = null;
			if (jRadioButtongeschlax.isSelected())
			{
				typ = "geschlossen";
				typ2 = "axial";
//				hilfsantriebe = ha_geschlax;
			}
			else if (jRadioButtongeschlrad.isSelected())
			{
				typ = "geschlossen";
				typ2 = "radial";
//				hilfsantriebe = ha_geschlrad;
			}
			else if (jRadioButtonofax.isSelected())
			{
				typ = "offen";
				typ2 = "axial";
//				hilfsantriebe = ha_ofax;
			}
			else if (jRadioButtonofrad.isSelected())
			{
				typ = "offen";
				typ2 = "radial";
//				hilfsantriebe = ha_ofrad;
			}
			rk = new Verdunstungsrueckkuehler("RK " + kmname, typ, typ2);
		}
		f_km_spez.km_erzeugen(rk);
		this.setVisible(false);
	}
}
