package de.elisabetheckstaedt.dipl.GUI;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import de.elisabetheckstaedt.dipl.common.Klimadatensatz;
import java.awt.Insets;
import java.awt.Dimension;

/**
 * Eingabefenster fr Klimadatestze, ffnet im Wesentlichen einen Dateiauswahldialog
 * @author Elisabeth Eckstdt
 *
 */
public class Klimadaten extends TopCustomDialog {

	private static final long serialVersionUID = 1L;

	private JPanel jPanelInhalt = null;
	private JTextField jTextFieldDateiauswahl = null;

	private JButton jButtonDursuchen = null;

	public File Eingabe = null; 

	private JTextField jTextFieldName = null;

	private JLabel jLabelName = null;

	/**
	 * This is the default constructor
	 */
	public Klimadaten(Hauptfenster vaterfenster) {
		super(vaterfenster);
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(400, 150);
		this.setContentPane(getJContentPane());
		this.setTitle("DC/DEsign - I - Klimadaten einlesen");
		this.setVisible(true);
	}


	/**
	 * This method initializes jPanelInhalt
	 * 
	 * @return javax.swing.JPanel
	 */
	protected JPanel getJPanelInhalt() {
		if (jPanelInhalt == null) {
			jPanelInhalt = new JPanel();
			jPanelInhalt.setLayout(new GridBagLayout());

			GridBagConstraints gridBagConstraints31 = new GridBagConstraints();
			gridBagConstraints31.gridx = 0;
			gridBagConstraints31.anchor = GridBagConstraints.EAST;
			gridBagConstraints31.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints31.gridy = 0;
			jLabelName = new JLabel("Name des Klimadatensatzes");
			GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
			gridBagConstraints21.fill = GridBagConstraints.BOTH;
			gridBagConstraints21.gridx = 1;
			gridBagConstraints21.anchor = GridBagConstraints.WEST;
			gridBagConstraints21.insets = new Insets(0, 5, 0, 0);
			gridBagConstraints21.weightx = 1.0;
			gridBagConstraints21.gridy = 0;
			
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.fill = GridBagConstraints.BOTH;
			gridBagConstraints2.gridx = 0;
			gridBagConstraints2.weightx = 1.0;
			gridBagConstraints2.insets = new Insets(5, 0, 0, 0);
			gridBagConstraints2.gridy = 1;
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.gridx = 1;
			gridBagConstraints3.anchor = GridBagConstraints.WEST;
			gridBagConstraints3.insets = new Insets(5, 5, 0, 0);
			gridBagConstraints3.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints3.gridy = 1;
			jPanelInhalt.add(jLabelName, gridBagConstraints31);
			jPanelInhalt.add(getJTextFieldName(), gridBagConstraints21);
			jPanelInhalt.add(getJTextFieldDateiauswahl(), gridBagConstraints2);
			jPanelInhalt.add(getJButtonDursuchen(), gridBagConstraints3);
			
		}
		return jPanelInhalt;
	}

	/**
	 * This method initializes jTextFieldDateiauswahl	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldDateiauswahl() {
		if (jTextFieldDateiauswahl == null) {
			jTextFieldDateiauswahl = new JTextField();
			jTextFieldDateiauswahl.setText("keine Datei gewhlt");
//			jTextFieldDateiauswahl.setPreferredSize(new Dimension(200, 20));
			jTextFieldDateiauswahl.setPreferredSize(new Dimension(250, 20));
//			jTextFieldDateiauswahl.setName("");
		}
		return jTextFieldDateiauswahl;
	}

	/**
	 * This method initializes jButtonDursuchen	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonDursuchen() {
		if (jButtonDursuchen == null) {
			jButtonDursuchen = new JButton();
			jButtonDursuchen.setText("Durchsuchen...");
			jButtonDursuchen.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
				    JFileChooser fc = new JFileChooser(); 
				    int state = fc.showOpenDialog( null ); 
				    File file = null;
				    if ( state == JFileChooser.APPROVE_OPTION ) 
				    { 
				      file = fc.getSelectedFile();
				      jTextFieldDateiauswahl.setText(file.getPath());
				      Eingabe = file;
				      jTextFieldName.setText(file.getName().substring(0, file.getName().indexOf(".")));
				    } 
				}
			});
		}
		return jButtonDursuchen;
	}

	/**
	 * This method initializes jTextFieldName	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldName() {
		if (jTextFieldName == null) {
			jTextFieldName = new JTextField();
			jTextFieldName.setText("Klimadatensatz1");
		}
		return jTextFieldName;
	}

	protected void Uebernehmen() {
		if (Eingabe == null)
		{
			System.err.println("Sie haben keine Datei ausgewhlt --> kein Klimadatensatz erzeugt");
		}
		else
		{
			Klimadatensatz KDD = null;
			double[] Aussentemperatur = new double[8760];
			double[] Wasserdampfgehalt = new double[8760];
			try
			{
				FileInputStream fstream = new FileInputStream(Eingabe);
				DataInputStream in = new DataInputStream(fstream);
				BufferedReader br = new BufferedReader(new InputStreamReader(in));
				String Zeile;
				for (int i=0; i<8760; i++)
				{
					Zeile = br.readLine();
					String T_A = Zeile.substring(40, 44);
					String x = Zeile.substring(57,61);
					Aussentemperatur[i] = Float.valueOf( T_A ).floatValue();
					Wasserdampfgehalt[i] = Float.valueOf( x ).floatValue();
				}
				KDD = new Klimadatensatz(jTextFieldName.getText(),Aussentemperatur, Wasserdampfgehalt);
				in.close();
			}
			catch (Exception a) {}
			((Hauptfenster) getOwner()).kds = KDD;
			((Hauptfenster) getOwner()).konfig_freischalten();
		}
		
	}
}  //  @jve:decl-index=0:visual-constraint="10,10"
