package de.elisabetheckstaedt.dipl.GUI;

import javax.swing.JDialog;
import javax.swing.JButton;
import javax.swing.JPanel;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

/**
 * enthlt OK, bernehmen, Abbrechen-Buttons; deren Action Listener, Schliessen Methode, OK Methode und abstrakte Uebernehmen-Methode
 * @author Elisabeth Eckstdt
 *
 */
public abstract class TopCustomDialog extends JDialog implements ActionListener{
	
	protected JPanel jContentPane = null;
	protected JPanel jPanelInhalt = null;
	private JPanel jPanelNavigation = null;
	protected JButton jButtonOK = null;
	protected JButton jButtonUebernehmen = null;
	protected JButton jButtonAbbrechen = null;

	protected static final long serialVersionUID = 1L;
	
	public TopCustomDialog(Hauptfenster hauptfenster) {
		super(hauptfenster);
		WindowListener WindowListener = new WindowAdapter()
		{
			public void windowClosing(WindowEvent we)
			{
				Schliessen();
			}
		};
		this.addWindowListener(WindowListener);
	}
	
	public TopCustomDialog(Verbrauchein vaterfenster) {
		super(vaterfenster);
		WindowListener WindowListener = new WindowAdapter()
		{
			public void windowClosing(WindowEvent we)
			{
				Schliessen();
			}
		};
		this.addWindowListener(WindowListener);
	}
	
	public void actionPerformed(ActionEvent ae)
	{
		Object Quelle = ae.getSource();
		if (Quelle == jButtonOK)
		{
			Uebernehmen();
			Schliessen();
		}
		else if (Quelle == jButtonUebernehmen)
		{
			Uebernehmen();
		}
		else if (Quelle == jButtonAbbrechen)
		{
			Schliessen();
		}
	}

	/**
	 * = JPanelInhalt + JPAnelNavigation
	 * @return
	 */
	protected JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new GridBagLayout());
			
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 0;
			gridBagConstraints.anchor = GridBagConstraints.WEST;
			gridBagConstraints.fill = GridBagConstraints.BOTH;
			jContentPane.add(getJPanelInhalt(), gridBagConstraints);
			
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 0;
			gridBagConstraints1.gridy = 1;
			gridBagConstraints1.anchor = GridBagConstraints.WEST;
			gridBagConstraints1.fill = GridBagConstraints.HORIZONTAL;
			jContentPane.add(getJPanelNavigation(), gridBagConstraints1);
		}
		return jContentPane;
	}
	
	protected abstract JPanel getJPanelInhalt();

	/**
	 * This method initializes jPanelNavigation	
	 * 	Abbrechen, zurck, weiter
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelNavigation() {
		if (jPanelNavigation == null) {
			jPanelNavigation = new JPanel();
			jPanelNavigation.setLayout(new GridBagLayout());

			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.insets = new Insets(10, 0, 0, 0);
			gridBagConstraints5.gridx = 0;
			gridBagConstraints5.gridy = 0;
			gridBagConstraints5.fill = GridBagConstraints.BOTH;
			jPanelNavigation.add(getJButtonOK(), gridBagConstraints5);
			
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.insets = new Insets(10, 10, 0, 10);
			gridBagConstraints4.gridx = 1;
			gridBagConstraints4.gridy = 0;
			gridBagConstraints4.fill = GridBagConstraints.BOTH;
			jPanelNavigation.add(getJButtonUebernehmen(), gridBagConstraints4);
			
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.insets = new Insets(10, 10, 0, 10);
			gridBagConstraints2.gridx = 2;
			gridBagConstraints2.gridy = 0;
			gridBagConstraints2.fill = GridBagConstraints.BOTH;
			jPanelNavigation.add(getJButtonAbbrechen(), gridBagConstraints2);
		}
		return jPanelNavigation;
	}

	/**
	 * This method initializes jButtonOK	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonOK() {
		if (jButtonOK == null) {
			jButtonOK = new JButton();
			jButtonOK.setText("OK");
			jButtonOK.addActionListener(this);
			jButtonOK.setPreferredSize(new Dimension(100, 26));
		}
		return jButtonOK;
	}

	/**
	 * This method initializes jButtonUebernehmen	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonUebernehmen() {
		if (jButtonUebernehmen == null) {
			jButtonUebernehmen = new JButton();
			jButtonUebernehmen.setText("bernehmen");
			jButtonUebernehmen.addActionListener(this);
			jButtonUebernehmen.setPreferredSize(new Dimension(100, 26));
		}
		return jButtonUebernehmen;
	}

	/**
	 * This method initializes jButtonAbbrechen	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonAbbrechen() {
		if (jButtonAbbrechen == null) {
			jButtonAbbrechen = new JButton();
			jButtonAbbrechen.setText("Abbrechen");
			jButtonAbbrechen.addActionListener(this);
			jButtonAbbrechen.setPreferredSize(new Dimension(100, 26));
		}
		return jButtonAbbrechen;
	}

	abstract protected void Uebernehmen();

	protected void Schliessen()
	{
		this.setVisible(false);
	}
}