package de.elisabetheckstaedt.dipl.GUI;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextPane;

import de.elisabetheckstaedt.dipl.real.Verbraucher;
import de.elisabetheckstaedt.dipl.real.Verbraucher_e;
import de.elisabetheckstaedt.dipl.real.Verbraucher_k;

/**
 * Textfenster zur Verbrauchereingabe
 * @author Elisabeth Eckstdt
 */
public class Verbrauchein extends TopCustomDialog {

	/**
	 * Fake-Button, wird vom Programm gedrckt
	 */
	private JButton aktualisieren = null;
	
	public String Verbraucherstring;  //  @jve:decl-index=0:
	protected JPanel jPanelInhalt = null;
	private static final long serialVersionUID = 1L;

	FVerbraucher_e FVerbraucher_e = null;
	
	FVerbraucher_k FVerbraucher_k = null;

	private JLabel jLabelvorhandene = null;

	private JTextPane jTextPaneVorhandene = null;

	private JButton jButtonHinzuDatei = null;

	private JButton jButtonHinzuE = null;

	private JButton jButtonHinzuK = null;  //  @jve:decl-index=0:

	private JScrollPane jScrollPane = null;

	/**
	 * This is the default constructor
	 */
	public Verbrauchein(Hauptfenster hauptfenster) {
		super(hauptfenster);
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		Verbraucherstring = "";
		this.setSize(750, 350);
		this.setContentPane(getJContentPane());
		this.setTitle("DC/DEsign - I - Verbraucher einlesen");
		this.setVisible(true);
		aktualisieren = new JButton();
	}
	
	public void actionPerformed(ActionEvent ae) {
		super.actionPerformed(ae);
		Object Quelle = ae.getSource();
		if (Quelle == jButtonHinzuDatei)
		{
			JFileChooser fc = new JFileChooser(); 
		    int state = fc.showOpenDialog( null ); 
		    FileReader in = null;
		    if ( state == JFileChooser.APPROVE_OPTION ) 
		    { 
		      File file = fc.getSelectedFile(); 
		      try 	{in = new FileReader ( file );}
		      	catch (FileNotFoundException a) {a.printStackTrace();} 
		      char[] Einlesen = new char[new Integer( Math.round(file.length())).intValue()];
		      try {in.read(Einlesen);} 
		      	catch (IOException b) { b.printStackTrace();    }
		      String Dateiinhalt = new String(Einlesen);
		      Verbraucherstring = jTextPaneVorhandene.getText() + "\n" + Dateiinhalt;
		    } 
		}
		else if (Quelle == jButtonHinzuE)
		{
			getFVerbraucher_e();
		}
		else if (Quelle == jButtonHinzuK)
		{
			getFVerbraucher_k();
		}
		jTextPaneVorhandene.setText(Verbraucherstring);
		
	}

	/**
		 * This method initializes jPanelInhalt
		 * 
		 * @return javax.swing.JPanel
		 */
		protected JPanel getJPanelInhalt() {
			if (jPanelInhalt == null) {
				jPanelInhalt = new JPanel();
				jPanelInhalt.setLayout(new GridBagLayout());
				
				GridBagConstraints gridBagConstraints = new GridBagConstraints();
				gridBagConstraints.gridx = 0;
				gridBagConstraints.gridy = 0;
				gridBagConstraints.gridwidth = 3;
				jLabelvorhandene = new JLabel("Bisher eingelesene Verbraucher");
				jPanelInhalt.add(jLabelvorhandene, gridBagConstraints);
	
				GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
				gridBagConstraints8.fill = GridBagConstraints.BOTH;
				gridBagConstraints8.gridx = 0;
				gridBagConstraints8.gridy = 1;
				gridBagConstraints8.gridwidth = 3;
				jPanelInhalt.add(getJScrollPane(), gridBagConstraints8);
				
				GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
				gridBagConstraints2.gridx = 0;
				gridBagConstraints2.gridy = 2;
				jPanelInhalt.add(getJButtonHinzuDatei(), gridBagConstraints2);
				
				GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
				gridBagConstraints3.gridx = 1;
				gridBagConstraints3.gridy = 2;
				jPanelInhalt.add(getJButtonHinzuE(), gridBagConstraints3);
	
				GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
				gridBagConstraints4.gridx = 2;
				gridBagConstraints4.gridy = 2;
				jPanelInhalt.add(getJButtonHinzuK(), gridBagConstraints4);
			}
			return jPanelInhalt;
		}

	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane(getJTextPaneVorhandene());
			jScrollPane.setViewportView(getJTextPaneVorhandene());
			jScrollPane.setPreferredSize(new Dimension(500, 200));
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jTextPaneVorhandene	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextPane getJTextPaneVorhandene() {
		if (jTextPaneVorhandene == null) {
			jTextPaneVorhandene = new JTextPane();
			jTextPaneVorhandene.setText(Verbraucherstring);
		}
		return jTextPaneVorhandene;
	}

	/**
	 * This method initializes jButtonHinzuDatei	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonHinzuDatei() {
		if (jButtonHinzuDatei == null) {
			jButtonHinzuDatei = new JButton();
			jButtonHinzuDatei.setText("Hinzufgen aus Datei...");
			jButtonHinzuDatei.addActionListener(this);
			jButtonHinzuDatei.setPreferredSize(new Dimension(180, 26));
		}
		return jButtonHinzuDatei;
	}

	/**
		 * This method initializes jButtonHinzuE	
		 * 	
		 * @return javax.swing.JButton	
		 */
		private JButton getJButtonHinzuE() {
	//		final Verbrauchereingabe Ich = this;
			if (jButtonHinzuE == null) {
				jButtonHinzuE = new JButton();
				jButtonHinzuE.setText("Hinzufgen mit Sttzpunktverfahren...");
				jButtonHinzuE.addActionListener(this);
				jButtonHinzuE.setPreferredSize(new Dimension(250, 26));
			}
			return jButtonHinzuE;
		}

	/**
		 * This method initializes jButtonHinzuK	
		 * 	
		 * @return javax.swing.JButton	
		 */
		private JButton getJButtonHinzuK() {
	//		final Verbrauchereingabe Ich = this;
			if (jButtonHinzuK == null) {
				jButtonHinzuK = new JButton();
				jButtonHinzuK.setText("Hinzufgen mit Gebudecharakteristik...");
				jButtonHinzuK.addActionListener(this);
				jButtonHinzuK.setPreferredSize(new Dimension(270, 26));
			}
			return jButtonHinzuK;
		}

	public void hinzufuegen(Verbraucher neu)
	{
		Verbraucherstring = jTextPaneVorhandene.getText() + "\n" + neu.toASCII() + "\n";
		aktualisieren.addActionListener(this);
//		aktualisieren.doClick();
	}

	protected void Uebernehmen() {
	//		Anzahl der Verbraucher in der Datei ermitteln
			String Dateiinhalt = jTextPaneVorhandene.getText();
			int pos = 0;
			int Verbraucherzahl = 0;
			int[] Startposition = new int[100]; //TODO maximal 100 Verbraucher
			int start = 0;
			int ende = 0;
			while ((pos = Dateiinhalt.indexOf("Name", start)) != -1)
			{
				Startposition[Verbraucherzahl] = pos;
				start = pos + 4;
				Verbraucherzahl++;
			}
			Verbraucher[] Verbraucherliste = new Verbraucher[Verbraucherzahl];
			for (int i=0; i<Verbraucherzahl; i++)
			{
				String Verbraucheri;
				double Endposition = Startposition[i+1];
				if (Endposition == 0)
					Verbraucheri = Dateiinhalt.substring(Startposition[i]);
				else
					Verbraucheri = Dateiinhalt.substring(Startposition[i], Startposition[i+1]);
	//			System.err.println("Verbraucher " + i + ":");
	//			System.out.println(Verbraucheri);
	
				start = Verbraucheri.indexOf("Name: ") + 6;
				ende = Verbraucheri.indexOf(" ",start);
				String Name = Verbraucheri.substring(start,ende);
				
				double[] Ort = new double[2];
				start = Verbraucheri.indexOf("Ort: ") + 5;
				ende = Verbraucheri.indexOf(" ",start);
				String Text = Verbraucheri.substring(start,ende);
				Ort[0] = Double.valueOf(Text).doubleValue();
				start = ende + 1;
				ende = Verbraucheri.indexOf(" ",start);
				Text = Verbraucheri.substring(start,ende);
				Ort[1] = Double.valueOf(Text).doubleValue();
				
				start = Verbraucheri.indexOf("Vorlauftemperatur: ") + 19;
				ende = Verbraucheri.indexOf(" ",start);
				Text = Verbraucheri.substring(start,ende);
				double Vorlauftemperatur = Double.valueOf(Text).doubleValue();
				
				if (Verbraucheri.indexOf("Stuetzstelle") == -1) //d.h. Verbraucher_k
				{
					
					start = Verbraucheri.indexOf("Nutzflaeche: ") + 13;
					ende = Verbraucheri.indexOf(" ",start);
					Text = Verbraucheri.substring(start,ende);
					double Nutzflaeche = Double.valueOf(Text).doubleValue();
					
					start = Verbraucheri.indexOf("Waermedurchgangswert: ") + 22;
					ende = Verbraucheri.indexOf(" ",start);
					Text = Verbraucheri.substring(start,ende);
					double Waermedurchgangswert = Double.valueOf(Text).doubleValue();
					
					start = Verbraucheri.indexOf("Raumsolltemperatur: ") + 20;
					ende = Verbraucheri.indexOf(" ",start);
					Text = Verbraucheri.substring(start,ende);
					double Raumsolltemperatur = Double.valueOf(Text).doubleValue();
					
					start = Verbraucheri.indexOf("Grundlast") + 11;
					ende = Verbraucheri.indexOf(" ",start);
					Text = Verbraucheri.substring(start,ende);
					double Grundlast = Double.valueOf(Text).doubleValue();
					
					start = Verbraucheri.indexOf("Nutzlast") + 10;
					ende = Verbraucheri.indexOf(" ",start);
					Text = Verbraucheri.substring(start,ende);
					double Nutzlast = Double.valueOf(Text).doubleValue();
					
					double[][] Nutzf = new double[3][24];
					start = Verbraucheri.indexOf("Nutzf: ") + 7;
					for (int j = 0; j<3; j++)
					{
						for (int k=0; k<24; k++)
						{
							if (j == 2 && k == 23)
							{
								ende = Verbraucheri.indexOf("\n",start);
							}
							else
								ende = Verbraucheri.indexOf(" ",start);
							Text = Verbraucheri.substring(start,ende);
							start = ende + 1;
							Nutzf[j][k]= Double.valueOf(Text).doubleValue();
						}
					}
					
					double[][] Lastf = new double[3][24];
					start = Verbraucheri.indexOf("Lastf: ") + 7;
					for (int j = 0; j<3; j++)
					{
						for (int k=0; k<24; k++)
						{
							if (j == 2 && k == 23)
							{
								ende = Verbraucheri.indexOf("\n",start);
							}
							else
								ende = Verbraucheri.indexOf(" ",start);
							Text = Verbraucheri.substring(start,ende);
							start = ende + 1;
							Lastf[j][k]= Double.valueOf(Text).doubleValue();
						}
					}
					Verbraucherliste[i] = new Verbraucher_k(Name, Ort, Nutzflaeche, Waermedurchgangswert, Raumsolltemperatur, Grundlast, Nutzlast, Lastf, Nutzf, Vorlauftemperatur);
	//				System.out.println((Verbraucherliste[i]).toASCII());
				}
				else
				{
					double[] temps = new double[3];
					double[] leistungen = new double[3];
					for (int m=0; m<3; m++)
					{
						start = Verbraucheri.indexOf("Stuetzstelle "+ String.valueOf(m+1) + ": ") + 16; // + m+1 + ": "
						ende = Verbraucheri.indexOf(" ",start);
						Text = Verbraucheri.substring(start,ende);
						temps[m] = Double.valueOf(Text).doubleValue();
						start = ende + 1;
						ende = Verbraucheri.indexOf(" ",start);
						Text = Verbraucheri.substring(start,ende);
						leistungen[m] = Double.valueOf(Text).doubleValue();
					}
					Verbraucherliste[i] = new Verbraucher_e(Name, Ort, Vorlauftemperatur, temps, leistungen);
				}
			}
			((Hauptfenster) getOwner()).verbraucher = Verbraucherliste;
			((Hauptfenster) getOwner()).konfig_freischalten();
		}

	private FVerbraucher_e getFVerbraucher_e()
	{
		if (FVerbraucher_e == null)
		{
			FVerbraucher_e = new FVerbraucher_e(this);
		}
		FVerbraucher_e.setVisible(true);
		return FVerbraucher_e;
	}

	private FVerbraucher_k getFVerbraucher_k()
	{
		if (FVerbraucher_k == null)
		{
			FVerbraucher_k = new FVerbraucher_k(this);
		}
		FVerbraucher_k.setVisible(true);
		return FVerbraucher_k;
	}
}
