package de.elisabetheckstaedt.dipl.GUI;

import javax.swing.JPanel;
import javax.swing.JDialog;
import javax.swing.JTabbedPane;
import java.awt.GridBagLayout;
import javax.swing.JComboBox;
import java.awt.GridBagConstraints;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JButton;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.NumberFormat;
import java.text.ParseException;
import java.util.ArrayList;

import de.elisabetheckstaedt.dipl.common.Einzelobjekt;
import de.elisabetheckstaedt.dipl.common.Helper;
import de.elisabetheckstaedt.dipl.common.Gesamtsystem;
import de.elisabetheckstaedt.dipl.real.AbKM;
import de.elisabetheckstaedt.dipl.real.Gebaeude;
import de.elisabetheckstaedt.dipl.real.KoKM;
import de.elisabetheckstaedt.dipl.real.Kaeltemaschine;
import de.elisabetheckstaedt.dipl.real.Teilsystem;
import de.elisabetheckstaedt.dipl.real.Kompaktanlage;
import de.elisabetheckstaedt.dipl.real.MSR;
import de.elisabetheckstaedt.dipl.real.Pumpe;
import de.elisabetheckstaedt.dipl.real.Rohrnetz;
import de.elisabetheckstaedt.dipl.real.Rueckkuehler;
import de.elisabetheckstaedt.dipl.real.Subnetz;
import de.elisabetheckstaedt.dipl.real.Verbraucher;
import javax.swing.JScrollPane;
import java.awt.Insets;
import java.awt.Color;

/**
 * enthlt alle nderbaren Zwischenwerte der Konfiguration und bietet Mglichkeit des Starts 
 * einer neuen Berechnung mit den ggf. genderten Werten
 * @author Elisabeth Eckstdt
 *
 */
public class Werteingabe extends JDialog implements ActionListener {

	private static final long serialVersionUID = 1L;
	
	JTextField[][] faktoren = new JTextField[10][5];
	
	final Gesamtsystem lv;
	Teilsystem kz;  //  @jve:decl-index=0:
	Subnetz tn;  //  @jve:decl-index=0:
	Kaeltemaschine km;
	Rueckkuehler rk;
	String[] namen_km;
	String[] namen_tn;
	Hauptfenster owner = null;
	Verbraucher[] verbraucher;
	JTextField[] Verbraucherinvestitionen;
	JLabel[] Verbrauchernamen;
	private JPanel jContentPane = null;

	private JTabbedPane jTabbedPane = null;

	private JPanel jPanelPreisdaten = null;

	private JPanel jPanelFaktoren = null;

	private JPanel jPanelTeilsysteme = null;

	private JComboBox jComboBoxKZ = null;

	private JLabel jLabelOrt = null;

	private JTextField jTextFieldOrtX = null;

	private JTextField jTextFieldOrtY = null;

	private JButton jButtonOrtStd = null;

	private JTabbedPane jTabbedPaneKZ = null;

	private JPanel jPanelTN = null;

	private JPanel jPanelKMRK = null;

	private JComboBox jComboBoxTN = new JComboBox();

	private JComboBox jComboBoxKMRK = new JComboBox();

	private JButton jButtonOK = null;

	private JButton jButtonAbbrechen = null;

	private JButton jButtonTNStd = null;

	private JButton jButtonKMRKStd = null;

	private JLabel jLabelRNdm = null;

	private JLabel jLabelRNebf = null;

	private JLabel jLabelRNlambda = null;

	private JLabel jLabelRNrl = null;

	private JLabel jLabelRNvl = null;

	private JLabel jLabelRN = null;

	private JLabel jLabelPumpe = null;

	private JLabel jLabelPfh = null;

	private JLabel jLabelPv = null;

	private JLabel jLabelPeta = null;

	private JTextField jTextFieldRNdm = null;

	private JTextField jTextFieldRNebf = null;

	private JTextField jTextFieldRNlambda = null;

	private JTextField jTextFieldRNrl = null;

	private JTextField jTextFieldRNvl = null;

	private JTextField jTextFieldPfh = null;

	private JTextField jTextFieldPv = null;

	private JTextField jTextFieldPeta = null;

	private JLabel jLabelRNInvest = null;

	private JTextField jTextFieldRNInvest = null;

	private JLabel jLabelPInvest = null;

	private JTextField jTextFieldPInvest = null;

	private JLabel jLabelKM = null;

	private JLabel jLabelKMnl = null;

	private JLabel jLabelKMwg = null;

	private JLabel jLabelKMwf = null;

	private JLabel jLabelKMha = null;

	private JLabel jLabelKMInvest = null;

	private JLabel jLabelRK = null;

	private JLabel jLabelRKnl = null;

	private JLabel jLabelRKha = null;

	private JLabel jLabelRKInvest = null;

	private JTextField jTextFieldKMnl = null;

	private JTextField jTextFieldKMwg = null;

	private JTextField jTextFieldKMwf = null;

	private JTextField jTextFieldKMha = null;

	private JTextField jTextFieldKMInvest = null;

	private JTextField jTextFieldRKnl = null;

	private JTextField jTextFieldRKha = null;

	private JTextField jTextFieldRKInvest = null;

	private JLabel jLabelBZR = null;

	private JLabel jLabelZinssatz = null;

	private JLabel jLabelStundenlohn = null;

	private JLabel jLabelStrompreis = null;

	private JLabel jLabelWaermepreis = null;

	private JLabel jLabelWasserpreis = null;

	private JLabel jLabelpaf_invest = null;

	private JLabel jLabelpaf_lohn = null;

	private JLabel jLabelpaf_energie = null;

	private JTextField jTextFieldbzr = null;

	private JTextField jTextFieldZinssatz = null;

	private JTextField jTextFieldpaf_invest = null;

	private JTextField jTextFieldStundenlohn = null;

	private JTextField jTextFieldpaf_lohn = null;

	private JTextField jTextFieldStrompreis = null;

	private JTextField jTextFieldWaermepreis = null;

	private JTextField jTextFieldWasserpreis = null;

	private JTextField jTextFieldpaf_energie = null;

	private JLabel jLabelNutzungsdauer = null;

	private JLabel jLabelInsta = null;

	private JLabel jLabelWartung = null;

	private JLabel jLabelInspektion = null;

	private JLabel jLabelBedienung = null;

	private JLabel jLabelProzent = null;

	private JLabel jLabelStunden = null;

	private JLabel jLabelAbKM = null;

	private JLabel jLabelKKM = null;

	private JLabel jLabelRK1 = null;

	private JLabel jLabelRohre = null;

	private JLabel jLabelPumpen = null;

	private JLabel jLabelVerbraucher = null;

	private JLabel jLabelKomplett = null;

	private JPanel jPanelVerbraucher = null;

	private JPanel jPanelZentrale = null;

	private JLabel jLabelGebaeude = null;

	private JLabel jLabelVerrohrung = null;

	private JLabel jLabelArmaturen = null;

	private JLabel jLabelMSR = null;

	private JLabel jLabelPumpenRK = null;

	private JLabel jLabelPumpenKM = null;

	private JTextField jTextFieldGebaeude = null;

	private JTextField jTextFieldVerrohrung = null;

	private JTextField jTextFieldArmaturen = null;

	private JTextField jTextFieldMSR = null;

	private JTextField jTextFieldPumpenRK = null;

	private JTextField jTextFieldPumpenKM = null;

	private JLabel jLabelFGebaeude = null;

	private JLabel jLabelFMSR = null;

	private JLabel jLabelFArmaturen = null;

	private JScrollPane jScrollPaneVerbraucher = null;

	private JPanel jPanelVerbraucher2 = null;

	private JTextField jTextFieldRohrkosten = null;

	private JLabel jLabelRohkosten = null;

	private JLabel jLabelTrassenkosten = null;

	private JTextField jTextFieldTrassenkosten = null;

	private JLabel jLabelJahresgesamtkosten = null;

	private JLabel jLabelErstinvestition = null;

	private JButton jButtonStdZentrale = null;

	private JPanel jPanelbunt = null;

	private JLabel jLabelZwischenergebnis = null;

	/**
	 * @param owner
	 * @param lv
	 */
	public Werteingabe(Hauptfenster owner, Gesamtsystem lv) {
		super(owner);
		this.owner = owner;
		this.lv = lv;
		verbraucher = lv.projekt.getVerbraucher();
		Verbraucherinvestitionen = new JTextField[verbraucher.length];
		Verbrauchernamen = new JLabel[verbraucher.length];
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
//		jComboBoxKMRK.setPreferredSize(new Dimension(200, 25));
//		jComboBoxTN.setPreferredSize(new Dimension(200, 25));
		this.setSize(843, 464);
		this.setTitle("DC/DEsign - IIIb - Parameter ndern");
		this.setContentPane(getJContentPane());
		jLabelJahresgesamtkosten.setText("Jahresgesamtkosten: " + Helper.Euroformat(lv.getKosten(), 0));
		jLabelErstinvestition.setText("Investition: " + Helper.Euroformat(lv.getInvestition(),0));
	}

	/**
	 * This method initializes jPanelInhalt
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			GridBagConstraints gridBagConstraints109 = new GridBagConstraints();
			gridBagConstraints109.gridx = 0;
			gridBagConstraints109.anchor = GridBagConstraints.WEST;
			gridBagConstraints109.fill = GridBagConstraints.NONE;
			gridBagConstraints109.gridwidth = 2;
			gridBagConstraints109.gridy = 0;
			jLabelJahresgesamtkosten = new JLabel("Jahresgesamtkosten");
			jLabelErstinvestition = new JLabel("Investition");
			
			
			
			jContentPane = new JPanel();
			jContentPane.setLayout(new GridBagLayout());

			jContentPane.setBackground(Color.lightGray);
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.fill = GridBagConstraints.BOTH;
			gridBagConstraints6.gridx = 0;
			gridBagConstraints6.gridy = 3;
			gridBagConstraints6.ipadx = 497;
			gridBagConstraints6.weightx = 1.0;
			gridBagConstraints6.weighty = 1.0;
			gridBagConstraints6.gridwidth = 2;
			
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.gridx = 0;
			gridBagConstraints7.weightx = 1.0;
			gridBagConstraints7.gridy = 4;
			
			
			GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
			gridBagConstraints9.gridx = 1;
			gridBagConstraints9.fill = GridBagConstraints.NONE;
			gridBagConstraints9.weightx = 1.0;
			gridBagConstraints9.gridy = 4;
			jContentPane.add(getJTabbedPane(), gridBagConstraints6);
			jContentPane.add(getJButtonOK(), gridBagConstraints7);
			jContentPane.add(getJButtonAbbrechen(), gridBagConstraints9);
			jContentPane.add(getJPanelbunt(), gridBagConstraints109);
		}
		return jContentPane;
	}

	/**
	 * This method initializes jTabbedPane	
	 * 	
	 * @return javax.swing.JTabbedPane	
	 */
	private JTabbedPane getJTabbedPane() {
		if (jTabbedPane == null) {
			jTabbedPane = new JTabbedPane();
			jTabbedPane.setName("Preisdaten");
			jTabbedPane.addTab("Preisdaten", null, getJPanelPreisdaten(), null);
			jTabbedPane.addTab("Faktoren", null, getJPanelFaktoren(), null);
			jTabbedPane.addTab("Teilsysteme", null, getJPanelTeilsysteme(), null);
			jTabbedPane.addTab("Verbraucheranschlussstellen", null, getJPanelVerbraucher(), null);
		}
		return jTabbedPane;
	}

	/**
	 * This method initializes jPanelPreisdaten	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelPreisdaten() {
		if (jPanelPreisdaten == null) {
			GridBagConstraints gridBagConstraints83 = new GridBagConstraints();
			gridBagConstraints83.fill = GridBagConstraints.BOTH;
			gridBagConstraints83.gridy = 11;
			gridBagConstraints83.weightx = 1.0;
			gridBagConstraints83.gridx = 1;
			GridBagConstraints gridBagConstraints82 = new GridBagConstraints();
			gridBagConstraints82.gridx = 0;
			gridBagConstraints82.gridy = 11;
			GridBagConstraints gridBagConstraints67 = new GridBagConstraints();
			gridBagConstraints67.fill = GridBagConstraints.NONE;
			gridBagConstraints67.gridy = 10;
			gridBagConstraints67.weightx = 1.0;
			gridBagConstraints67.anchor = GridBagConstraints.WEST;
			gridBagConstraints67.gridx = 1;
			GridBagConstraints gridBagConstraints66 = new GridBagConstraints();
			gridBagConstraints66.fill = GridBagConstraints.NONE;
			gridBagConstraints66.gridy = 7;
			gridBagConstraints66.weightx = 1.0;
			gridBagConstraints66.anchor = GridBagConstraints.WEST;
			gridBagConstraints66.gridx = 1;
			GridBagConstraints gridBagConstraints65 = new GridBagConstraints();
			gridBagConstraints65.fill = GridBagConstraints.NONE;
			gridBagConstraints65.gridy = 6;
			gridBagConstraints65.weightx = 1.0;
			gridBagConstraints65.anchor = GridBagConstraints.WEST;
			gridBagConstraints65.gridx = 1;
			GridBagConstraints gridBagConstraints64 = new GridBagConstraints();
			gridBagConstraints64.fill = GridBagConstraints.NONE;
			gridBagConstraints64.gridy = 5;
			gridBagConstraints64.weightx = 1.0;
			gridBagConstraints64.anchor = GridBagConstraints.WEST;
			gridBagConstraints64.gridx = 1;
			GridBagConstraints gridBagConstraints63 = new GridBagConstraints();
			gridBagConstraints63.fill = GridBagConstraints.NONE;
			gridBagConstraints63.gridy = 4;
			gridBagConstraints63.weightx = 1.0;
			gridBagConstraints63.anchor = GridBagConstraints.WEST;
			gridBagConstraints63.gridx = 1;
			GridBagConstraints gridBagConstraints62 = new GridBagConstraints();
//			gridBagConstraints62.fill = GridBagConstraints.BOTH;
			gridBagConstraints62.gridy = 3;
			gridBagConstraints62.weightx = 1.0;
			gridBagConstraints62.anchor = GridBagConstraints.WEST;
			gridBagConstraints62.fill = GridBagConstraints.NONE;
			gridBagConstraints62.gridx = 1;
			GridBagConstraints gridBagConstraints61 = new GridBagConstraints();
			gridBagConstraints61.fill = GridBagConstraints.NONE;
			gridBagConstraints61.gridy = 2;
			gridBagConstraints61.weightx = 1.0;
			gridBagConstraints61.anchor = GridBagConstraints.WEST;
			gridBagConstraints61.gridx = 1;
			GridBagConstraints gridBagConstraints60 = new GridBagConstraints();
			gridBagConstraints60.fill = GridBagConstraints.NONE;
			gridBagConstraints60.gridy = 1;
			gridBagConstraints60.weightx = 1.0;
			gridBagConstraints60.anchor = GridBagConstraints.WEST;
			gridBagConstraints60.gridx = 1;
			GridBagConstraints gridBagConstraints59 = new GridBagConstraints();
			gridBagConstraints59.fill = GridBagConstraints.NONE;
			gridBagConstraints59.gridy = 0;
			gridBagConstraints59.weightx = 1.0;
			gridBagConstraints59.anchor = GridBagConstraints.WEST;
			gridBagConstraints59.gridx = 1;
			GridBagConstraints gridBagConstraints58 = new GridBagConstraints();
			gridBagConstraints58.gridx = 0;
			gridBagConstraints58.anchor = GridBagConstraints.EAST;
			gridBagConstraints58.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints58.gridy = 10;
			jLabelpaf_energie = new JLabel();
			jLabelpaf_energie.setText("Preisnderungsfaktor Energie [1]");
			GridBagConstraints gridBagConstraints57 = new GridBagConstraints();
			gridBagConstraints57.gridx = 0;
			gridBagConstraints57.anchor = GridBagConstraints.EAST;
			gridBagConstraints57.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints57.gridy = 4;
			jLabelpaf_lohn = new JLabel();
			jLabelpaf_lohn.setText("Preisnderungsfaktor Lohn [1]");
			GridBagConstraints gridBagConstraints56 = new GridBagConstraints();
			gridBagConstraints56.gridx = 0;
			gridBagConstraints56.anchor = GridBagConstraints.EAST;
			gridBagConstraints56.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints56.gridy = 2;
			jLabelpaf_invest = new JLabel();
			jLabelpaf_invest.setText("Preisnderungsfaktor Investitionen [1]");
			GridBagConstraints gridBagConstraints55 = new GridBagConstraints();
			gridBagConstraints55.gridx = 0;
			gridBagConstraints55.anchor = GridBagConstraints.EAST;
			gridBagConstraints55.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints55.gridy = 7;
			jLabelWasserpreis = new JLabel();
			jLabelWasserpreis.setText("Wasserpreis [/m]");
			GridBagConstraints gridBagConstraints54 = new GridBagConstraints();
			gridBagConstraints54.gridx = 0;
			gridBagConstraints54.anchor = GridBagConstraints.EAST;
			gridBagConstraints54.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints54.gridy = 6;
			jLabelWaermepreis = new JLabel();
			jLabelWaermepreis.setText("Wrmepreis [/kWh]");
			GridBagConstraints gridBagConstraints53 = new GridBagConstraints();
			gridBagConstraints53.gridx = 0;
			gridBagConstraints53.anchor = GridBagConstraints.EAST;
			gridBagConstraints53.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints53.gridy = 5;
			jLabelStrompreis = new JLabel();
			jLabelStrompreis.setText("Strompreis [/kWh]");
			GridBagConstraints gridBagConstraints52 = new GridBagConstraints();
			gridBagConstraints52.gridx = 0;
			gridBagConstraints52.anchor = GridBagConstraints.EAST;
			gridBagConstraints52.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints52.gridy = 3;
			jLabelStundenlohn = new JLabel();
			jLabelStundenlohn.setText("Stundenlohn arbeitgeberseitig [/h]");
			GridBagConstraints gridBagConstraints51 = new GridBagConstraints();
			gridBagConstraints51.gridx = 0;
			gridBagConstraints51.anchor = GridBagConstraints.EAST;
			gridBagConstraints51.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints51.gridy = 1;
			jLabelZinssatz = new JLabel();
			jLabelZinssatz.setText("Zinssatz [1]");
			GridBagConstraints gridBagConstraints50 = new GridBagConstraints();
			gridBagConstraints50.gridx = 0;
			gridBagConstraints50.anchor = GridBagConstraints.EAST;
			gridBagConstraints50.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints50.gridy = 0;
			jLabelBZR = new JLabel();
			jLabelBZR.setText("Betrachtungszeitraum [a]");
			jPanelPreisdaten = new JPanel();
			jPanelPreisdaten.setLayout(new GridBagLayout());
			jPanelPreisdaten.add(jLabelBZR, gridBagConstraints50);
			jPanelPreisdaten.add(jLabelZinssatz, gridBagConstraints51);
			jPanelPreisdaten.add(jLabelStundenlohn, gridBagConstraints52);
			jPanelPreisdaten.add(jLabelStrompreis, gridBagConstraints53);
			jPanelPreisdaten.add(jLabelWaermepreis, gridBagConstraints54);
			jPanelPreisdaten.add(jLabelWasserpreis, gridBagConstraints55);
			jPanelPreisdaten.add(jLabelpaf_invest, gridBagConstraints56);
			jPanelPreisdaten.add(jLabelpaf_lohn, gridBagConstraints57);
			jPanelPreisdaten.add(jLabelpaf_energie, gridBagConstraints58);
			jPanelPreisdaten.add(getJTextFieldbzr(), gridBagConstraints59);
			jPanelPreisdaten.add(getJTextFieldZinssatz(), gridBagConstraints60);
			jPanelPreisdaten.add(getJTextFieldpaf_invest(), gridBagConstraints61);
			jPanelPreisdaten.add(getJTextFieldStundenlohn(), gridBagConstraints62);
			jPanelPreisdaten.add(getJTextFieldpaf_lohn(), gridBagConstraints63);
			jPanelPreisdaten.add(getJTextFieldStrompreis(), gridBagConstraints64);
			jPanelPreisdaten.add(getJTextFieldWaermepreis(), gridBagConstraints65);
			jPanelPreisdaten.add(getJTextFieldWasserpreis(), gridBagConstraints66);
			jPanelPreisdaten.add(getJTextFieldpaf_energie(), gridBagConstraints67);
		}
		return jPanelPreisdaten;
	}

	/**
	 * This method initializes jPanelFaktoren	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelFaktoren() {
		if (jPanelFaktoren == null) {
			GridBagConstraints gridBagConstraints98 = new GridBagConstraints();
			gridBagConstraints98.gridx = 0;
			gridBagConstraints98.anchor = GridBagConstraints.EAST;
			gridBagConstraints98.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints98.gridy = 11;
			jLabelFArmaturen = new JLabel();
			jLabelFArmaturen.setText("Armaturen");
			GridBagConstraints gridBagConstraints97 = new GridBagConstraints();
			gridBagConstraints97.gridx = 0;
			gridBagConstraints97.anchor = GridBagConstraints.EAST;
			gridBagConstraints97.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints97.gridy = 10;
			jLabelFMSR = new JLabel();
			jLabelFMSR.setText("Mess-, Steuer-, Regelungstechnik");
			GridBagConstraints gridBagConstraints96 = new GridBagConstraints();
			gridBagConstraints96.gridx = 0;
			gridBagConstraints96.anchor = GridBagConstraints.EAST;
			gridBagConstraints96.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints96.gridy = 9;
			jLabelFGebaeude = new JLabel();
			jLabelFGebaeude.setText("Gebude");
			GridBagConstraints gridBagConstraints81 = new GridBagConstraints();
			gridBagConstraints81.gridx = 0;
			gridBagConstraints81.anchor = GridBagConstraints.EAST;
			gridBagConstraints81.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints81.gridy = 8;
			jLabelKomplett = new JLabel();
			jLabelKomplett.setText("Komplettanlagen");
			GridBagConstraints gridBagConstraints80 = new GridBagConstraints();
			gridBagConstraints80.gridx = 0;
			gridBagConstraints80.anchor = GridBagConstraints.EAST;
			gridBagConstraints80.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints80.gridy = 7;
			jLabelVerbraucher = new JLabel();
			jLabelVerbraucher.setText("Verbraucheranschlussstellen");
			GridBagConstraints gridBagConstraints79 = new GridBagConstraints();
			gridBagConstraints79.gridx = 0;
			gridBagConstraints79.anchor = GridBagConstraints.EAST;
			gridBagConstraints79.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints79.gridy = 6;
			jLabelPumpen = new JLabel();
			jLabelPumpen.setText("Pumpen");
			GridBagConstraints gridBagConstraints78 = new GridBagConstraints();
			gridBagConstraints78.gridx = 0;
			gridBagConstraints78.anchor = GridBagConstraints.EAST;
			gridBagConstraints78.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints78.gridy = 5;
			jLabelRohre = new JLabel();
			jLabelRohre.setText("Rohre");
			GridBagConstraints gridBagConstraints77 = new GridBagConstraints();
			gridBagConstraints77.gridx = 0;
			gridBagConstraints77.anchor = GridBagConstraints.EAST;
			gridBagConstraints77.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints77.gridy = 4;
			jLabelRK1 = new JLabel();
			jLabelRK1.setText("Rckkhler");
			GridBagConstraints gridBagConstraints76 = new GridBagConstraints();
			gridBagConstraints76.gridx = 0;
			gridBagConstraints76.anchor = GridBagConstraints.EAST;
			gridBagConstraints76.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints76.gridy = 3;
			jLabelKKM = new JLabel();
			jLabelKKM.setText("Kompressionskltemaschinen");
			GridBagConstraints gridBagConstraints75 = new GridBagConstraints();
			gridBagConstraints75.gridx = 0;
			gridBagConstraints75.anchor = GridBagConstraints.EAST;
			gridBagConstraints75.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints75.gridy = 2;
			jLabelAbKM = new JLabel();
			jLabelAbKM.setText("Absorptionskltemaschinen");
			GridBagConstraints gridBagConstraints74 = new GridBagConstraints();
			gridBagConstraints74.gridx = 4;
			gridBagConstraints74.gridwidth = 2;
			gridBagConstraints74.gridy = 1;
			jLabelStunden = new JLabel();
			jLabelStunden.setText("[h/a]");
			GridBagConstraints gridBagConstraints73 = new GridBagConstraints();
			gridBagConstraints73.gridx = 2;
			gridBagConstraints73.gridwidth = 2;
			gridBagConstraints73.gridy = 1;
			jLabelProzent = new JLabel();
			jLabelProzent.setText("[% der Investitionssumme pro Jahr]");
			GridBagConstraints gridBagConstraints72 = new GridBagConstraints();
			gridBagConstraints72.gridx = 5;
			gridBagConstraints72.insets = new Insets(0, 5, 0, 5);
			gridBagConstraints72.gridy = 0;
			jLabelBedienung = new JLabel();
			jLabelBedienung.setText("Bedienungsaufwand");
			GridBagConstraints gridBagConstraints71 = new GridBagConstraints();
			gridBagConstraints71.gridx = 4;
			gridBagConstraints71.insets = new Insets(0, 5, 0, 5);
			gridBagConstraints71.gridy = 0;
			jLabelInspektion = new JLabel();
			jLabelInspektion.setText("Inspektionsaufwand");
			GridBagConstraints gridBagConstraints70 = new GridBagConstraints();
			gridBagConstraints70.gridx = 3;
			gridBagConstraints70.insets = new Insets(0, 5, 0, 5);
			gridBagConstraints70.gridy = 0;
			jLabelWartung = new JLabel();
			jLabelWartung.setText("Wartungsaufwand");
			GridBagConstraints gridBagConstraints69 = new GridBagConstraints();
			gridBagConstraints69.gridx = 2;
			gridBagConstraints69.insets = new Insets(0, 5, 0, 5);
			gridBagConstraints69.gridy = 0;
			jLabelInsta = new JLabel();
			jLabelInsta.setText("Instandhaltungsaufwand");
			GridBagConstraints gridBagConstraints68 = new GridBagConstraints();
			gridBagConstraints68.gridx = 1;
			gridBagConstraints68.insets = new Insets(0, 5, 0, 5);
			gridBagConstraints68.gridy = 0;
			jLabelNutzungsdauer = new JLabel();
			jLabelNutzungsdauer.setText("Nutzungsdauer [a]");
			jPanelFaktoren = new JPanel();
			
			double[][] Wert = {{15, 1.5, 1, 0, 0},
					{15,2,1,0,1},
					{20,2,1,0,0},
					{40,1,0,0,0},
					{10,1,0,0,0},
					{20,2,10,0,0},
					{15,2,1,0,1},
					{50,1,1,0,0},
					{15,1.5,1,0,0},
					{20,1.5,0,0,0}};
			
			jPanelFaktoren.setLayout(new GridBagLayout());
			jPanelFaktoren.add(jLabelNutzungsdauer, gridBagConstraints68);
			jPanelFaktoren.add(jLabelInsta, gridBagConstraints69);
			jPanelFaktoren.add(jLabelWartung, gridBagConstraints70);
			jPanelFaktoren.add(jLabelInspektion, gridBagConstraints71);
			jPanelFaktoren.add(jLabelBedienung, gridBagConstraints72);
			jPanelFaktoren.add(jLabelProzent, gridBagConstraints73);
			jPanelFaktoren.add(jLabelStunden, gridBagConstraints74);
			jPanelFaktoren.add(jLabelAbKM, gridBagConstraints75);
			jPanelFaktoren.add(jLabelKKM, gridBagConstraints76);
			jPanelFaktoren.add(jLabelRK1, gridBagConstraints77);
			jPanelFaktoren.add(jLabelRohre, gridBagConstraints78);
			jPanelFaktoren.add(jLabelPumpen, gridBagConstraints79);
			jPanelFaktoren.add(jLabelVerbraucher, gridBagConstraints80);
			jPanelFaktoren.add(jLabelKomplett, gridBagConstraints81);
			jPanelFaktoren.add(jLabelFGebaeude, gridBagConstraints96);
			jPanelFaktoren.add(jLabelFMSR, gridBagConstraints97);
			jPanelFaktoren.add(jLabelFArmaturen, gridBagConstraints98);
			for (int i = 0; i<10; i++)
			{
				for (int j=0; j<5; j++)
				{
					faktoren[i][j] = new JTextField(Helper.Zahlformat(Wert[i][j], 3));
					faktoren[i][j].setColumns(5);
					GridBagConstraints gbc_f = new GridBagConstraints();
					gbc_f.gridx = j+1;
					gbc_f.gridy = i+2;
//					gbc_f.fill = GridBagConstraints.BOTH;
					jPanelFaktoren.add(faktoren[i][j], gbc_f);
				}
			}
			
//			GridBagConstraints gbc_f = new GridBagConstraints();
//			gbc_f.gridx = 0+1;
//			gbc_f.gridy = 0+2;
//			gbc_f.fill = GridBagConstraints.BOTH;
//			jPanelFaktoren.add(new JTextField(Helper.Zahlformat(Wert[0][0],3)),gbc_f);
//			 new GridBagConstraints(1,2,1,1,1,1,1,GridBagConstraints.BOTH, null, 0,0)
		}
		return jPanelFaktoren;
	}

	/**
	 * This method initializes jPanelTeilsysteme	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelTeilsysteme() {
		if (jPanelTeilsysteme == null) {
			GridBagConstraints gridBagConstraints210 = new GridBagConstraints();
			gridBagConstraints210.fill = GridBagConstraints.NONE;
			gridBagConstraints210.gridy = 0;
			gridBagConstraints210.gridx = 4;
			GridBagConstraints gridBagConstraints110 = new GridBagConstraints();
			gridBagConstraints110.fill = GridBagConstraints.NONE;
			gridBagConstraints110.gridy = 0;
			gridBagConstraints110.insets = new Insets(0, 10, 0, 0);
			gridBagConstraints110.gridx = 1;
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.fill = GridBagConstraints.BOTH;
			gridBagConstraints3.weighty = 1.0;
			gridBagConstraints3.gridx = 0;
			gridBagConstraints3.gridy = 1;
			gridBagConstraints3.gridwidth = 5;
			gridBagConstraints3.insets = new Insets(10, 0, 0, 0);
			gridBagConstraints3.weightx = 1.0;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.fill = GridBagConstraints.NONE;
			gridBagConstraints2.gridx = 3;
			gridBagConstraints2.gridy = 0;
			gridBagConstraints2.weightx = 1.0;
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.fill = GridBagConstraints.NONE;
			gridBagConstraints1.gridx = 2;
			gridBagConstraints1.gridy = 0;
			gridBagConstraints1.weightx = 1.0;
			jLabelOrt = new JLabel();
			jLabelOrt.setText("Ort (X,Y) [m]");
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 0;
			gridBagConstraints.weightx = 1.0;
			jPanelTeilsysteme = new JPanel();
			jPanelTeilsysteme.setLayout(new GridBagLayout());
			jPanelTeilsysteme.add(getJComboBoxKZ(), gridBagConstraints);
			jPanelTeilsysteme.add(jLabelOrt, gridBagConstraints110);
			jPanelTeilsysteme.add(getJTextFieldOrtX(), gridBagConstraints1);
			jPanelTeilsysteme.add(getJTextFieldOrtY(), gridBagConstraints2);
			jPanelTeilsysteme.add(getJButtonOrtStd(), gridBagConstraints210);
			jPanelTeilsysteme.add(getJTabbedPaneKZ(), gridBagConstraints3);
			kz_laden(0); 
			tn_laden(0);
			km_laden(0);
		}
		return jPanelTeilsysteme;
	}

	/**
	 * This method initializes jComboBoxKZ	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJComboBoxKZ() {
		if (jComboBoxKZ == null) {
			int anzahl = lv.teilsysteme.length;
			String[] kz_namen = new String[anzahl];
			for (int i=0; i<anzahl; i++)
			{
				kz_namen[i] = lv.teilsysteme[i].getName();
			}
			jComboBoxKZ = new JComboBox(kz_namen);
			jComboBoxKZ.setName("zu bearbeitendes Teilsystem whlen");
			jComboBoxKZ.setPreferredSize(new Dimension(200, 25));
			jComboBoxKZ.addActionListener(this);
		}
		return jComboBoxKZ;
	}

	/**
	 * This method initializes jTextFieldOrtX	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldOrtX() {
		if (jTextFieldOrtX == null) {
			jTextFieldOrtX = new JTextField();
//			jTextFieldOrtX.setPreferredSize(new Dimension(20, 20));
			jTextFieldOrtX.setColumns(7);
			jTextFieldOrtX.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					double[] ortneu = {einlesen(jTextFieldOrtX),
							einlesen(jTextFieldOrtY)};
					kz.setOrt(
							ortneu,
							lv.projekt.getKDS().getAussentemperatur());
					RNrl_akt();
					RNvl_akt();
					RNInvest_akt();
					Pfh_akt();
					PInvest_akt();
				}
			});
			jTextFieldOrtX.addActionListener(this);
		}
		return jTextFieldOrtX;
	}

	/**
	 * This method initializes jTextFieldOrtY	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldOrtY() {
		if (jTextFieldOrtY == null) {
			jTextFieldOrtY = new JTextField();
//			jTextFieldOrtY.setPreferredSize(new Dimension(20, 20));
			jTextFieldOrtY.setColumns(7);
			jTextFieldOrtY.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					double[] ortneu = {einlesen(jTextFieldOrtX),
							einlesen(jTextFieldOrtY)};
					kz.setOrt(
							ortneu,
							lv.projekt.getKDS().getAussentemperatur());
					RNrl_akt();
					RNvl_akt();
					RNInvest_akt();
					Pfh_akt();
					PInvest_akt();
				}
			});
			jTextFieldOrtY.addActionListener(this);
		}
		return jTextFieldOrtY;
	}

	/**
	 * This method initializes jButtonOrtStd	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonOrtStd() {
		if (jButtonOrtStd == null) {
			jButtonOrtStd = new JButton();
			jButtonOrtStd.setText("Standardwert setzen");
			jButtonOrtStd.setEnabled(false);
		}
		return jButtonOrtStd;
	}

	/**
	 * This method initializes jTabbedPaneKZ	
	 * 	
	 * @return javax.swing.JTabbedPane	
	 */
	private JTabbedPane getJTabbedPaneKZ() {
		if (jTabbedPaneKZ == null) {
			jTabbedPaneKZ = new JTabbedPane();
			jTabbedPaneKZ.setName("Zentrale");
			jTabbedPaneKZ.addTab("Zentrale", null, getJPanelZentrale(), null);
			jTabbedPaneKZ.addTab("Subnetze", null, getJPanelTN(), null);
			jTabbedPaneKZ.addTab("Kltemaschinen & Rckkhler", null, getJPanelKMRK(), null);
		}
		return jTabbedPaneKZ;
	}

	/**
	 * This method initializes jPanelTN	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelTN() {
		if (jPanelTN == null) {
			GridBagConstraints gridBagConstraints104 = new GridBagConstraints();
			gridBagConstraints104.fill = GridBagConstraints.NONE;
			gridBagConstraints104.gridy = 7;
			gridBagConstraints104.weightx = 1.0;
			gridBagConstraints104.anchor = GridBagConstraints.WEST;
			gridBagConstraints104.gridx = 1;
			GridBagConstraints gridBagConstraints103 = new GridBagConstraints();
			gridBagConstraints103.gridx = 0;
			gridBagConstraints103.anchor = GridBagConstraints.EAST;
			gridBagConstraints103.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints103.gridy = 7;
			jLabelTrassenkosten = new JLabel();
			jLabelTrassenkosten.setText("Trassenkosten [/m]");
			GridBagConstraints gridBagConstraints102 = new GridBagConstraints();
			gridBagConstraints102.gridx = 3;
			gridBagConstraints102.gridy = 0;
			GridBagConstraints gridBagConstraints101 = new GridBagConstraints();
			gridBagConstraints101.gridx = 0;
			gridBagConstraints101.anchor = GridBagConstraints.EAST;
			gridBagConstraints101.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints101.gridy = 5;
			jLabelRohkosten = new JLabel();
			jLabelRohkosten.setText("Rohrkosten [/m]");
			GridBagConstraints gridBagConstraints100 = new GridBagConstraints();
			gridBagConstraints100.fill = GridBagConstraints.NONE;
			gridBagConstraints100.gridy = 5;
			gridBagConstraints100.weightx = 1.0;
			gridBagConstraints100.anchor = GridBagConstraints.WEST;
			gridBagConstraints100.gridx = 1;
			GridBagConstraints gridBagConstraints31 = new GridBagConstraints();
			gridBagConstraints31.fill = GridBagConstraints.NONE;
			gridBagConstraints31.gridy = 13;
			gridBagConstraints31.weightx = 1.0;
			gridBagConstraints31.anchor = GridBagConstraints.WEST;
			gridBagConstraints31.gridx = 3;
			GridBagConstraints gridBagConstraints30 = new GridBagConstraints();
			gridBagConstraints30.gridx = 2;
			gridBagConstraints30.gridy = 13;
			jLabelPInvest = new JLabel();
			jLabelPInvest.setText("Investition []");
			GridBagConstraints gridBagConstraints29 = new GridBagConstraints();
			gridBagConstraints29.fill = GridBagConstraints.NONE;
			gridBagConstraints29.gridy = 8;
			gridBagConstraints29.weightx = 1.0;
			gridBagConstraints29.anchor = GridBagConstraints.WEST;
			gridBagConstraints29.gridx = 3;
			GridBagConstraints gridBagConstraints28 = new GridBagConstraints();
			gridBagConstraints28.gridx = 2;
			gridBagConstraints28.anchor = GridBagConstraints.EAST;
			gridBagConstraints28.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints28.gridy = 8;
			jLabelRNInvest = new JLabel();
			jLabelRNInvest.setText("Investition []");
			GridBagConstraints gridBagConstraints27 = new GridBagConstraints();
			gridBagConstraints27.fill = GridBagConstraints.NONE;
			gridBagConstraints27.gridy = 12;
			gridBagConstraints27.weightx = 1.0;
			gridBagConstraints27.anchor = GridBagConstraints.WEST;
			gridBagConstraints27.gridx = 3;
			GridBagConstraints gridBagConstraints26 = new GridBagConstraints();
			gridBagConstraints26.fill = GridBagConstraints.NONE;
			gridBagConstraints26.gridy = 11;
			gridBagConstraints26.weightx = 1.0;
			gridBagConstraints26.anchor = GridBagConstraints.WEST;
			gridBagConstraints26.gridx = 3;
			GridBagConstraints gridBagConstraints25 = new GridBagConstraints();
			gridBagConstraints25.fill = GridBagConstraints.NONE;
			gridBagConstraints25.gridy = 10;
			gridBagConstraints25.weightx = 1.0;
			gridBagConstraints25.anchor = GridBagConstraints.WEST;
			gridBagConstraints25.gridx = 3;
			GridBagConstraints gridBagConstraints24 = new GridBagConstraints();
			gridBagConstraints24.fill = GridBagConstraints.NONE;
			gridBagConstraints24.gridy = 7;
			gridBagConstraints24.weightx = 1.0;
			gridBagConstraints24.anchor = GridBagConstraints.WEST;
			gridBagConstraints24.gridx = 3;
			GridBagConstraints gridBagConstraints23 = new GridBagConstraints();
			gridBagConstraints23.fill = GridBagConstraints.NONE;
			gridBagConstraints23.gridy = 5;
			gridBagConstraints23.weightx = 1.0;
			gridBagConstraints23.anchor = GridBagConstraints.WEST;
			gridBagConstraints23.gridx = 3;
			GridBagConstraints gridBagConstraints22 = new GridBagConstraints();
			gridBagConstraints22.fill = GridBagConstraints.NONE;
			gridBagConstraints22.gridy = 4;
			gridBagConstraints22.weightx = 1.0;
			gridBagConstraints22.anchor = GridBagConstraints.WEST;
			gridBagConstraints22.gridx = 3;
			GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
			gridBagConstraints21.fill = GridBagConstraints.NONE;
			gridBagConstraints21.gridy = 3;
			gridBagConstraints21.weightx = 1.0;
			gridBagConstraints21.anchor = GridBagConstraints.WEST;
			gridBagConstraints21.gridx = 3;
			GridBagConstraints gridBagConstraints20 = new GridBagConstraints();
			gridBagConstraints20.fill = GridBagConstraints.NONE;
			gridBagConstraints20.gridy = 2;
			gridBagConstraints20.weightx = 4.0;
			gridBagConstraints20.anchor = GridBagConstraints.WEST;
			gridBagConstraints20.gridx = 3;
			GridBagConstraints gridBagConstraints19 = new GridBagConstraints();
			gridBagConstraints19.gridx = 2;
			gridBagConstraints19.anchor = GridBagConstraints.EAST;
			gridBagConstraints19.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints19.gridy = 12;
			jLabelPeta = new JLabel();
			jLabelPeta.setText("eta_ges [1]");
			GridBagConstraints gridBagConstraints18 = new GridBagConstraints();
			gridBagConstraints18.gridx = 2;
			gridBagConstraints18.anchor = GridBagConstraints.EAST;
			gridBagConstraints18.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints18.gridy = 11;
			jLabelPv = new JLabel();
			jLabelPv.setText("Volumenstrom [m/s]");
			GridBagConstraints gridBagConstraints17 = new GridBagConstraints();
			gridBagConstraints17.gridx = 2;
			gridBagConstraints17.anchor = GridBagConstraints.EAST;
			gridBagConstraints17.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints17.gridy = 10;
			jLabelPfh = new JLabel();
			jLabelPfh.setText("Frderhhe [m]");
			GridBagConstraints gridBagConstraints16 = new GridBagConstraints();
			gridBagConstraints16.gridx = 2;
			gridBagConstraints16.anchor = GridBagConstraints.CENTER;
			gridBagConstraints16.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints16.gridy = 9;
			jLabelPumpe = new JLabel();
			jLabelPumpe.setText("Pumpe");
			GridBagConstraints gridBagConstraints15 = new GridBagConstraints();
			gridBagConstraints15.gridx = 2;
			gridBagConstraints15.anchor = GridBagConstraints.CENTER;
			gridBagConstraints15.gridy = 1;
			jLabelRN = new JLabel();
			jLabelRN.setText("Rohrnetz");
			GridBagConstraints gridBagConstraints14 = new GridBagConstraints();
			gridBagConstraints14.gridx = 2;
			gridBagConstraints14.anchor = GridBagConstraints.EAST;
			gridBagConstraints14.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints14.gridy = 7;
			jLabelRNvl = new JLabel();
			jLabelRNvl.setText("Trassenlnge [m]");
			GridBagConstraints gridBagConstraints13 = new GridBagConstraints();
			gridBagConstraints13.gridx = 2;
			gridBagConstraints13.anchor = GridBagConstraints.EAST;
			gridBagConstraints13.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints13.gridy = 5;
			jLabelRNrl = new JLabel();
			jLabelRNrl.setText("Rohrlnge [m]");
			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			gridBagConstraints12.gridx = 2;
			gridBagConstraints12.anchor = GridBagConstraints.EAST;
			gridBagConstraints12.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints12.gridy = 4;
			jLabelRNlambda = new JLabel();
			jLabelRNlambda.setText("lambda [1]");
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.gridx = 2;
			gridBagConstraints11.anchor = GridBagConstraints.EAST;
			gridBagConstraints11.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints11.gridy = 3;
			jLabelRNebf = new JLabel();
			jLabelRNebf.setText("Fakor fr Einbauten [1]");
			GridBagConstraints gridBagConstraints10 = new GridBagConstraints();
			gridBagConstraints10.gridx = 2;
			gridBagConstraints10.anchor = GridBagConstraints.EAST;
			gridBagConstraints10.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints10.gridy = 2;
			jLabelRNdm = new JLabel();
			jLabelRNdm.setText("Rohrdurchmesser [mm]");
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints4.gridx = 0;
			gridBagConstraints4.gridy = 0;
			gridBagConstraints4.gridwidth = 3;
			gridBagConstraints4.gridheight = 1;
//			gridBagConstraints4.weightx = 1.0;
			jPanelTN = new JPanel();
			jPanelTN.setLayout(new GridBagLayout());
			jPanelTN.add(getJComboBoxTN(), gridBagConstraints4);
			jPanelTN.add(getJButtonTNStd(), gridBagConstraints102);
			jPanelTN.add(jLabelRNdm, gridBagConstraints10);
			jPanelTN.add(jLabelRNebf, gridBagConstraints11);
			jPanelTN.add(jLabelRNlambda, gridBagConstraints12);
			jPanelTN.add(jLabelRNrl, gridBagConstraints13);
			jPanelTN.add(jLabelRNvl, gridBagConstraints14);
			jPanelTN.add(jLabelRN, gridBagConstraints15);
			jPanelTN.add(jLabelPumpe, gridBagConstraints16);
			jPanelTN.add(jLabelPfh, gridBagConstraints17);
			jPanelTN.add(jLabelPv, gridBagConstraints18);
			jPanelTN.add(jLabelPeta, gridBagConstraints19);
			jPanelTN.add(getJTextFieldRNdm(), gridBagConstraints20);
			jPanelTN.add(getJTextFieldRNebf(), gridBagConstraints21);
			jPanelTN.add(getJTextFieldRNlambda(), gridBagConstraints22);
			jPanelTN.add(getJTextFieldRNrl(), gridBagConstraints23);
			jPanelTN.add(getJTextFieldRNvl(), gridBagConstraints24);
			jPanelTN.add(getJTextFieldPfh(), gridBagConstraints25);
			jPanelTN.add(getJTextFieldPv(), gridBagConstraints26);
			jPanelTN.add(getJTextFieldPeta(), gridBagConstraints27);
			jPanelTN.add(jLabelRNInvest, gridBagConstraints28);
			jPanelTN.add(getJTextFieldRNInvest(), gridBagConstraints29);
			jPanelTN.add(jLabelPInvest, gridBagConstraints30);
			jPanelTN.add(getJTextFieldPInvest(), gridBagConstraints31);
			jPanelTN.add(getJTextFieldRohrkosten(), gridBagConstraints100);
			jPanelTN.add(jLabelRohkosten, gridBagConstraints101);
			jPanelTN.add(jLabelTrassenkosten, gridBagConstraints103);
			jPanelTN.add(getJTextFieldTrassenkosten(), gridBagConstraints104);
		}
		return jPanelTN;
	}

	/**
	 * This method initializes jPanelKMRK	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelKMRK() {
		if (jPanelKMRK == null) {
			GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
			gridBagConstraints8.gridy = 0;
			gridBagConstraints8.gridx = 1;
			GridBagConstraints gridBagConstraints49 = new GridBagConstraints();
			gridBagConstraints49.fill = GridBagConstraints.NONE;
			gridBagConstraints49.gridy = 10;
			gridBagConstraints49.weightx = 1.0;
			gridBagConstraints49.anchor = GridBagConstraints.WEST;
			gridBagConstraints49.gridx = 1;
			GridBagConstraints gridBagConstraints48 = new GridBagConstraints();
			gridBagConstraints48.fill = GridBagConstraints.NONE;
			gridBagConstraints48.gridy = 9;
			gridBagConstraints48.weightx = 1.0;
			gridBagConstraints48.anchor = GridBagConstraints.WEST;
			gridBagConstraints48.gridx = 1;
			GridBagConstraints gridBagConstraints47 = new GridBagConstraints();
			gridBagConstraints47.fill = GridBagConstraints.NONE;
			gridBagConstraints47.gridy = 8;
			gridBagConstraints47.weightx = 1.0;
			gridBagConstraints47.anchor = GridBagConstraints.WEST;
			gridBagConstraints47.gridx = 1;
			GridBagConstraints gridBagConstraints46 = new GridBagConstraints();
			gridBagConstraints46.fill = GridBagConstraints.NONE;
			gridBagConstraints46.gridy = 6;
			gridBagConstraints46.weightx = 1.0;
			gridBagConstraints46.anchor = GridBagConstraints.WEST;
			gridBagConstraints46.gridx = 1;
			GridBagConstraints gridBagConstraints45 = new GridBagConstraints();
			gridBagConstraints45.fill = GridBagConstraints.NONE;
			gridBagConstraints45.gridy = 5;
			gridBagConstraints45.weightx = 1.0;
			gridBagConstraints45.anchor = GridBagConstraints.WEST;
			gridBagConstraints45.gridx = 1;
			GridBagConstraints gridBagConstraints44 = new GridBagConstraints();
			gridBagConstraints44.fill = GridBagConstraints.NONE;
			gridBagConstraints44.gridy = 4;
			gridBagConstraints44.weightx = 1.0;
			gridBagConstraints44.anchor = GridBagConstraints.WEST;
			gridBagConstraints44.gridx = 1;
			GridBagConstraints gridBagConstraints43 = new GridBagConstraints();
			gridBagConstraints43.fill = GridBagConstraints.NONE;
			gridBagConstraints43.gridy = 3;
			gridBagConstraints43.weightx = 1.0;
			gridBagConstraints43.anchor = GridBagConstraints.WEST;
			gridBagConstraints43.gridx = 1;
			GridBagConstraints gridBagConstraints42 = new GridBagConstraints();
			gridBagConstraints42.fill = GridBagConstraints.NONE;
			gridBagConstraints42.gridy = 2;
			gridBagConstraints42.weightx = 4.0;
			gridBagConstraints42.anchor = GridBagConstraints.WEST;
			gridBagConstraints42.gridx = 1;
			GridBagConstraints gridBagConstraints41 = new GridBagConstraints();
			gridBagConstraints41.gridx = 0;
			gridBagConstraints41.anchor = GridBagConstraints.EAST;
			gridBagConstraints41.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints41.fill = GridBagConstraints.NONE;
			gridBagConstraints41.gridy = 10;
			jLabelRKInvest = new JLabel();
			jLabelRKInvest.setText("Investition []");
			GridBagConstraints gridBagConstraints40 = new GridBagConstraints();
			gridBagConstraints40.gridx = 0;
			gridBagConstraints40.anchor = GridBagConstraints.EAST;
			gridBagConstraints40.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints40.fill = GridBagConstraints.NONE;
			gridBagConstraints40.gridy = 9;
			jLabelRKha = new JLabel();
			jLabelRKha.setText("Hilfsantriebe [kW Strom/kW Rckkhlleistung]");
			GridBagConstraints gridBagConstraints39 = new GridBagConstraints();
			gridBagConstraints39.gridx = 0;
			gridBagConstraints39.anchor = GridBagConstraints.EAST;
			gridBagConstraints39.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints39.fill = GridBagConstraints.NONE;
			gridBagConstraints39.gridy = 8;
			jLabelRKnl = new JLabel();
			jLabelRKnl.setText("Nennleistung [kW]");
			GridBagConstraints gridBagConstraints38 = new GridBagConstraints();
			gridBagConstraints38.gridx = 0;
			gridBagConstraints38.fill = GridBagConstraints.NONE;
			gridBagConstraints38.gridy = 7;
			jLabelRK = new JLabel();
			jLabelRK.setText("Rckkhler");
			GridBagConstraints gridBagConstraints37 = new GridBagConstraints();
			gridBagConstraints37.gridx = 0;
			gridBagConstraints37.anchor = GridBagConstraints.EAST;
			gridBagConstraints37.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints37.fill = GridBagConstraints.NONE;
			gridBagConstraints37.gridy = 6;
			jLabelKMInvest = new JLabel();
			jLabelKMInvest.setText("Investition []");
			GridBagConstraints gridBagConstraints36 = new GridBagConstraints();
			gridBagConstraints36.gridx = 0;
			gridBagConstraints36.anchor = GridBagConstraints.EAST;
			gridBagConstraints36.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints36.fill = GridBagConstraints.NONE;
			gridBagConstraints36.gridy = 5;
			jLabelKMha = new JLabel();
			jLabelKMha.setText("Hilfsantriebe [kW Strom/kW Klte]]");
			GridBagConstraints gridBagConstraints35 = new GridBagConstraints();
			gridBagConstraints35.gridx = 0;
			gridBagConstraints35.anchor = GridBagConstraints.EAST;
			gridBagConstraints35.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints35.fill = GridBagConstraints.NONE;
			gridBagConstraints35.gridy = 4;
			jLabelKMwf = new JLabel();
			jLabelKMwf.setText("Wasserfaktor [m/kWh Klte]");
			GridBagConstraints gridBagConstraints34 = new GridBagConstraints();
			gridBagConstraints34.gridx = 0;
			gridBagConstraints34.anchor = GridBagConstraints.EAST;
			gridBagConstraints34.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints34.fill = GridBagConstraints.NONE;
			gridBagConstraints34.gridy = 3;
			jLabelKMwg = new JLabel();
			jLabelKMwg.setText("Wirkungsgrad [1]");
			GridBagConstraints gridBagConstraints33 = new GridBagConstraints();
			gridBagConstraints33.gridx = 0;
			gridBagConstraints33.anchor = GridBagConstraints.EAST;
			gridBagConstraints33.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints33.fill = GridBagConstraints.NONE;
			gridBagConstraints33.gridy = 2;
			jLabelKMnl = new JLabel();
			jLabelKMnl.setText("Nennleistung [kW]");
			GridBagConstraints gridBagConstraints32 = new GridBagConstraints();
			gridBagConstraints32.gridx = 0;
			gridBagConstraints32.fill = GridBagConstraints.NONE;
			gridBagConstraints32.gridy = 1;
			jLabelKM = new JLabel();
			jLabelKM.setText("Kltemaschine");
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.fill = GridBagConstraints.HORIZONTAL;
			gridBagConstraints5.gridx = 0;
			gridBagConstraints5.gridy = 0;
			gridBagConstraints5.weightx = 1.0;
			jPanelKMRK = new JPanel();
			jPanelKMRK.setLayout(new GridBagLayout());
			jPanelKMRK.add(getJComboBoxKMRK(), gridBagConstraints5);
			jPanelKMRK.add(getJButtonKMRKStd(), gridBagConstraints8);
			jPanelKMRK.add(jLabelKM, gridBagConstraints32);
			jPanelKMRK.add(jLabelKMnl, gridBagConstraints33);
			jPanelKMRK.add(jLabelKMwg, gridBagConstraints34);
			jPanelKMRK.add(jLabelKMwf, gridBagConstraints35);
			jPanelKMRK.add(jLabelKMha, gridBagConstraints36);
			jPanelKMRK.add(jLabelKMInvest, gridBagConstraints37);
			jPanelKMRK.add(jLabelRK, gridBagConstraints38);
			jPanelKMRK.add(jLabelRKnl, gridBagConstraints39);
			jPanelKMRK.add(jLabelRKha, gridBagConstraints40);
			jPanelKMRK.add(jLabelRKInvest, gridBagConstraints41);
			jPanelKMRK.add(getJTextFieldKMnl(), gridBagConstraints42);
			jPanelKMRK.add(getJTextFieldKMwg(), gridBagConstraints43);
			jPanelKMRK.add(getJTextFieldKMwf(), gridBagConstraints44);
			jPanelKMRK.add(getJTextFieldKMha(), gridBagConstraints45);
			jPanelKMRK.add(getJTextFieldKMInvest(), gridBagConstraints46);
			jPanelKMRK.add(getJTextFieldRKnl(), gridBagConstraints47);
			jPanelKMRK.add(getJTextFieldRKha(), gridBagConstraints48);
			jPanelKMRK.add(getJTextFieldRKInvest(), gridBagConstraints49);
		}
		return jPanelKMRK;
	}

	/**
	 * This method initializes jComboBoxTN	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJComboBoxTN() {
//		if (jComboBoxTN == null) {
//			jComboBoxTN = new JComboBox(namen_tn);
			jComboBoxTN.addActionListener(this);
//		}
		return jComboBoxTN;
	}

	/**
	 * This method initializes jComboBoxKMRK	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJComboBoxKMRK() {
//		if (jComboBoxKMRK == null) {
//			jComboBoxKMRK = new JComboBox(namen_km);
			jComboBoxKMRK.addActionListener(this);
//		}
		return jComboBoxKMRK;
	}

	/**
	 * This method initializes jButtonOK	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonOK() {
		if (jButtonOK == null) {
			jButtonOK = new JButton();
			jButtonOK.setText("Neu Berechnen");
			jButtonOK.addActionListener(this);
		}
		return jButtonOK;
	}

	/**
	 * This method initializes jButtonAbbrechen	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonAbbrechen() {
		if (jButtonAbbrechen == null) {
			jButtonAbbrechen = new JButton();
			jButtonAbbrechen.setText("Fenster Schlieen");
			jButtonAbbrechen.addActionListener(this);
		}
		return jButtonAbbrechen;
	}

	/**
	 * This method initializes jButtonTNStd	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonTNStd() {
		if (jButtonTNStd == null) {
			jButtonTNStd = new JButton();
			jButtonTNStd.setText("Standardwerte setzen");
			jButtonTNStd.setEnabled(false);
		}
		return jButtonTNStd;
	}

	/**
	 * This method initializes jButtonKMRKStd	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonKMRKStd() {
		if (jButtonKMRKStd == null) {
			jButtonKMRKStd = new JButton();
			jButtonKMRKStd.setText("Standardwerte setzen");
			jButtonKMRKStd.setEnabled(false);
		}
		return jButtonKMRKStd;
	}

	/**
	 * This method initializes jTextFieldRNdm	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldRNdm() {
		if (jTextFieldRNdm == null) {
			jTextFieldRNdm = new JTextField();
			jTextFieldRNdm.setColumns(10);
			jTextFieldRNdm.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					tn.getRohrnetz().setDurchmesser(
							einlesen(jTextFieldRNdm));
					tn.getPumpen().setFoerderhoehe(tn);
					Pfh_akt();
					PInvest_akt();
					Rohrkosten_akt();
					Trassenkosten_akt();
					RNInvest_akt();
				}
			});
		}
		return jTextFieldRNdm;
	}

	/**
	 * This method initializes jTextFieldRNebf	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldRNebf() {
		if (jTextFieldRNebf == null) {
			jTextFieldRNebf = new JTextField();
			jTextFieldRNebf.setColumns(10);
			jTextFieldRNebf.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					tn.getRohrnetz().setEinbautenfaktor(
							einlesen(jTextFieldRNebf));
					tn.getPumpen().setFoerderhoehe(tn);
					RNebf_akt();
					Pfh_akt();
					PInvest_akt();
				}
			});
		}
		return jTextFieldRNebf;
	}

	/**
	 * This method initializes jTextFieldRNlambda	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldRNlambda() {
		if (jTextFieldRNlambda == null) {
			jTextFieldRNlambda = new JTextField();
			jTextFieldRNlambda.setColumns(10);
			jTextFieldRNlambda.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					tn.getRohrnetz().setLambda(einlesen(jTextFieldRNlambda));
					tn.getPumpen().setFoerderhoehe(tn);
					RNlambda_akt();
					Pfh_akt();
					PInvest_akt();
				}
			});
		}
		return jTextFieldRNlambda;
	}

	/**
	 * This method initializes jTextFieldRNrl	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldRNrl() {
		if (jTextFieldRNrl == null) {
			jTextFieldRNrl = new JTextField();
			jTextFieldRNrl.setColumns(10);
			jTextFieldRNrl.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					tn.getRohrnetz().setRohrlaenge(einlesen(jTextFieldRNrl));
					tn.getPumpen().setFoerderhoehe(tn);
					RNrl_akt();
					RNInvest_akt();
					Pfh_akt();
					PInvest_akt();
				}
			});
		}
		return jTextFieldRNrl;
	}

	/**
	 * This method initializes jTextFieldRNvl	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldRNvl() {
		if (jTextFieldRNvl == null) {
			jTextFieldRNvl = new JTextField();
			jTextFieldRNvl.setColumns(10);
			jTextFieldRNvl.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					tn.getRohrnetz().setTrassenlaenge(einlesen(jTextFieldRNvl));
					RNInvest_akt();
				}
			});
		}
		return jTextFieldRNvl;
	}

	/**
	 * This method initializes jTextFieldPfh	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldPfh() {
		if (jTextFieldPfh == null) {
			jTextFieldPfh = new JTextField();
			jTextFieldPfh.setColumns(10);
			jTextFieldPfh.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					tn.getPumpen().setFoerderhoehe(einlesen(jTextFieldPfh));
					Pfh_akt();
					PInvest_akt();
				}
			});
		}
		return jTextFieldPfh;
	}

	/**
	 * This method initializes jTextFieldPv	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldPv() {
		if (jTextFieldPv == null) {
			jTextFieldPv = new JTextField();
			jTextFieldPv.setColumns(10);
			jTextFieldPv.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					tn.getPumpen().setVolumenstrom(einlesen(jTextFieldPv));
					Pv_akt();
					PInvest_akt();
				}
			});
		}
		return jTextFieldPv;
	}

	/**
	 * This method initializes jTextFieldPeta	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldPeta() {
		if (jTextFieldPeta == null) {
			jTextFieldPeta = new JTextField();
			jTextFieldPeta.setColumns(10);
			jTextFieldPeta.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					tn.getPumpen().setEta_ges(einlesen(jTextFieldPeta));
					Peta_akt();
					PInvest_akt();
				}
			});
		}
		return jTextFieldPeta;
	}

	/**
	 * This method initializes jTextFieldRNInvest	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldRNInvest() {
		if (jTextFieldRNInvest == null) {
			jTextFieldRNInvest = new JTextField();
			jTextFieldRNInvest.setColumns(10);
			jTextFieldRNInvest.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					tn.getRohrnetz().setInvestition(einlesen(jTextFieldRNInvest));
					RNInvest_akt();
				}
			});
		}
		return jTextFieldRNInvest;
	}

	/**
	 * This method initializes jTextFieldPInvest	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldPInvest() {
		if (jTextFieldPInvest == null) {
			jTextFieldPInvest = new JTextField();
			jTextFieldPInvest.setColumns(10);
			jTextFieldPInvest.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					tn.getPumpen().setInvestition(einlesen(jTextFieldPInvest));
					PInvest_akt();
				}
			});
		}
		return jTextFieldPInvest;
	}

	/**
	 * This method initializes jTextFieldKMnl	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldKMnl() {
		if (jTextFieldKMnl == null) {
			jTextFieldKMnl = new JTextField();
			jTextFieldKMnl.setColumns(10);
			jTextFieldKMnl.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					km.setNennleistung(einlesen(jTextFieldKMnl));
					KMnl_akt();
					KMInvest_akt();
					RKnl_akt();
					RKInvest_akt();
				}
			});
		}
		return jTextFieldKMnl;
	}

	/**
	 * This method initializes jTextFieldKMwg	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldKMwg() {
		if (jTextFieldKMwg == null) {
			jTextFieldKMwg = new JTextField();
			jTextFieldKMwg.setColumns(10);
			jTextFieldKMwg.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					if (km instanceof AbKM)
					{
						((AbKM) km).setZeta_K(einlesen(jTextFieldKMwg));
					}
					else
					{
						((KoKM) km).setEER(einlesen(jTextFieldKMwg));
					}
					KMwg_akt();
					RKnl_akt();
					RKInvest_akt();
				}
			});
		}
		return jTextFieldKMwg;
	}

	/**
	 * This method initializes jTextFieldKMwf	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldKMwf() {
		if (jTextFieldKMwf == null) {
			jTextFieldKMwf = new JTextField();
			jTextFieldKMwf.setColumns(10);
			jTextFieldKMwf.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					km.setWasserfaktor(einlesen(jTextFieldKMwf));
					KMwf_akt();
				}
			});
		}
		return jTextFieldKMwf;
	}

	/**
	 * This method initializes jTextFieldKMha	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldKMha() {
		if (jTextFieldKMha == null) {
			jTextFieldKMha = new JTextField();
			jTextFieldKMha.setColumns(10);
			jTextFieldKMha.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					km.setHilfsantriebe(einlesen(jTextFieldKMwg));
					KMha_akt();
				}
			});
		}
		return jTextFieldKMha;
	}

	/**
	 * This method initializes jTextFieldKMInvest	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldKMInvest() {
		if (jTextFieldKMInvest == null) {
			jTextFieldKMInvest = new JTextField();
			jTextFieldKMInvest.setColumns(10);
			jTextFieldKMInvest.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					km.setInvestition(einlesen(jTextFieldKMInvest));
				}
			});
		}
		return jTextFieldKMInvest;
	}

	/**
	 * This method initializes jTextFieldRKnl	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldRKnl() {
		if (jTextFieldRKnl == null) {
			jTextFieldRKnl = new JTextField();
			jTextFieldRKnl.setColumns(10);
			jTextFieldRKnl.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					rk.setNennleistung(einlesen(jTextFieldRKnl));
					RKnl_akt();
					RKInvest_akt();
				}
			});
		}
		return jTextFieldRKnl;
	}

	/**
	 * This method initializes jTextFieldRKha	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldRKha() {
		if (jTextFieldRKha == null) {
			jTextFieldRKha = new JTextField();
			jTextFieldRKha.setColumns(10);
			jTextFieldRKha.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					rk.setHilfsantriebe(einlesen(jTextFieldRKha));
					RKha_akt();
				}
			});
		}
		return jTextFieldRKha;
	}

	/**
	 * This method initializes jTextFieldRKInvest	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldRKInvest() {
		if (jTextFieldRKInvest == null) {
			jTextFieldRKInvest = new JTextField();
			jTextFieldRKInvest.setColumns(10);
			jTextFieldRKInvest.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					rk.setInvestition(einlesen(jTextFieldRKInvest));
				}
			});
		}
		return jTextFieldRKInvest;
	}

	/**
	 * This method initializes jTextFieldbzr	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldbzr() {
		if (jTextFieldbzr == null) {
			jTextFieldbzr = new JTextField(Helper.Zahlformat(lv.projekt.getPD().getBetrachtungszeitraum(),0));
			jTextFieldbzr.setColumns(10);
		}
		return jTextFieldbzr;
	}

	/**
	 * This method initializes jTextFieldZinssatz	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldZinssatz() {
		if (jTextFieldZinssatz == null) {
			jTextFieldZinssatz = new JTextField(Helper.Zahlformat(lv.projekt.getPD().getZinssatz(),4));
			jTextFieldZinssatz.setColumns(10);
		}
		return jTextFieldZinssatz;
	}

	/**
	 * This method initializes jTextFieldpaf_invest	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldpaf_invest() {
		if (jTextFieldpaf_invest == null) {
			jTextFieldpaf_invest = new JTextField(Helper.Zahlformat(lv.projekt.getPD().getPaf_invest(),3));
			jTextFieldpaf_invest.setColumns(10);
		}
		return jTextFieldpaf_invest;
	}

	/**
	 * This method initializes jTextFieldStundenlohn	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldStundenlohn() {
		if (jTextFieldStundenlohn == null) {
			jTextFieldStundenlohn = new JTextField(Helper.Zahlformat(lv.projekt.getPD().getStundenlohn(),4));
			jTextFieldStundenlohn.setColumns(10);
		}
		return jTextFieldStundenlohn;
	}

	/**
	 * This method initializes jTextFieldpaf_lohn	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldpaf_lohn() {
		if (jTextFieldpaf_lohn == null) {
			jTextFieldpaf_lohn = new JTextField(Helper.Zahlformat(lv.projekt.getPD().getPaf_lohn(),4));
			jTextFieldpaf_lohn.setColumns(10);
		}
		return jTextFieldpaf_lohn;
	}

	/**
	 * This method initializes jTextFieldStrompreis	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldStrompreis() {
		if (jTextFieldStrompreis == null) {
			jTextFieldStrompreis = new JTextField(Helper.Zahlformat(lv.projekt.getPD().getStrompreis()[0],4));
			jTextFieldStrompreis.setColumns(10);
		}
		return jTextFieldStrompreis;
	}

	/**
	 * This method initializes jTextFieldWaermepreis	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldWaermepreis() {
		if (jTextFieldWaermepreis == null) {
			jTextFieldWaermepreis = new JTextField(Helper.Zahlformat(lv.projekt.getPD().getWaermepreis()[0],4));
			jTextFieldWaermepreis.setColumns(10);
		}
		return jTextFieldWaermepreis;
	}

	/**
	 * This method initializes jTextFieldWasserpreis	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldWasserpreis() {
		if (jTextFieldWasserpreis == null) {
			jTextFieldWasserpreis = new JTextField(Helper.Zahlformat(lv.projekt.getPD().getWasserpreis()[0],4));
			jTextFieldWasserpreis.setColumns(10);
		}
		return jTextFieldWasserpreis;
	}

	/**
	 * This method initializes jTextFieldpaf_energie	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldpaf_energie() {
		if (jTextFieldpaf_energie == null) {
			jTextFieldpaf_energie = new JTextField(Helper.Zahlformat(lv.projekt.getPD().getPaf_energie(),4));
			jTextFieldpaf_energie.setColumns(10);
		}
		return jTextFieldpaf_energie;
	}

	public void actionPerformed(ActionEvent ae) {
		Object Quelle = ae.getSource();
		if (Quelle == jComboBoxKZ)
		{
			kzdaten_speichern();
			kz_laden(jComboBoxKZ.getSelectedIndex());
		}
		if (Quelle == jComboBoxTN)
		{
			if (jComboBoxTN.getSelectedIndex() != -1)
				tn_laden(jComboBoxTN.getSelectedIndex());
		}
		if (Quelle == jComboBoxKMRK)
		{
			if (jComboBoxKMRK.getSelectedIndex() != -1)
				km_laden(jComboBoxKMRK.getSelectedIndex());
		}
		else if (Quelle == jButtonOK)
		{
			Uebernehmen();
		}
		else if (Quelle == jButtonAbbrechen)
		{
			Schliessen();
		}
	}
	
	private void kzdaten_speichern() {
		kz.getGebaeude().setInvestition(einlesen(jTextFieldGebaeude));
		kz.getVerrohrung().setInvestition(einlesen(jTextFieldVerrohrung));
		kz.getArmaturen().setInvestition(einlesen(jTextFieldArmaturen));
		kz.getMsr().setInvestition(einlesen(jTextFieldMSR));
		kz.getPumpen_rk()[0].setInvestition(einlesen(jTextFieldPumpenRK)); //TODO fr mehrere Pumpen
		kz.getPumpen_km()[0].setInvestition(einlesen(jTextFieldPumpenKM));
		for (int i=0; i<verbraucher.length; i++)
		{
			lv.projekt.getVerbraucher()[i].setInvestition(einlesen(Verbraucherinvestitionen[i]));
		}
	}

	void Schliessen()
	{
		this.setVisible(false);
	}
	
	void Uebernehmen()
	{
		lv.projekt.getPD().setBetrachtungszeitraum(einlesen(jTextFieldbzr));
		lv.projekt.getPD().setZinssatz(einlesen(jTextFieldZinssatz));
		lv.projekt.getPD().setPaf_invest(einlesen(jTextFieldpaf_invest));
		lv.projekt.getPD().setStundenlohn(einlesen(jTextFieldStundenlohn));
		lv.projekt.getPD().setPaf_lohn(einlesen(jTextFieldpaf_lohn));
		lv.projekt.getPD().setStrompreis(einlesen(jTextFieldStrompreis));
		lv.projekt.getPD().setWaermepreis(einlesen(jTextFieldWaermepreis));
		lv.projekt.getPD().setWasserpreis(einlesen(jTextFieldWasserpreis));
		lv.projekt.getPD().setPaf_energie(einlesen(jTextFieldpaf_energie));
		
		ArrayList objekte = new ArrayList();
		int k=0;
		int m=0; //Verbrauchernummer
		kzdaten_speichern();
		for (int i=0; i<lv.teilsysteme.length; i++)
		{
			objekte.add(lv.teilsysteme[i].getGebaeude());
			k++;
			objekte.add(lv.teilsysteme[i].getVerrohrung());
			k++;
			objekte.add(lv.teilsysteme[i].getMsr());
			k++;
			objekte.add(lv.teilsysteme[i].getArmaturen());
			k++;
			for (int j=0; j<lv.teilsysteme[i].getPumpen_km().length; j++)
			{
				objekte.add(lv.teilsysteme[i].getPumpen_km()[j]);
				k++;
			}
			for (int j=0; j<lv.teilsysteme[i].getPumpen_rk().length; j++)
			{
				objekte.add(lv.teilsysteme[i].getPumpen_rk()[j]);
				k++;
			}
			for (int j=0; j<lv.teilsysteme[i].getKaeltemaschinen().length; j++)
			{
				objekte.add(lv.teilsysteme[i].getKaeltemaschinen()[j]);
				k++;
				objekte.add(lv.teilsysteme[i].getRueckkuehler()[j]);
				k++;
			}
			for (int j=0; j<lv.teilsysteme[i].getSubnetze().length; j++)
			{
				objekte.add(lv.teilsysteme[i].getSubnetze()[j].getRohrnetz());
				k++;
				objekte.add(lv.teilsysteme[i].getSubnetze()[j].getPumpen());
				k++;
				for (int h=0; h<lv.teilsysteme[i].getSubnetze()[j].getVerbraucher().length; h++)
				{
					objekte.add(lv.teilsysteme[i].getSubnetze()[j].getVerbraucher()[h]);
					lv.teilsysteme[i].getSubnetze()[j].getVerbraucher()[h].setInvestition(einlesen(Verbraucherinvestitionen[m]));
					m++;
					k++;
				}
			}
		}
		for (int i=0; i<k-1; i++)
		{
			int typ = 0;
			if (objekte.get(i) instanceof AbKM)
				typ = 0;
			else if (objekte.get(i) instanceof KoKM)
				typ = 1;
			else if (objekte.get(i) instanceof Rueckkuehler)
				typ = 2;
			else if (objekte.get(i) instanceof Rohrnetz)
				typ = 3;
			else if (objekte.get(i) instanceof Pumpe)
				typ = 4;
			else if (objekte.get(i) instanceof Verbraucher)
				typ = 5;
			else if (objekte.get(i) instanceof Kompaktanlage)
				typ = 6;
			else if (objekte.get(i) instanceof Gebaeude)
				typ = 7;
			else if (objekte.get(i) instanceof MSR)
				typ = 8;
			else //if (objekte.get(i) instanceof )
				typ = 9;
			((Einzelobjekt ) objekte.get(i)).setNutzungsdauer(einlesen(faktoren[typ][0]));
			((Einzelobjekt ) objekte.get(i)).setInstandsetzung(einlesen(faktoren[typ][1]));
			((Einzelobjekt ) objekte.get(i)).setWartung(einlesen(faktoren[typ][2]));
			((Einzelobjekt ) objekte.get(i)).setInspektion(einlesen(faktoren[typ][3]));
			((Einzelobjekt ) objekte.get(i)).setBedienung(einlesen(faktoren[typ][4]));
		}
		owner.berechnen(lv);
		kz_laden(0);
		tn_laden(0);
		km_laden(0);
		jLabelJahresgesamtkosten.setText("Jahresgesamtkosten: " + Helper.Euroformat(lv.getKosten(), 0));
		jLabelErstinvestition.setText("Investition: " + Helper.Euroformat(lv.getInvestition(),0));
	}
	
	/**
	 * ndert alles was mit der Klteznetrae zusammenhngt
	 * @param index
	 */
	private void kz_laden(int index)
	{
		jComboBoxKMRK.removeAllItems();
		jComboBoxTN.removeAllItems();
		kz = lv.teilsysteme[index];
		namen_km = new String[kz.getKaeltemaschinen().length];
		namen_tn = new String[kz.getSubnetze().length];
		for (int i=0; i<namen_km.length; i++)
		{
			namen_km[i] = kz.getKaeltemaschinen()[i].getName();
			jComboBoxKMRK.addItem(namen_km[i]);
		}
		for (int i=0; i<namen_tn.length; i++)
		{
			namen_tn[i] = kz.getSubnetze()[i].getName();
			jComboBoxTN.addItem(namen_tn[i]);
		}
		jTextFieldOrtX.setText(Helper.Zahlformat(kz.getOrt()[0],0));
		jTextFieldOrtY.setText(Helper.Zahlformat(kz.getOrt()[1],0));
		jTextFieldGebaeude.setText(Helper.Zahlformat(kz.getGebaeude().getInvestition(), 0));
		jTextFieldVerrohrung.setText(Helper.Zahlformat(kz.getVerrohrung().getInvestition(), 0));
		jTextFieldArmaturen.setText(Helper.Zahlformat(kz.getArmaturen().getInvestition(), 0));
		jTextFieldMSR.setText(Helper.Zahlformat(kz.getMsr().getInvestition(), 0));
		jTextFieldPumpenRK.setText(Helper.Zahlformat(kz.getPumpen_rk()[0].getInvestition(), 0)); //TODO fr mehrere Pumpen
		jTextFieldPumpenKM.setText(Helper.Zahlformat(kz.getPumpen_km()[0].getInvestition(), 0));
	}
	
	/**
	 * ndert alles was mit dem Subnetz zusammen hngt
	 * @param index
	 */
	private void tn_laden(int i)
	{
		tn = kz.getSubnetze()[i];
		jTextFieldRNdm.setText(Helper.Zahlformat(tn.getRohrnetz().getDurchmesser(), 0));
		jTextFieldRNebf.setText(Helper.Zahlformat(tn.getRohrnetz().getEinbautenfaktor(), 3));
		jTextFieldRNlambda.setText(Helper.Zahlformat(tn.getRohrnetz().getLambda(), 3));
		jTextFieldRNrl.setText(Helper.Zahlformat(tn.getRohrnetz().getRohrlaenge(), 0));
		jTextFieldRNvl.setText(Helper.Zahlformat(tn.getRohrnetz().getTrassenlaenge(), 0));
		jTextFieldRNInvest.setText(Helper.Zahlformat(tn.getRohrnetz().getInvestition(), 0));
		jTextFieldPfh.setText(Helper.Zahlformat(tn.getPumpen().getFoerderhoehe(), 3));
		jTextFieldPv.setText(Helper.Zahlformat(tn.getPumpen().getVolumenstrom(), 3));
		jTextFieldPeta.setText(Helper.Zahlformat(tn.getPumpen().getEta_ges(), 3));
		jTextFieldPInvest.setText(Helper.Zahlformat(tn.getPumpen().getInvestition(), 0));
		jTextFieldRohrkosten.setText(Helper.Zahlformat(tn.getRohrnetz().getRohrkosten(), 0));
		jTextFieldTrassenkosten.setText(Helper.Zahlformat(tn.getRohrnetz().getTrassenkosten(), 0));
	}
	
	private void km_laden(int i)
	{
		km = kz.getKaeltemaschinen()[i];
		rk = kz.getRueckkuehler()[i];
		jTextFieldKMnl.setText(Helper.Zahlformat(km.getNennleistung(), 0));
		if (km instanceof KoKM)
		{
			jLabelKMwg.setText("EER [1]");
			jTextFieldKMwg.setText(Helper.Zahlformat(((KoKM) km).getEER(), 3));
		}
		else
		{
			jLabelKMwg.setText("zeta_K [1]");
			jTextFieldKMwg.setText(Helper.Zahlformat(((AbKM) km).getZeta_K(), 3));
		}
		jTextFieldKMwf.setText(Helper.Zahlformat(km.getWasserfaktor(), 3));
		jTextFieldKMha.setText(Helper.Zahlformat(km.getHilfsantriebe(), 3));
		jTextFieldKMInvest.setText(Helper.Zahlformat(km.getInvestition(), 0));
		jTextFieldRKnl.setText(Helper.Zahlformat(rk.getNennleistung(), 0));
		jTextFieldRKha.setText(Helper.Zahlformat(rk.getHilfsantriebe(), 3));
		jTextFieldRKInvest.setText(Helper.Zahlformat(rk.getInvestition(), 0));
	}

	public void RNdm_akt()
	{
		jTextFieldRNdm.setText(Helper.Zahlformat(tn.getRohrnetz().getDurchmesser(), 0));
	}
	public void Rohrkosten_akt()
	{
		jTextFieldRohrkosten.setText(Helper.Zahlformat(tn.getRohrnetz().getRohrkosten(), 0));
	}
	public void Trassenkosten_akt()
	{
		jTextFieldTrassenkosten.setText(Helper.Zahlformat(tn.getRohrnetz().getTrassenkosten(), 0));
	}
	public void RNebf_akt()
	{
		jTextFieldRNebf.setText(Helper.Zahlformat(tn.getRohrnetz().getEinbautenfaktor(), 3));
	}
	public void RNlambda_akt()
	{
		jTextFieldRNlambda.setText(Helper.Zahlformat(tn.getRohrnetz().getLambda(), 3));
	}
	public void RNrl_akt()
	{
		jTextFieldRNrl.setText(Helper.Zahlformat(tn.getRohrnetz().getRohrlaenge(), 0));
	}
	public void RNvl_akt()
	{
		jTextFieldRNvl.setText(Helper.Zahlformat(tn.getRohrnetz().getTrassenlaenge(), 0));
	}
	public void RNInvest_akt()
	{
		jTextFieldRNInvest.setText(Helper.Zahlformat(tn.getRohrnetz().getInvestition(), 0));
	}
	public void Pfh_akt()
	{
		jTextFieldPfh.setText(Helper.Zahlformat(tn.getPumpen().getFoerderhoehe(), 3));
	}
	public void Pv_akt()
	{
		jTextFieldPv.setText(Helper.Zahlformat(tn.getPumpen().getVolumenstrom(), 3));
	}
	public void Peta_akt()
	{
		jTextFieldPeta.setText(Helper.Zahlformat(tn.getPumpen().getEta_ges(), 3));
	}
	public void PInvest_akt()
	{
		jTextFieldPInvest.setText(Helper.Zahlformat(tn.getPumpen().getInvestition(), 0));
	}
	public void KMnl_akt()
	{
		jTextFieldKMnl.setText(Helper.Zahlformat(km.getNennleistung(), 0));
	}
	public void KMwg_akt()
	{
		if (km instanceof KoKM)
		{
			jTextFieldKMwg.setText(Helper.Zahlformat(((KoKM) km).getEER(), 3));
		}
		else
		{
			jTextFieldKMwg.setText(Helper.Zahlformat(((AbKM) km).getZeta_K(), 3));
		}
	}
	public void KMwf_akt()
	{
		jTextFieldKMwf.setText(Helper.Zahlformat(km.getWasserfaktor(), 3));
	}
	public void KMha_akt()
	{
		jTextFieldKMha.setText(Helper.Zahlformat(km.getHilfsantriebe(), 3));
	}
	public void KMInvest_akt()
	{
		jTextFieldKMInvest.setText(Helper.Zahlformat(km.getInvestition(), 0));
	}
	public void RKnl_akt()
	{
		jTextFieldRKnl.setText(Helper.Zahlformat(rk.getNennleistung(), 0));
	}
	public void RKha_akt()
	{
		jTextFieldRKha.setText(Helper.Zahlformat(rk.getHilfsantriebe(), 3));
	}
	public void RKInvest_akt()
	{
		jTextFieldRKInvest.setText(Helper.Zahlformat(rk.getInvestition(), 0));
	}
	
	public double einlesen(JTextField textfeld)
	{
		double wert = 0;
		NumberFormat nf = NumberFormat.getInstance();
		try {
			wert = nf.parse(textfeld.getText()).doubleValue();
		} catch (ParseException e) {
			e.printStackTrace();
		}
		return wert;
	}

	/**
	 * This method initializes jPanelVerbraucher	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelVerbraucher() {
		if (jPanelVerbraucher == null) {
			GridBagConstraints gridBagConstraints99 = new GridBagConstraints();
			gridBagConstraints99.fill = GridBagConstraints.BOTH;
			gridBagConstraints99.weighty = 1.0;
			gridBagConstraints99.weightx = 1.0;
			jPanelVerbraucher = new JPanel();
			jPanelVerbraucher.setLayout(new GridBagLayout());
			jPanelVerbraucher.add(getJScrollPaneVerbraucher(), gridBagConstraints99);
		}
		return jPanelVerbraucher;
	}

	/**
	 * This method initializes jPanelZentrale	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelZentrale() {
		if (jPanelZentrale == null) {
			GridBagConstraints gridBagConstraints107 = new GridBagConstraints();
			gridBagConstraints107.gridx = 2;
			gridBagConstraints107.gridheight = 6;
			gridBagConstraints107.fill = GridBagConstraints.VERTICAL;
			gridBagConstraints107.gridy = 0;
			GridBagConstraints gridBagConstraints95 = new GridBagConstraints();
			gridBagConstraints95.fill = GridBagConstraints.NONE;
			gridBagConstraints95.gridy = 5;
			gridBagConstraints95.weightx = 1.0;
			gridBagConstraints95.anchor = GridBagConstraints.WEST;
			gridBagConstraints95.gridx = 1;
			GridBagConstraints gridBagConstraints94 = new GridBagConstraints();
			gridBagConstraints94.fill = GridBagConstraints.NONE;
			gridBagConstraints94.gridy = 4;
			gridBagConstraints94.weightx = 1.0;
			gridBagConstraints94.anchor = GridBagConstraints.WEST;
			gridBagConstraints94.gridx = 1;
			GridBagConstraints gridBagConstraints93 = new GridBagConstraints();
			gridBagConstraints93.fill = GridBagConstraints.NONE;
			gridBagConstraints93.gridy = 3;
			gridBagConstraints93.weightx = 1.0;
			gridBagConstraints93.anchor = GridBagConstraints.WEST;
			gridBagConstraints93.gridx = 1;
			GridBagConstraints gridBagConstraints92 = new GridBagConstraints();
			gridBagConstraints92.fill = GridBagConstraints.NONE;
			gridBagConstraints92.gridy = 2;
			gridBagConstraints92.weightx = 1.0;
			gridBagConstraints92.anchor = GridBagConstraints.WEST;
			gridBagConstraints92.gridx = 1;
			GridBagConstraints gridBagConstraints91 = new GridBagConstraints();
			gridBagConstraints91.fill = GridBagConstraints.NONE;
			gridBagConstraints91.gridy = 1;
			gridBagConstraints91.weightx = 1.0;
			gridBagConstraints91.anchor = GridBagConstraints.WEST;
			gridBagConstraints91.gridx = 1;
			GridBagConstraints gridBagConstraints90 = new GridBagConstraints();
			gridBagConstraints90.fill = GridBagConstraints.NONE;
			gridBagConstraints90.gridy = 0;
			gridBagConstraints90.weightx = 1.0;
			gridBagConstraints90.anchor = GridBagConstraints.WEST;
			gridBagConstraints90.gridx = 1;
			GridBagConstraints gridBagConstraints89 = new GridBagConstraints();
			gridBagConstraints89.gridx = 0;
			gridBagConstraints89.anchor = GridBagConstraints.EAST;
			gridBagConstraints89.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints89.gridy = 5;
			jLabelPumpenKM = new JLabel();
			jLabelPumpenKM.setText("Pumpen Kltemaschinen");
			GridBagConstraints gridBagConstraints88 = new GridBagConstraints();
			gridBagConstraints88.gridx = 0;
			gridBagConstraints88.anchor = GridBagConstraints.EAST;
			gridBagConstraints88.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints88.gridy = 4;
			jLabelPumpenRK = new JLabel();
			jLabelPumpenRK.setText("Pumpen Rckkhlkreislauf");
			GridBagConstraints gridBagConstraints87 = new GridBagConstraints();
			gridBagConstraints87.gridx = 0;
			gridBagConstraints87.anchor = GridBagConstraints.EAST;
			gridBagConstraints87.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints87.gridy = 3;
			jLabelMSR = new JLabel();
			jLabelMSR.setText("Mess-, Steuer-, Regeltechnik");
			GridBagConstraints gridBagConstraints86 = new GridBagConstraints();
			gridBagConstraints86.gridx = 0;
			gridBagConstraints86.anchor = GridBagConstraints.EAST;
			gridBagConstraints86.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints86.gridy = 2;
			jLabelArmaturen = new JLabel();
			jLabelArmaturen.setText("Armaturen / hydraulische Weiche");
			GridBagConstraints gridBagConstraints85 = new GridBagConstraints();
			gridBagConstraints85.gridx = 0;
			gridBagConstraints85.anchor = GridBagConstraints.EAST;
			gridBagConstraints85.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints85.gridy = 1;
			jLabelVerrohrung = new JLabel();
			jLabelVerrohrung.setText("Verrohrung");
			GridBagConstraints gridBagConstraints84 = new GridBagConstraints();
			gridBagConstraints84.gridx = 0;
			gridBagConstraints84.anchor = GridBagConstraints.EAST;
			gridBagConstraints84.insets = new Insets(0, 0, 0, 5);
			gridBagConstraints84.gridy = 0;
			jLabelGebaeude = new JLabel();
			jLabelGebaeude.setText("Gebude");
			jPanelZentrale = new JPanel();
			jPanelZentrale.setLayout(new GridBagLayout());
			jPanelZentrale.add(jLabelGebaeude, gridBagConstraints84);
			jPanelZentrale.add(jLabelVerrohrung, gridBagConstraints85);
			jPanelZentrale.add(jLabelArmaturen, gridBagConstraints86);
			jPanelZentrale.add(jLabelMSR, gridBagConstraints87);
			jPanelZentrale.add(jLabelPumpenRK, gridBagConstraints88);
			jPanelZentrale.add(jLabelPumpenKM, gridBagConstraints89);
			jPanelZentrale.add(getJTextFieldGebaeude(), gridBagConstraints90);
			jPanelZentrale.add(getJTextFieldVerrohrung(), gridBagConstraints91);
			jPanelZentrale.add(getJTextFieldArmaturen(), gridBagConstraints92);
			jPanelZentrale.add(getJTextFieldMSR(), gridBagConstraints93);
			jPanelZentrale.add(getJTextFieldPumpenRK(), gridBagConstraints94);
			jPanelZentrale.add(getJTextFieldPumpenKM(), gridBagConstraints95);
			jPanelZentrale.add(getJButtonStdZentrale(), gridBagConstraints107);
		}
		return jPanelZentrale;
	}

	/**
	 * This method initializes jTextFieldGebaeude	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldGebaeude() {
		if (jTextFieldGebaeude == null) {
			jTextFieldGebaeude = new JTextField();
			jTextFieldGebaeude.setColumns(7);
		}
		return jTextFieldGebaeude;
	}

	/**
	 * This method initializes jTextFieldVerrohrung	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldVerrohrung() {
		if (jTextFieldVerrohrung == null) {
			jTextFieldVerrohrung = new JTextField();
			jTextFieldVerrohrung.setColumns(7);
		}
		return jTextFieldVerrohrung;
	}

	/**
	 * This method initializes jTextFieldArmaturen	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldArmaturen() {
		if (jTextFieldArmaturen == null) {
			jTextFieldArmaturen = new JTextField();
			jTextFieldArmaturen.setColumns(7);
		}
		return jTextFieldArmaturen;
	}

	/**
	 * This method initializes jTextFieldMSR	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldMSR() {
		if (jTextFieldMSR == null) {
			jTextFieldMSR = new JTextField();
			jTextFieldMSR.setColumns(7);
		}
		return jTextFieldMSR;
	}

	/**
	 * This method initializes jTextFieldPumpenRK	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldPumpenRK() {
		if (jTextFieldPumpenRK == null) {
			jTextFieldPumpenRK = new JTextField();
			jTextFieldPumpenRK.setColumns(7);
		}
		return jTextFieldPumpenRK;
	}

	/**
	 * This method initializes jTextFieldPumpenKM	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldPumpenKM() {
		if (jTextFieldPumpenKM == null) {
			jTextFieldPumpenKM = new JTextField();
			jTextFieldPumpenKM.setColumns(7);
		}
		return jTextFieldPumpenKM;
	}

	/**
	 * This method initializes jScrollPaneVerbraucher	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPaneVerbraucher() {
		if (jScrollPaneVerbraucher == null) {
			jScrollPaneVerbraucher = new JScrollPane();
			jScrollPaneVerbraucher.setViewportView(getJPanelVerbraucher2());
			
		}
		return jScrollPaneVerbraucher;
	}

	/**
	 * This method initializes jPanelVerbraucher2	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelVerbraucher2() {
		if (jPanelVerbraucher2 == null) {
			jPanelVerbraucher2 = new JPanel();
			jPanelVerbraucher2.setLayout(new GridBagLayout());
			int m = 0;
			for (int i=0; i<lv.teilsysteme.length; i++)
			{
				for (int j=0; j<lv.teilsysteme[i].getSubnetze().length; j++)
				{
					for (int h=0; h<lv.teilsysteme[i].getSubnetze()[j].getVerbraucher().length; h++)
					{
						Verbraucher verbr = lv.teilsysteme[i].getSubnetze()[j].getVerbraucher()[h];
						Verbrauchernamen[m] = new JLabel("Preis Hausanschlussstation " + verbr.getName() + " []");
						Verbraucherinvestitionen[m] = new JTextField(Helper.Zahlformat(verbr.getInvestition(), 0));
						GridBagConstraints gbc_f = new GridBagConstraints();
						gbc_f.gridx = 0;
						gbc_f.gridy = m;
						gbc_f.anchor = GridBagConstraints.WEST;
						jPanelVerbraucher2.add(Verbrauchernamen[m], gbc_f);
						gbc_f.gridx = 1;
						Verbraucherinvestitionen[m].setPreferredSize(new Dimension(70, 20));
						jPanelVerbraucher2.add(Verbraucherinvestitionen[m], gbc_f);
						m++;
					}
				}
			}
		}
		return jPanelVerbraucher2;
	}

	/**
	 * This method initializes jTextFieldRohrkosten	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldRohrkosten() {
		if (jTextFieldRohrkosten == null) {
			jTextFieldRohrkosten = new JTextField();
			jTextFieldRohrkosten.setColumns(10);
			jTextFieldRohrkosten.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					tn.getRohrnetz().setRohrkosten(einlesen(jTextFieldRohrkosten));
					RNInvest_akt();
				}
			});
		}
		return jTextFieldRohrkosten;
	}

	/**
	 * This method initializes jTextFieldTrassenkosten	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldTrassenkosten()
	{
		if (jTextFieldTrassenkosten == null)
		{
			jTextFieldTrassenkosten = new JTextField();
			jTextFieldTrassenkosten.setColumns(10);
			jTextFieldTrassenkosten.addActionListener(
					new java.awt.event.ActionListener()
					{
						public void actionPerformed(java.awt.event.ActionEvent e)
						{
						tn.getRohrnetz().setTrassenkosten(einlesen(jTextFieldTrassenkosten));
						RNInvest_akt();
						}
					});
		}
		return jTextFieldTrassenkosten;
	}

	/**
	 * This method initializes jButtonStdZentrale	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonStdZentrale() {
		if (jButtonStdZentrale == null) {
			jButtonStdZentrale = new JButton();
			jButtonStdZentrale.setText("Standardwerte setzen");
			jButtonStdZentrale.setEnabled(false);
		}
		return jButtonStdZentrale;
	}

	/**
	 * This method initializes jPanelbunt	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelbunt() {
		if (jPanelbunt == null) {
			GridBagConstraints gridBagConstraints111 = new GridBagConstraints();
			gridBagConstraints111.gridx = 0;
			gridBagConstraints111.gridheight = 2;
			gridBagConstraints111.insets = new Insets(0, 0, 0, 10);
			gridBagConstraints111.anchor = GridBagConstraints.WEST;
			gridBagConstraints111.gridy = 0;
			jLabelZwischenergebnis = new JLabel();
			jLabelZwischenergebnis.setText("ZWISCHENERGEBNIS");
			GridBagConstraints gridBagConstraints108 = new GridBagConstraints();
			gridBagConstraints108.anchor = GridBagConstraints.WEST;
			gridBagConstraints108.gridx = -1;
			gridBagConstraints108.gridy = -1;
			gridBagConstraints108.insets = new Insets(0, 0, 0, 0);
			GridBagConstraints gridBagConstraints106 = new GridBagConstraints();
			gridBagConstraints106.anchor = GridBagConstraints.WEST;
			gridBagConstraints106.gridy = 1;
			gridBagConstraints106.gridx = 1;
			GridBagConstraints gridBagConstraints105 = new GridBagConstraints();
			gridBagConstraints105.anchor = GridBagConstraints.WEST;
			gridBagConstraints105.gridx = 1;
			gridBagConstraints105.gridy = 0;
			gridBagConstraints105.gridwidth = 1;
			gridBagConstraints105.fill = GridBagConstraints.NONE;
			jPanelbunt = new JPanel();
			jPanelbunt.setLayout(new GridBagLayout());
			jPanelbunt.setBackground(Color.green);
			jPanelbunt.add(jLabelJahresgesamtkosten, gridBagConstraints105);
			jPanelbunt.add(jLabelErstinvestition, gridBagConstraints106);
			jPanelbunt.add(jLabelZwischenergebnis, gridBagConstraints111);
		}
		return jPanelbunt;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
