package de.elisabetheckstaedt.dipl.common;

import de.elisabetheckstaedt.dipl.real.Verbraucher;

/**
 * Diese Klasse fasst die Ausgangdaten zusammen:
-	Klimadatendatensatz
-	Verbraucherliste
-	Preisdaten
 * @author Elisabeth Eckstdt
 */
public class Projekt {
	
	private final String name;
	private final Preisdaten PD; // Konstruktor
	private final Verbraucher[] verbraucher;
	private final Klimadatensatz KDS; //
	
	/**
	 * @param name
	 * @param verbraucher
	 * @param kds
	 */
	public Projekt(final String name,  final Verbraucher[] verbraucher, final Klimadatensatz kds) {
		super();
		this.name = name;
		PD = new Preisdaten();
		this.verbraucher = verbraucher;
		for (int i=0; i<verbraucher.length; i++)
		{
			verbraucher[i].init(kds.getAussentemperatur());
		}
		KDS = kds;
	}

	public Klimadatensatz getKDS() {
		return KDS;
	}

	public Verbraucher[] getVerbraucher() {
		return verbraucher;
	}

	public Preisdaten getPD() {
		return PD;
	}

	
}
