package de.elisabetheckstaedt.dipl.common;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;


/**
 * reprsentiert alle Kostenstellen, die nicht selbst gekauft werden, sondern mehrere Investitionsgter zusammen fassen
 * @author Elisabeth Eckstdt
 *
 */
public abstract class Sammelobjekt extends Kostenstelle
{
	protected Sammelobjekt(String name) {
			super(name);
		}
	
	public void Investition()
	{
		Investition = 0;
		Object[] Bestandteile = getStruktur();
		for (int i=0; i<Bestandteile.length; i++)
		{
			for (int j=0; j<((Kostenstelle[]) Bestandteile[i]).length; j++)
			{
				if (((Kostenstelle[]) Bestandteile[i])[j] instanceof Sammelobjekt)
				{
					((Sammelobjekt[]) Bestandteile[i])[j].Investition();
				}
				Investition = Investition + ((Kostenstelle[]) Bestandteile[i])[j].getInvestition(); 
			}
		}
	}
	
	public void Kosten(Preisdaten preisdaten)
	{
		Object[] Bestandteile = getStruktur();
		for (int i=0; i<Bestandteile.length; i++)
		{
			for (int j=0; j<((Kostenstelle[]) Bestandteile[i]).length; j++)
			{
				((Kostenstelle[]) Bestandteile[i])[j].Kosten(preisdaten);
			}
		}
		super.Kosten(preisdaten);
	}
	/**
	 * Summe ber alle Bestandteile
	 * @param Betrachtungszeitraum
	 * @param Zinssatz
	 * @param paf_invest
	 */
	protected void Investitionskosten(double Betrachtungszeitraum, double Zinssatz, double paf_invest)
	{
		Investitionskosten = 0;
		Object[] Bestandteile = getStruktur();
		for (int i=0; i<Bestandteile.length; i++)
		{
			for (int j=0; j<((Kostenstelle[]) Bestandteile[i]).length; j++)
			{
				Investitionskosten = Investitionskosten + ((Kostenstelle[]) Bestandteile[i])[j].getInvestitionskosten(); 
			}
		}
	}
	
	/**
	 * Summe ber alle Bestandteile
	 * @param Betrachtungszeitraum
	 * @param Zinssatz
	 * @param paf_invest
	 */
	protected void Instandsetzungskosten(double Betrachtungszeitraum, double Zinssatz, double paf_invest)
	{
		Instandsetzungskosten = 0;
		Object[] Bestandteile = getStruktur();
		for (int i=0; i<Bestandteile.length; i++)
		{
			for (int j=0; j<((Kostenstelle[]) Bestandteile[i]).length; j++)
			{
				Instandsetzungskosten = Instandsetzungskosten + ((Kostenstelle[]) Bestandteile[i])[j].getInstandsetzungskosten(); 
			}
		}
	}
	
	/**
	 * Summe ber alle Bestandteile
	 * @param Betrachtungszeitraum
	 * @param Zinssatz
	 * @param Stundenlohn
	 * @param paf_lohn
	 */
	protected void Bedienungskosten(double Betrachtungszeitraum, double Zinssatz, double Stundenlohn, double paf_lohn)
	{
		Bedienungskosten = 0;
		Object[] Bestandteile = getStruktur();
		for (int i=0; i<Bestandteile.length; i++)
		{
			for (int j=0; j<((Kostenstelle[]) Bestandteile[i]).length; j++)
			{
				Bedienungskosten = Bedienungskosten + ((Kostenstelle[]) Bestandteile[i])[j].getBedienungskosten(); 
			}
		}
	}
	
	/**
	 * Summe ber alle Bestandteile
	 * @param Betrachtungszeitraum
	 * @param Zinssatz
	 * @param paf_invest
	 */
	protected void Wartungskosten(double Betrachtungszeitraum, double Zinssatz, double paf_invest)
	{
		Wartungskosten = 0;
		Object[] Bestandteile = getStruktur();
		for (int i=0; i<Bestandteile.length; i++)
		{
			for (int j=0; j<((Kostenstelle[]) Bestandteile[i]).length; j++)
			{
				Wartungskosten = Wartungskosten + ((Kostenstelle[]) Bestandteile[i])[j].getWartungskosten(); 
			}
		}
	}
	
	/**
	 * Summe ber alle Bestandteile
	 * @param Betrachtungszeitraum
	 * @param Zinssatz
	 * @param Stundenlohn
	 * @param paf_lohn
	 */
	protected void Inspektionskosten(double Betrachtungszeitraum, double Zinssatz, double Stundenlohn, double paf_lohn)
	{
		Inspektionskosten = 0;
		Object[] Bestandteile = getStruktur();
		for (int i=0; i<Bestandteile.length; i++)
		{
			for (int j=0; j<((Kostenstelle[]) Bestandteile[i]).length; j++)
			{
				Inspektionskosten = Inspektionskosten + ((Kostenstelle[]) Bestandteile[i])[j].getInspektionskosten(); 
			}
		}
	}
	
	/**
	 * Summe ber alle Bestandteile
	 * @param Strompreis
	 * @param T
	 * @param q
	 * @param r
	 */
	protected void Stromkosten(double[] Strompreis, double T, double q, double r)
	{
		double Stromk = 0;
		Object[] Bestandteile = getStruktur();
		for (int i=0; i<Bestandteile.length; i++)
		{
			Kostenstelle[] Kostentraegerlistei = ((Kostenstelle[]) Bestandteile[i]);
			for (int j=0; j<Kostentraegerlistei.length; j++)
			{
				Stromk = Stromk + Kostentraegerlistei[j].getStromkosten();
			}
		}
		Stromkosten = Stromk;
	}
	
	/**
	 * Summe ber alle Bestandteile
	 * @param Wasserpreis
	 * @param T
	 * @param q
	 * @param r
	 */
	protected void Wasserkosten(double[] Wasserpreis, double T, double q, double r)
	{
		Object[] Bestandteile = getStruktur();
		double Wasserk = 0;
		for (int i=0; i<Bestandteile.length; i++)
		{
			Kostenstelle[] Kostentraegerlistei = ((Kostenstelle[]) Bestandteile[i]);
			for (int j=0; j<Kostentraegerlistei.length; j++)
			{
				Wasserk = Wasserk + Kostentraegerlistei[j].getWasserkosten();
			}
		}
		Wasserkosten = Wasserk;
	}
	/**
	 * Summe ber alle Bestandteile
	 * @param Waermepreis
	 * @param T
	 * @param q
	 * @param r
	 */
	protected void Waermekosten(double[] Waermepreis, double T, double q, double r)
	{
		Object[] Bestandteile = getStruktur();
		double Waermek = 0;
		for (int i=0; i<Bestandteile.length; i++)
		{
			Kostenstelle[] Kostentraegerlistei = ((Kostenstelle[]) Bestandteile[i]);
			for (int j=0; j<Kostentraegerlistei.length; j++)
			{
				Waermek = Waermek + Kostentraegerlistei[j].getWaermekosten();
			}
		}
		Waermekosten = Waermek;
	}
	
	/**
	 * ruft zustzlich die Methode fr alle Bestandteile
	 * @param baum
	 * @param preisdaten
	 * @return Node
	 */
	protected Node KostenXMLout(Document baum, Preisdaten preisdaten)
	{
		
		Element aktElem = (Element) super.KostenXMLout(baum, preisdaten);
		aktElem.setAttribute("Sammelname", getName());
		
		Object[] Bestandteile = getStruktur();
		for (int i=0; i<Bestandteile.length; i++)
		{
			Kostenstelle[] Kostentraegerliste = ((Kostenstelle[])Bestandteile[i]);
			if (Kostentraegerliste.length>1)
			{
				Element Kindelemente = baum.createElement("alle"+Kostentraegerliste[0].getBauteilart());
				for (int j=0; j<Kostentraegerliste.length; j++)
				{
					Kostenstelle kt = ((Kostenstelle[]) Bestandteile[i])[j];
					Node test = kt.KostenXMLout(baum, preisdaten);
					Kindelemente.appendChild(test);
				}
				aktElem.appendChild(Kindelemente);
			}
			else
			{
				aktElem.appendChild(Kostentraegerliste[0].KostenXMLout(baum, preisdaten));
			}
		}
		return aktElem;
	}
	
	/**
	 * @param baum
	 * @param Wurzelknoten
	 * @param teilsystemname
	 * @param subnetzname
	 * @param preisdaten
	 * @return Node
	 */
	protected Node KostenXMLoutflach(Document baum, Node Wurzelknoten, String teilsystemname,
			String subnetzname, Preisdaten preisdaten)
	{
//		Kosten(preisdaten);
		Object[] Bestandteile = getStruktur();
		for (int i=0; i<Bestandteile.length; i++)
		{
			Kostenstelle[] Kostentraegerliste = ((Kostenstelle[])Bestandteile[i]);
			for (int j=0; j<Kostentraegerliste.length; j++)
			{
				if (Kostentraegerliste[j].getBauteilart() == "Teilsystem")
				{
					teilsystemname = Kostentraegerliste[j].getName();
				}
				else if (Kostentraegerliste[j].getBauteilart() == "Subnetz")
				{
					subnetzname = Kostentraegerliste[j].getName();
				}
//				else if (Kostentraegerliste[j].getBauteilart() == "Rohrnetz")
//				{
//					Rohrnetzname = Kostentraegerliste[j].getName();
//				}
				Wurzelknoten = Kostentraegerliste[j].KostenXMLoutflach(baum, Wurzelknoten, teilsystemname, 
						subnetzname, preisdaten); 
			}
		}
		return Wurzelknoten;
	}

	public abstract Object[] getStruktur();
}
