package de.elisabetheckstaedt.dipl.common;

import de.elisabetheckstaedt.dipl.GUI.F_5_KM_Zahl;
import de.elisabetheckstaedt.dipl.GUI.F_1_TS_Zahl;
import de.elisabetheckstaedt.dipl.GUI.Hauptfenster;
import de.elisabetheckstaedt.dipl.real.Pumpe;
import de.elisabetheckstaedt.dipl.real.Rohrnetz;
import de.elisabetheckstaedt.dipl.real.Subnetz;
import de.elisabetheckstaedt.dipl.real.Verbraucher;

/**
 * berschreibt die Methoden von Berechnung die Diagrammzeichnen enthalt, so dass keine 
 * Diagramme erzeugt werden (spart Zeit und keine Verbindung zu Matlab ntig)
 * @author Elisabeth Eckstdt
 */
public class Schnellkonfiguration extends Konfiguration {

	public Schnellkonfiguration(Projekt projekt, Hauptfenster hauptfenster) {
		super(projekt, hauptfenster);
	}
	protected void start()
	{
		f_kz_zahl = new F_1_TS_Zahl(this, verbraucher_gesamt.length);
		f_kz_zahl.setVisible(true);
	}
	/**
	 * wird gerufen wenn Fenster F_2_TS_Zuordnung fertig
	 */
	public void kzs_aufspalten(Verbraucher[][] verbraucher_kzs)
	{
		f_kz_zuordnung.setVisible(false);
		this.verbraucher_kzs = verbraucher_kzs;
		for (int i=0; i<zahl_kz; i++)
		{
			tn_anzahl(i);
		}
	}
	/**
	 * wird gerufen wenn Fenster F_4_SN_Zuordnung fertig
	 */
	public void km_anzahl(int kznummer, Verbraucher[][] verbraucher_tns)
	{
		geschlossen++;
		f_tn_zuordnung[kznummer].setVisible(false);
		this.verbraucher_tns[kznummer] = verbraucher_tns;
		tns[kznummer] = new Subnetz[zahl_tn[kznummer]];
		for (int i=0; i<zahl_tn[kznummer]; i++)
		{
			Pumpe pumpe = new Pumpe("Subnetz " + new Integer(i).toString());
			Rohrnetz rohrnetz = new Rohrnetz("Subnetz " + new Integer(i).toString(),"KMR");
			Verbraucher[] verbraucher = this.verbraucher_tns[kznummer][i];
			String name = f_tn_zuordnung[kznummer].namen_kzs[i];
			tns[kznummer][i] = new Subnetz(name, pumpe, rohrnetz, verbraucher);
		}
		
		double[] kaelteleistung = new Versorgungsaufgabe(verbraucher_kzs[kznummer], va.getKlimadatensatz()).Lastgang();
		geoeffnet++;
		f_km_zahl[kznummer] = new F_5_KM_Zahl(this, kznummer, kaelteleistung);
		f_km_zahl[kznummer].setVisible(true);
	}
}
