package de.elisabetheckstaedt.dipl.real;

import java.util.Arrays;

import de.elisabetheckstaedt.dipl.common.Helper;

/**
 * reprsentiert das Bauwerk fr die Kltezentrale
 * @author Elisabeth Eckstdt
 */
public class Gebaeude extends Stromverbraucher {
	
	/**
	 * [m]
	 */
	private double laenge;
	/**
	 * [m]
	 */
	private double breite;
	/**
	 * [m]
	 */
	private double hoehe;
	/**
	 * [1] wieviel grer als rein fr KM ntig wird das Gebude<p>
	 * (Faktor bezogen auf die Flche, nicht auf die Seitenlngen)
	 */
	private double faktor;

	/**
	 * reicht Paramter an Vaterkonstruktor durch
	 * @param name
	 */
	public Gebaeude(String name) {
		super(name);
	}
	
	/**
	 * setzt Faktoren und Abmessungen<p>
	 * ruft Investition()<p>
	 * liest Abmessungen der Maschinen
	 * @param kms
	 */
	public void init(Kaeltemaschine[] kms)
	{
		Nutzungsdauer = 50;
		Instandsetzung = 1;
		Wartung = 1;
		Bedienung = 0;
		Inspektion = 0;
		laenge = 0;
		breite = 0;
		hoehe = 0;
		faktor = 5;
		double lk;
		double hk;
		double bk;
		for (int i=0; i< kms.length; i++)
		{
			lk = kms[i].getLaenge();
			hk = kms[i].getHoehe();
			bk = kms[i].getBreite();
			if (laenge < lk) laenge = lk;
			if (hoehe < hk) hoehe = hk;
			breite = breite + bk;
		}
		if (hoehe < 3) hoehe = 3;
		Investition();
	}
	
	/**
	 * setzt Stromverbraucher.Stromverbrauch = 0
	 */
	public void Stromverbrauch()
	{
		Arrays.fill(Stromverbrauch,0);
	}
	
	/**
	 * setzt Kostenstelle.Investition in Abhngigkeit der Abmessungen
	 */
	private void Investition()
	{
		double aussenwaende = 2 * Math.sqrt(faktor) * (laenge + breite) * hoehe * 628;
		double dach = laenge * breite * faktor * 198;
		double gruendung = laenge * breite * faktor * 232;
		Investition = (aussenwaende + dach + gruendung) * 1.25;
	}

	public String getBauteilart() {
		return "Gebaeude";
	}
	
	/**
	 * @return Flche und Abmessungen
	 */
	public String Investitionstext()
	{
		return super.Investitionstext() + 
		" Flaeche: " + Helper.Zahlformat(laenge * breite * faktor,0) + " m" + 
		" Hhe: " + Helper.Zahlformat(hoehe,0) + " m";
	}
}
