package de.elisabetheckstaedt.dipl.real;

import de.elisabetheckstaedt.dipl.common.Helper;

/**
 * reprsentiert Schraubenverdichter
 * @author Elisabeth Eckstdt
 */
public class Schraubenverdichter extends KoKM{

	/**
	 * reicht Parameter durch
	 * @param name
	 * @param rk
	 * @param teillastregelung
	 */
	public Schraubenverdichter(String name, Rueckkuehler rk, String teillastregelung) {
		super(name, rk, teillastregelung);
	}

	/**
	 * ermittelt epsilon aus Vorlauftemp<p>
	 * ruft KoKM.init()
	 * @param Nennleistung
	 * @param t_K_A
	 */
	public void init(double Nennleistung, double t_K_A)
	{
		super.init(Nennleistung);
		//epsilon nach DIN
		double epsilon_6; 
		double epsilon_14;
		if (Rueckkuehler instanceof Verdunstungsrueckkuehler)
		{
			epsilon_6 = 4.5;
			epsilon_14 = 5.3;
		}
		else //Trockenrueckkuehler
		{
			epsilon_6 = 2.9;
			epsilon_14 = 3.7;
		}
		EER = Helper.ggl_2pkt(t_K_A, 6, epsilon_6, 14, epsilon_14);
	}
	
	public String getBauteilart()
	{
		return "Schraubenverdichter";
	}
}
