package de.elisabetheckstaedt.dipl.real;

import de.elisabetheckstaedt.dipl.common.Helper;

/**
 * reprsentiert Turboverdichter
 * @author Elisabeth Eckstdt
 */
public class Turboverdichter extends KoKM {

	/**
	 * @param name
	 * @param rk
	 * @param teillastregelung
	 */
	public Turboverdichter (String name, Rueckkuehler rk, String teillastregelung)
	{
		super(name, rk, teillastregelung);
	}

	/**
	 * setzt epsilon nach DIN entsprechend Vorlauftemp<p>
	 * ruft KoKM.init()
	 * @param Nennleistung
	 * @param t_K_A
	 */
	public void init(double Nennleistung, double t_K_A)
	{
		super.init(Nennleistung);
		//epsilon nach DIN
		double epsilon_6; 
		double epsilon_14;
		if (Rueckkuehler instanceof Verdunstungsrueckkuehler)
		{
			epsilon_6 = 5.2;
			epsilon_14 = 5.9;
		}
		else //Trockenrueckkuehler
		{
			epsilon_6 = 4.1;
			epsilon_14 = 4.8;
		}
		EER = Helper.ggl_2pkt(t_K_A, 6, epsilon_6, 14, epsilon_14);
	}
	
	public String getBauteilart()
	{
		return "Turboverdichter";
	}
}
