package de.elisabetheckstaedt.dipl.real;

/**
 * Verbraucher deren Kltelast sich ber Sttzstellen bestimmt
 * @author Elisabeth Eckstdt
 */
public class Verbraucher_e extends Verbraucher {

	/**
	 * 3x aufsteigend sortiert[C]
	 */
	private double[] Stuetztemperaturen;
	/**
	 * 3x nach austeigenden Temperaturen sortiert [kW]
	 */
	private double[] Stuetzleistungen;
	
	/**
	 * @param name
	 * @param ort
	 * @param vorlauftemperatur
	 * @param Stuetztemperaturen
	 * @param Stuetzleistungen
	 */
	public Verbraucher_e(String name, double[] ort, double vorlauftemperatur, double[] Stuetztemperaturen, double[] Stuetzleistungen) {
		super(name, ort, vorlauftemperatur);
		this.Stuetztemperaturen = Stuetztemperaturen;
		this.Stuetzleistungen = Stuetzleistungen;
	}

	/**
	 * realisiert die abschnittsweise definierte Gerade
	 * @param Aussentemperatur
	 * @return Klteleistung [8760]
	 */
	public double[] Kaelteleistung(double[] Aussentemperatur) {
		double[] Kaelteleistung = new double[8760];
		for (int i=0; i<8760; i++)
		{
			if (Aussentemperatur[i] < Stuetztemperaturen[0])
				Kaelteleistung[i] = Stuetzleistungen[0];
			else if (Aussentemperatur[i] < Stuetztemperaturen[1])
			{
				double xa = Stuetztemperaturen[0];
				double xb = Stuetztemperaturen[1];
				double ya = Stuetzleistungen[0];
				double yb = Stuetzleistungen[1];
				Kaelteleistung[i] = (Aussentemperatur[i]-xa)*(yb-ya)/(xb-xa) + ya;
			}
			else if (Aussentemperatur[i] < Stuetztemperaturen[2])
			{
				double xa = Stuetztemperaturen[1];
				double xb = Stuetztemperaturen[2];
				double ya = Stuetzleistungen[1];
				double yb = Stuetzleistungen[2];
				Kaelteleistung[i] = (Aussentemperatur[i]-xa)*(yb-ya)/(xb-xa) + ya;
			}
			else
				Kaelteleistung[i] = Stuetzleistungen[2];
		}
		return Kaelteleistung;
	}

	public String toASCII() {
		String Speichern = "Name: " + Name + " \n" +
		"Ort: " + Ort[0] + " " + Ort[1] + " \n" +
		"Vorlauftemperatur: " + Vorlauftemperatur + " \n" +
		"Stuetzstelle 1: " + Stuetztemperaturen[0] + " " + Stuetzleistungen[0] + " \n" +
		"Stuetzstelle 2: " + Stuetztemperaturen[1] + " " + Stuetzleistungen[1] + " \n" +
		"Stuetzstelle 3: " + Stuetztemperaturen[2] + " " + Stuetzleistungen[2] + " \n" ;
		return Speichern;
	}

}
