package net.tinyos.matlab;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;


// to test server alone, start command prompt and type:
// %  telnet localhost 4444
// send it requests as if it were clientRequest
// alternatively, use MatClient.java and testClient.java 
public class MatServer 
{
  MatlabControl mc = new MatlabControl(); 
  boolean listening = true;

  public void body() throws IOException {
    
//	System.out.println("entering body"); 
	class Caller extends Thread {
      public void run()
      {
//    	  System.out.println("entering caller thread");
        try 
        {
          body2();
        }
        catch( IOException e ) { e.printStackTrace(); }
      }
      public void body2()  throws IOException
      {
//    	System.out.println("entering caller thread body (body2)");
        ServerSocket serverSocket = null;
        try
        {
//          System.out.println("creating socket");
          serverSocket = new ServerSocket( 4444 ); 
        }
        catch( IOException e ) { e.printStackTrace(); System.exit(1); }
    
        while( listening )
        {
//        	System.out.println("entering caller thread main loop - waiting for connections");
        	new workerThreadRMI( serverSocket.accept() ).run();
        	
        }
//        System.out.println("left caller thread main loop - closing server socket");
        serverSocket.close();
      } // end_run
    } // end_caller
    
    Caller c = new Caller();
    c.start();
  }

  public class workerThreadRMI
  {
	  private Socket socket = null;
	  public workerThreadRMI(Socket socket) { 
//		  System.out.println("entering worker thread constructor");
		  this.socket = socket; }
	  boolean end = false;
	  
	  public void run()
	  {
//		  System.out.println("entering worker thread");
		  try {
			ObjectOutputStream os = new ObjectOutputStream(socket.getOutputStream());
			ObjectInputStream is = new ObjectInputStream(socket.getInputStream());
			
//			while(!end) {
//				System.out.println("entering worker thread main loop - trying to read object");
//				while (is.available() <= 0){
//					Thread.sleep(100);
//				}
			System.out.println("trying to read object");
				Object call[] = (Object[]) is.readObject();
				String command = (String)call[0];
//				System.out.println("processing command: " + command);
				if("bye".equals(command)) {
//					System.out.println("end command received - shutting down");
//					end = true;
					listening = false;
//					break;
				} else {
//					System.out.println("matlab method call...");
					Object ret = mc.blockingFeval(command, (Object[])call[1]);
//					if(ret != null)
////						System.out.println("sending result: " + ret.toString());
//					else System.out.println("sending result: <null>");
					os.writeObject(ret);
				}				
//			}
//			System.out.println("closing object streams");
			os.close();
			is.close();
//			System.out.println("closing worker socket");
			socket.close();
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	  }
  }
  
}// end_MatServer_class
